#include <jni.h>
#include "jp_ne_so_0005fnet_ga2_no_0005fji_jcom_Com.h"
#include "atlbase.h"
#include "atlconv.h"
#include <stdio.h>
#include "jcom.h"

void ThrowComFail(JNIEnv *env, const char* desc, jint hr)
{
  jclass failClass = env->FindClass("jp/ne/so_net/ga2/no_ji/jcom/JComException	");
  // call the constructor that takes hr and message
  jmethodID failCons = 
     env->GetMethodID(failClass, "<init>", "(ILjava/lang/String;)V");
  if (!desc) desc = "Java/COM Error";
  jstring js = env->NewStringUTF(desc);
  jthrowable fail = (jthrowable)env->NewObject(failClass, failCons, hr, js);
  env->Throw(fail);
}


/* **********************************************************************
 * Class:     jp_ne_so_0005fnet_ga2_no_0005fji_jcom_Com
 * Method:    _CLSIDFromProgID
 * Signature: (Ljava/lang/String;)Ljp/ne/so_net/ga2/no_ji/jcom/GUID;
 * **********************************************************************/
JNIEXPORT jobject JNICALL Java_jp_ne_so_1net_ga2_no_1ji_jcom_Com__1CLSIDFromProgID
  (JNIEnv *env, jclass , jstring progid)
{
	BSTR bstrProgID = jstring2BSTR(env, progid);
	CLSID clsid;
	HRESULT hr = CLSIDFromProgID(bstrProgID, &clsid);
	SysFreeString(bstrProgID);
	if(FAILED(hr)) return NULL;		// ȂNULLԂ
	return GUID2jobject(env, &clsid);
}


/* **********************************************************************
 * Class:     jp_ne_so_0005fnet_ga2_no_0005fji_jcom_Com
 * Method:    _ProgIDFromCLSID
 * Signature: (Ljp/ne/so_net/ga2/no_ji/jcom/GUID;)Ljava/lang/String;
 * **********************************************************************/
JNIEXPORT jstring JNICALL Java_jp_ne_so_1net_ga2_no_1ji_jcom_Com__1ProgIDFromCLSID
  (JNIEnv *env, jclass , jobject jclsid)
{
USES_CONVERSION;
	if(jclsid==NULL) return NULL;
	CLSID clsid;
	jobject2GUID(env, jclsid, &clsid);
/*
	BSTR bstrProgID;
	ProgIDFromCLSID(clsid, &bstrProgID); 
print_BSTR(bstrProgID);
	jstring jProgID = BSTR2jstring(env, bstrProgID);
	SysFreeString(bstrProgID);
*/
	LPOLESTR lpsz;
	ProgIDFromCLSID(clsid, &lpsz);	// NOT BSTR!!!
//for(int i=0; i<20; i++) {
//	printf("%02X ", lpsz[i]);
//}
	BSTR bstrProgID = OLE2BSTR(lpsz);
	jstring jProgID = BSTR2jstring(env, bstrProgID);
	SysFreeString(bstrProgID);
	CoTaskMemFree(lpsz);

	return jProgID;
}




/* **********************************************************************
 * Class:     jp_ne_so_0005fnet_ga2_no_0005fji_jcom_Com
 * Method:    StringFromIID
 * Signature: (Ljp/ne/so_net/ga2/no_ji/jcom/GUID;)Ljava/lang/String;
 	gpBłJava GUIDŎς
 * **********************************************************************/
JNIEXPORT jstring JNICALL Java_jp_ne_so_1net_ga2_no_1ji_jcom_Com_StringFromIID
  (JNIEnv *env, jclass , jobject iid)
{
	// IID擾
	GUID IID;
	jobject2GUID(env, iid, &IID);
	// IIDProgID擾
	BSTR bstrString = NULL;
	HRESULT hr = StringFromIID(IID, &bstrString);
	if(FAILED(hr)) {
		printf("hr=%Xh \n", hr);
		return (jstring)NULL;
	}
	// BSTRjstringɕϊ
	jstring jString = BSTR2jstring(env, bstrString);
	SysFreeString(bstrString);
	return jString;
}

/*
 * Class:     jp_ne_so_0005fnet_ga2_no_0005fji_jcom_Com
 * Method:    _getIDsOfNames
 * Signature: (Ljava/lang/String;[Ljava/lang/String;)[I
 */
JNIEXPORT jintArray JNICALL Java_jp_ne_so_1net_ga2_no_1ji_jcom_Com__1getIDsOfNames__Ljava_lang_String_2_3Ljava_lang_String_2
  (JNIEnv *env, jclass , jstring guid, jobjectArray names)
{
  IDispatch *pIDispatch;
  IUnknown *punk = NULL;
  CLSID clsid;
  BSTR	bsProgId = jstring2BSTR(env,guid);

  // Now, try to find an IDispatch interface for progid
  HRESULT hr = CLSIDFromString(bsProgId, &clsid);
  if (FAILED(hr)) {
	ThrowComFail(env, "Can't get object clsid from clsidString", hr);
	return NULL;
  }
 // free(bsProgId);

  // standard creation
  hr = CoCreateInstance(clsid,NULL,CLSCTX_LOCAL_SERVER|CLSCTX_INPROC_SERVER,IID_IUnknown, (void **)&punk);
  if (!SUCCEEDED(hr)) {
     ThrowComFail(env, "Can't co-create object", hr);
     return NULL;
  }

  // now get an IDispatch pointer from the IUnknown
  hr = punk->QueryInterface(IID_IDispatch, (void **)&pIDispatch);
  if (!SUCCEEDED(hr)) {
    ThrowComFail(env, "Can't QI object for IDispatch", hr);
    return NULL;;
  }
  // CoCreateInstance called AddRef
  punk->Release();
  if (!pIDispatch) return NULL;

  int l = env->GetArrayLength(names);
  int i;
  LPOLESTR *lps = (LPOLESTR *)CoTaskMemAlloc(l * sizeof(LPOLESTR));
  DISPID *dispid = (DISPID *)CoTaskMemAlloc(l * sizeof(DISPID));
  for(i=0;i<l;i++) 
  {
    USES_CONVERSION;
    jstring s = (jstring)env->GetObjectArrayElement(names, i);
    const char *nm = env->GetStringUTFChars(s, NULL);
    LPOLESTR nmos = A2W(nm);
    lps[i] = nmos;
  }
  hr = pIDispatch->GetIDsOfNames(IID_NULL,lps,l,GetUserDefaultLCID(),dispid);
  if (FAILED(hr)) {
    CoTaskMemFree(lps);
    CoTaskMemFree(dispid);
    ThrowComFail(env, "Can't map name to dispid", hr);
	pIDispatch->Release();
    return NULL;
  }
  jintArray iarr = env->NewIntArray(l);
  env->SetIntArrayRegion(iarr, i, l, dispid);
  CoTaskMemFree(lps);
  CoTaskMemFree(dispid);
  pIDispatch->Release();
  return iarr;
}

