package com.lordjoe.utilities;
import java.util.*;

/**
* enumarated type integer values
*/
public abstract class EnumeratedInt extends EnumeratedType
{
      private final Integer m_test;
    
    protected EnumeratedInt(String name,Integer value) 
    {
        super(name);
        m_test = value;
        rememberValue();
    }
    
    protected EnumeratedInt(String name,int value) 
    {
        this(name,new Integer(value));
    }
    
    
    
    protected EnumeratedInt getEnumeratedIntByValue(int value) 
    {
        return((EnumeratedInt)getEnumeratedTypeByValue(new Integer(value)));
    }
    
    /**
    * return the class of the object held by the 
    * type 
    * @return non-null class
    */
    public Class getEnumeratedClass()
    { 
        return(Integer.class);
    }
    
          
    /**
    * return the data underlying the enumeration
    * @return non-null class
    */
    public Object getEnumeratedData()
    {
        return(m_test);
    }
      
          
    /**
    * return the data underlying the enumeration
    * @return non-null class
    */
    public Integer getEnumeratedInteger()
    {
        return((Integer)getEnumeratedData());
    }
          
    /**
    * return the data underlying the enumeration
    * @return non-null class
    */
    public int getValue()
    {
        return(getEnumeratedInteger().intValue());
    }
    
    public boolean equals(Object test)
    {
        if(getClass() != test.getClass())
            return(false);
        return(((EnumeratedInt)test).getValue() == getValue());
    }
    
    public int hashCode()
    {
        return(getValue());
    }
}
