package com.lordjoe.utilities;
import java.io.*;
/** 
* Wraps another exception in a runtime exception
  Updated to make it compile on Java 1.5
  Miika Nurminen
  
    @date> Fri 5. May 2006
    @version> 1.1
* @author Steve Lewis
*/
public class WrapperException extends RuntimeException implements IWrappedException
{
    private Throwable m_Wrapped;
    
    public WrapperException(Throwable ex)  {
       setCause(ex);
    }
     public WrapperException(String s,Throwable ex)  {
        super(s);
       setCause(ex);
    }
   
    public void setCause(Throwable ex) {
        if(ex == null)
            throw new IllegalArgumentException("WrapperException does not take null");
        if(ex.equals(this))
            throw new IllegalArgumentException("WrapperException does not take itself");
        
         m_Wrapped = ex;
    }
/*    
    public String getStackTrace() {
        Throwable cause = getCause();
        if(cause != null) {
            if(cause instanceof IWrappedException) {
                return(((IWrappedException)cause).getStackTrace());
            }
            else {
                return(Util.getStackTrace(getCause()));
            }
        }
        else
            return(Util.getStackTrace(this));
    }
    */
    public Throwable getCause() {
        return(m_Wrapped);
    }
    
    public Throwable getWrapped() {
        return(m_Wrapped);
    }
    
    public Throwable getRealWrapped() {
        Throwable wrapped = getWrapped();
        while(wrapped instanceof java.lang.reflect.InvocationTargetException)
            wrapped = ((java.lang.reflect.InvocationTargetException)wrapped).getTargetException();
        while(wrapped instanceof java.rmi.RemoteException){
            Throwable detail = ((java.rmi.RemoteException)wrapped).detail;
            if(detail == null || detail == wrapped)
                break;
            wrapped = detail;
        }
        
        return(wrapped);
    }
    
    public String getMessage() {
        String Message = "Wrapped exception - " + getWrapped().getMessage();
        return(Message);
    }
    
    public void printStackTrace(PrintWriter s)
    {
        s.println("Wrapped exception - " + getWrapped().getMessage());
        Throwable wrapped = getRealWrapped();
        wrapped.printStackTrace(s);
    }
    
    public void printStackTrace(PrintStream s)
    {
        s.println("Wrapped exception - " + getWrapped().getMessage());
        Throwable wrapped = getRealWrapped();
        wrapped.printStackTrace(s);
    }
    
    public void printStackTrace()
    {
        printStackTrace(System.out);
    }
}
