package com.microsoft.excel.gen;
import com.microsoft.excel.*;
import com.microsoft.excel.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object FreeformBuilder
* DO NOT EDIT THIS CODE 
* EDIT the subclass FreeformBuilder
* @author S Lewis
*/
public class _FreeformBuilder extends WDispatch
{
    public static final String clsid = "{0002443F-0000-0000-C000-000000000046}";
    protected static Map gParamHashAddNodes;
    // Static initializer
    // Used to initialize Hash Tables for named parameters
    static {
        gParamHashAddNodes = new HashMap();
        gParamHashAddNodes.put("SegmentType",new Integer(0));
        gParamHashAddNodes.put("EditingType",new Integer(1));
        gParamHashAddNodes.put("X1",new Integer(2));
        gParamHashAddNodes.put("Y1",new Integer(3));
        gParamHashAddNodes.put("X2",new Integer(4));
        gParamHashAddNodes.put("Y2",new Integer(5));
        gParamHashAddNodes.put("X3",new Integer(6));
        gParamHashAddNodes.put("Y3",new Integer(7));

    }
    /**
    * default constructor
    */
    public _FreeformBuilder()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _FreeformBuilder(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _FreeformBuilder(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,148,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return XlCreatorEnum
    */
    public XlCreatorEnum getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,149,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        XlCreatorEnum ret = XlCreatorEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,150,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @param SegmentTypeintRealType - MsoSegmentType
    * @param EditingTypeintRealType - MsoEditingType
    * @param X1float
    * @param Y1float
    * @param X2Object
    * @param Y2Object
    * @param X3Object
    * @param Y3Object
    * @param SegmentTypeintRealType - MsoSegmentType
    * @param EditingTypeintRealType - MsoEditingType
    * @param X1float
    * @param Y1float
    * @param X2Object
    * @param Y2Object
    * @param X3Object
    * @param Y3Object
    */
    public void AddNodes(int SegmentType,int EditingType,float X1,float Y1,Object X2,Object Y2,Object X3,Object Y3)
    {
        Variant[] args = {new Variant(SegmentType),new Variant(EditingType),new Variant(X1),new Variant(Y1),new Variant(X2),new Variant(Y2),new Variant(X3),new Variant(Y3)};
        invoke_method_void(args,1762,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void AddNodes(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashAddNodes.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,1762,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param SegmentTypeintRealType - MsoSegmentType
    * @param EditingTypeintRealType - MsoEditingType
    * @param X1float
    * @param Y1float
    * @param X2Object
    * @param Y2Object
    * @param X3Object
    * @param SegmentTypeintRealType - MsoSegmentType
    * @param EditingTypeintRealType - MsoEditingType
    * @param X1float
    * @param Y1float
    * @param X2Object
    * @param Y2Object
    * @param X3Object
    */
    public void AddNodes(int SegmentType,int EditingType,float X1,float Y1,Object X2,Object Y2,Object X3)
    {
        Variant[] args = {new Variant(SegmentType),new Variant(EditingType),new Variant(X1),new Variant(Y1),new Variant(X2),new Variant(Y2),new Variant(X3)};
        invoke_method_void(args,1762,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param SegmentTypeintRealType - MsoSegmentType
    * @param EditingTypeintRealType - MsoEditingType
    * @param X1float
    * @param Y1float
    * @param X2Object
    * @param Y2Object
    * @param SegmentTypeintRealType - MsoSegmentType
    * @param EditingTypeintRealType - MsoEditingType
    * @param X1float
    * @param Y1float
    * @param X2Object
    * @param Y2Object
    */
    public void AddNodes(int SegmentType,int EditingType,float X1,float Y1,Object X2,Object Y2)
    {
        Variant[] args = {new Variant(SegmentType),new Variant(EditingType),new Variant(X1),new Variant(Y1),new Variant(X2),new Variant(Y2)};
        invoke_method_void(args,1762,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param SegmentTypeintRealType - MsoSegmentType
    * @param EditingTypeintRealType - MsoEditingType
    * @param X1float
    * @param Y1float
    * @param X2Object
    * @param SegmentTypeintRealType - MsoSegmentType
    * @param EditingTypeintRealType - MsoEditingType
    * @param X1float
    * @param Y1float
    * @param X2Object
    */
    public void AddNodes(int SegmentType,int EditingType,float X1,float Y1,Object X2)
    {
        Variant[] args = {new Variant(SegmentType),new Variant(EditingType),new Variant(X1),new Variant(Y1),new Variant(X2)};
        invoke_method_void(args,1762,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param SegmentTypeintRealType - MsoSegmentType
    * @param EditingTypeintRealType - MsoEditingType
    * @param X1float
    * @param Y1float
    * @param SegmentTypeintRealType - MsoSegmentType
    * @param EditingTypeintRealType - MsoEditingType
    * @param X1float
    * @param Y1float
    */
    public void AddNodes(int SegmentType,int EditingType,float X1,float Y1)
    {
        Variant[] args = {new Variant(SegmentType),new Variant(EditingType),new Variant(X1),new Variant(Y1)};
        invoke_method_void(args,1762,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @return Shape
    */
    public Shape ConvertToShape()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1766,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

}
