package com.microsoft.excel.gen;
import com.microsoft.excel.*;
import com.microsoft.excel.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object PageSetup
* DO NOT EDIT THIS CODE 
* EDIT the subclass PageSetup
* @author S Lewis
*/
public class _PageSetup extends WDispatch
{
    public static final String clsid = "{000208B4-0000-0000-C000-000000000046}";
    /**
    * default constructor
    */
    public _PageSetup()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _PageSetup(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _PageSetup(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,148,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return XlCreatorEnum
    */
    public XlCreatorEnum getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,149,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        XlCreatorEnum ret = XlCreatorEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,150,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getBlackAndWhite()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1009,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setBlackAndWhite(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1009,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return double
    */
    public double getBottomMargin()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1002,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        double ret = retVar.toDouble();
        return(ret);
    }

    /**
    * @param arg1double
    * @param arg1double
    */
    public void setBottomMargin(double arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1002,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getCenterFooter()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1010,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setCenterFooter(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1010,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getCenterHeader()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1011,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setCenterHeader(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1011,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getCenterHorizontally()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1005,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setCenterHorizontally(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1005,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getCenterVertically()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1006,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setCenterVertically(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1006,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return XlObjectSizeEnum
    */
    public XlObjectSizeEnum getChartSize()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1012,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        XlObjectSizeEnum ret = XlObjectSizeEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1XlObjectSizeEnum
    * @param arg1XlObjectSizeEnum
    */
    public void setChartSize(XlObjectSizeEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,1012,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getDraft()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1020,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setDraft(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1020,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getFirstPageNumber()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1008,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setFirstPageNumber(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1008,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Object
    */
    public Object ambig_getFitToPagesTall()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1013,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param arg1Object
    * @param arg1Object
    */
    public void setFitToPagesTall(Object arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1013,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Object
    */
    public Object ambig_getFitToPagesWide()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1014,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param arg1Object
    * @param arg1Object
    */
    public void setFitToPagesWide(Object arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1014,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return double
    */
    public double getFooterMargin()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1015,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        double ret = retVar.toDouble();
        return(ret);
    }

    /**
    * @param arg1double
    * @param arg1double
    */
    public void setFooterMargin(double arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1015,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return double
    */
    public double getHeaderMargin()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1016,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        double ret = retVar.toDouble();
        return(ret);
    }

    /**
    * @param arg1double
    * @param arg1double
    */
    public void setHeaderMargin(double arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1016,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getLeftFooter()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1017,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setLeftFooter(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1017,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getLeftHeader()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1018,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setLeftHeader(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1018,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return double
    */
    public double getLeftMargin()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,999,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        double ret = retVar.toDouble();
        return(ret);
    }

    /**
    * @param arg1double
    * @param arg1double
    */
    public void setLeftMargin(double arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,999,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return XlOrderEnum
    */
    public XlOrderEnum getOrder()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,192,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        XlOrderEnum ret = XlOrderEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1XlOrderEnum
    * @param arg1XlOrderEnum
    */
    public void setOrder(XlOrderEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,192,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return XlPageOrientationEnum
    */
    public XlPageOrientationEnum getOrientation()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,134,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        XlPageOrientationEnum ret = XlPageOrientationEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1XlPageOrientationEnum
    * @param arg1XlPageOrientationEnum
    */
    public void setOrientation(XlPageOrientationEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,134,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return XlPaperSizeEnum
    */
    public XlPaperSizeEnum getPaperSize()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1007,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        XlPaperSizeEnum ret = XlPaperSizeEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1XlPaperSizeEnum
    * @param arg1XlPaperSizeEnum
    */
    public void setPaperSize(XlPaperSizeEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,1007,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getPrintArea()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1019,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setPrintArea(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1019,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getPrintGridlines()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1004,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setPrintGridlines(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1004,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getPrintHeadings()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1003,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setPrintHeadings(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1003,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getPrintNotes()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1021,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setPrintNotes(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1021,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param IndexObject
    * @param IndexObject
    * @return Object
    */
    public Object ambig_getPrintQuality(Object Index)
    {
        Variant[] args = {new Variant(Index)};
        Variant retVar = invoke_method(args,1022,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @return Object
    */
    public Object ambig_getPrintQuality()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1022,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param IndexObject
    * @param arg2Object
    * @param IndexObject
    * @param arg2Object
    */
    public void setPrintQuality(Object Index,Object arg2)
    {
        Variant[] args = {new Variant(Index),new Variant(arg2)};
        invoke_method_void(args,1022,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param arg1Object
    * @param arg1Object
    */
    public void setPrintQuality(Object arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1022,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getPrintTitleColumns()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1023,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setPrintTitleColumns(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1023,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getPrintTitleRows()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1024,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setPrintTitleRows(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1024,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getRightFooter()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1025,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setRightFooter(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1025,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getRightHeader()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1026,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setRightHeader(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1026,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return double
    */
    public double getRightMargin()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1000,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        double ret = retVar.toDouble();
        return(ret);
    }

    /**
    * @param arg1double
    * @param arg1double
    */
    public void setRightMargin(double arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1000,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return double
    */
    public double getTopMargin()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1001,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        double ret = retVar.toDouble();
        return(ret);
    }

    /**
    * @param arg1double
    * @param arg1double
    */
    public void setTopMargin(double arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1001,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Object
    */
    public Object ambig_getZoom()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,663,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param arg1Object
    * @param arg1Object
    */
    public void setZoom(Object arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,663,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return XlPrintLocationEnum
    */
    public XlPrintLocationEnum getPrintComments()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1524,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        XlPrintLocationEnum ret = XlPrintLocationEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1XlPrintLocationEnum
    * @param arg1XlPrintLocationEnum
    */
    public void setPrintComments(XlPrintLocationEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,1524,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

}
