package com.microsoft.excel.gen;
import com.microsoft.excel.*;
import com.microsoft.excel.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object PivotTable
* DO NOT EDIT THIS CODE 
* EDIT the subclass PivotTable
* @author S Lewis
*/
public class _PivotTable extends WDispatch
{
    public static final String clsid = "{00020872-0000-0000-C000-000000000046}";
    protected static Map gParamHashAddFields;
    protected static Map gParamHashPivotTableWizard;
    // Static initializer
    // Used to initialize Hash Tables for named parameters
    static {
        gParamHashAddFields = new HashMap();
        gParamHashAddFields.put("RowFields",new Integer(0));
        gParamHashAddFields.put("ColumnFields",new Integer(1));
        gParamHashAddFields.put("PageFields",new Integer(2));
        gParamHashAddFields.put("AddToTable",new Integer(3));

        gParamHashPivotTableWizard = new HashMap();
        gParamHashPivotTableWizard.put("SourceType",new Integer(0));
        gParamHashPivotTableWizard.put("SourceData",new Integer(1));
        gParamHashPivotTableWizard.put("TableDestination",new Integer(2));
        gParamHashPivotTableWizard.put("TableName",new Integer(3));
        gParamHashPivotTableWizard.put("RowGrand",new Integer(4));
        gParamHashPivotTableWizard.put("ColumnGrand",new Integer(5));
        gParamHashPivotTableWizard.put("SaveData",new Integer(6));
        gParamHashPivotTableWizard.put("HasAutoFormat",new Integer(7));
        gParamHashPivotTableWizard.put("AutoPage",new Integer(8));
        gParamHashPivotTableWizard.put("Reserved",new Integer(9));
        gParamHashPivotTableWizard.put("BackgroundQuery",new Integer(10));
        gParamHashPivotTableWizard.put("OptimizeCache",new Integer(11));
        gParamHashPivotTableWizard.put("PageFieldOrder",new Integer(12));
        gParamHashPivotTableWizard.put("PageFieldWrapCount",new Integer(13));
        gParamHashPivotTableWizard.put("ReadData",new Integer(14));
        gParamHashPivotTableWizard.put("Connection",new Integer(15));

    }
    /**
    * default constructor
    */
    public _PivotTable()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _PivotTable(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _PivotTable(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,148,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return XlCreatorEnum
    */
    public XlCreatorEnum getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,149,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        XlCreatorEnum ret = XlCreatorEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,150,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @param RowFieldsObject
    * @param ColumnFieldsObject
    * @param PageFieldsObject
    * @param AddToTableObject
    * @param RowFieldsObject
    * @param ColumnFieldsObject
    * @param PageFieldsObject
    * @param AddToTableObject
    * @return Object
    */
    public Object ambig_AddFields(Object RowFields,Object ColumnFields,Object PageFields,Object AddToTable)
    {
        Variant[] args = {new Variant(RowFields),new Variant(ColumnFields),new Variant(PageFields),new Variant(AddToTable)};
        Variant retVar = invoke_method(args,708,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return Object
    */
    public Object ambig_AddFields(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashAddFields.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,708,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param RowFieldsObject
    * @param ColumnFieldsObject
    * @param PageFieldsObject
    * @param RowFieldsObject
    * @param ColumnFieldsObject
    * @param PageFieldsObject
    * @return Object
    */
    public Object ambig_AddFields(Object RowFields,Object ColumnFields,Object PageFields)
    {
        Variant[] args = {new Variant(RowFields),new Variant(ColumnFields),new Variant(PageFields)};
        Variant retVar = invoke_method(args,708,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param RowFieldsObject
    * @param ColumnFieldsObject
    * @param RowFieldsObject
    * @param ColumnFieldsObject
    * @return Object
    */
    public Object ambig_AddFields(Object RowFields,Object ColumnFields)
    {
        Variant[] args = {new Variant(RowFields),new Variant(ColumnFields)};
        Variant retVar = invoke_method(args,708,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param RowFieldsObject
    * @param RowFieldsObject
    * @return Object
    */
    public Object ambig_AddFields(Object RowFields)
    {
        Variant[] args = {new Variant(RowFields)};
        Variant retVar = invoke_method(args,708,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @return Object
    */
    public Object ambig_AddFields()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,708,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param IndexObject
    * @param IndexObject
    * @return Dispatch
    */
    public Dispatch ambig_getColumnFields(Object Index)
    {
        Variant[] args = {new Variant(Index)};
        Variant retVar = invoke_method(args,713,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getColumnFields()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,713,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getColumnGrand()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,694,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setColumnGrand(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,694,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Range
    */
    public Range getColumnRange()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,702,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param PageFieldObject
    * @param PageFieldObject
    * @return Object
    */
    public Object ambig_ShowPages(Object PageField)
    {
        Variant[] args = {new Variant(PageField)};
        Variant retVar = invoke_method(args,706,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @return Object
    */
    public Object ambig_ShowPages()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,706,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @return Range
    */
    public Range getDataBodyRange()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,705,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param IndexObject
    * @param IndexObject
    * @return Dispatch
    */
    public Dispatch ambig_getDataFields(Object Index)
    {
        Variant[] args = {new Variant(Index)};
        Variant retVar = invoke_method(args,715,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getDataFields()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,715,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return Range
    */
    public Range getDataLabelRange()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,704,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return String
    */
    public String get_Default()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,0,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void set_Default(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,0,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getHasAutoFormat()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,695,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setHasAutoFormat(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,695,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param IndexObject
    * @param IndexObject
    * @return Dispatch
    */
    public Dispatch ambig_getHiddenFields(Object Index)
    {
        Variant[] args = {new Variant(Index)};
        Variant retVar = invoke_method(args,711,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getHiddenFields()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,711,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return String
    */
    public String getInnerDetail()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,698,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setInnerDetail(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,698,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getName()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,110,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setName(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,110,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param IndexObject
    * @param IndexObject
    * @return Dispatch
    */
    public Dispatch ambig_getPageFields(Object Index)
    {
        Variant[] args = {new Variant(Index)};
        Variant retVar = invoke_method(args,714,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getPageFields()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,714,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return Range
    */
    public Range getPageRange()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,703,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Range
    */
    public Range getPageRangeCells()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1482,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param IndexObject
    * @param IndexObject
    * @return Dispatch
    */
    public Dispatch ambig_PivotFields(Object Index)
    {
        Variant[] args = {new Variant(Index)};
        Variant retVar = invoke_method(args,718,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_PivotFields()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,718,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return java.util.Date
    */
    public java.util.Date getRefreshDate()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,696,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        java.util.Date ret = COMUtilities.fromVBDate(retVar.toDate()).getTime();
        return(ret);
    }

    /**
    * @return String
    */
    public String getRefreshName()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,697,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean RefreshTable()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,717,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param IndexObject
    * @param IndexObject
    * @return Dispatch
    */
    public Dispatch ambig_getRowFields(Object Index)
    {
        Variant[] args = {new Variant(Index)};
        Variant retVar = invoke_method(args,712,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getRowFields()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,712,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getRowGrand()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,693,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setRowGrand(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,693,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Range
    */
    public Range getRowRange()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,701,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getSaveData()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,692,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setSaveData(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,692,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Object
    */
    public Object ambig_getSourceData()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,686,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param arg1Object
    * @param arg1Object
    */
    public void setSourceData(Object arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,686,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Range
    */
    public Range getTableRange1()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,699,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Range
    */
    public Range getTableRange2()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,700,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return String
    */
    public String getValue()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,6,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setValue(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,6,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param IndexObject
    * @param IndexObject
    * @return Dispatch
    */
    public Dispatch ambig_getVisibleFields(Object Index)
    {
        Variant[] args = {new Variant(Index)};
        Variant retVar = invoke_method(args,710,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getVisibleFields()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,710,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return int
    */
    public int getCacheIndex()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1483,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setCacheIndex(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1483,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return CalculatedFields
    */
    public CalculatedFields CalculatedFields()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1484,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        CalculatedFields ret = new CalculatedFields(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getDisplayErrorString()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1485,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setDisplayErrorString(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1485,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getDisplayNullString()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1486,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setDisplayNullString(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1486,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getEnableDrilldown()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1487,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setEnableDrilldown(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1487,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getEnableFieldDialog()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1488,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setEnableFieldDialog(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1488,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getEnableWizard()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1489,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setEnableWizard(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1489,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getErrorString()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1490,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setErrorString(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1490,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param NameString
    * @param NameString
    * @return double
    */
    public double GetData(String Name)
    {
        Variant[] args = {new Variant(Name)};
        Variant retVar = invoke_method(args,1491,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        double ret = retVar.toDouble();
        return(ret);
    }

    /**
    */
    public void ListFormulas()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,1492,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @return boolean
    */
    public boolean getManualUpdate()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1493,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setManualUpdate(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1493,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getMergeLabels()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1494,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setMergeLabels(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1494,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getNullString()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1495,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setNullString(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1495,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return PivotCache
    */
    public PivotCache PivotCache()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1496,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        PivotCache ret = new PivotCache(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return PivotFormulas
    */
    public PivotFormulas getPivotFormulas()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1497,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        PivotFormulas ret = new PivotFormulas(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SourceTypeObject
    * @param SourceDataObject
    * @param TableDestinationObject
    * @param TableNameObject
    * @param RowGrandObject
    * @param ColumnGrandObject
    * @param SaveDataObject
    * @param HasAutoFormatObject
    * @param AutoPageObject
    * @param ReservedObject
    * @param BackgroundQueryObject
    * @param OptimizeCacheObject
    * @param PageFieldOrderObject
    * @param PageFieldWrapCountObject
    * @param ReadDataObject
    * @param ConnectionObject
    * @param SourceTypeObject
    * @param SourceDataObject
    * @param TableDestinationObject
    * @param TableNameObject
    * @param RowGrandObject
    * @param ColumnGrandObject
    * @param SaveDataObject
    * @param HasAutoFormatObject
    * @param AutoPageObject
    * @param ReservedObject
    * @param BackgroundQueryObject
    * @param OptimizeCacheObject
    * @param PageFieldOrderObject
    * @param PageFieldWrapCountObject
    * @param ReadDataObject
    * @param ConnectionObject
    */
    public void PivotTableWizard(Object SourceType,Object SourceData,Object TableDestination,Object TableName,Object RowGrand,Object ColumnGrand,Object SaveData,Object HasAutoFormat,Object AutoPage,Object Reserved,Object BackgroundQuery,Object OptimizeCache,Object PageFieldOrder,Object PageFieldWrapCount,Object ReadData,Object Connection)
    {
        Variant[] args = {new Variant(SourceType),new Variant(SourceData),new Variant(TableDestination),new Variant(TableName),new Variant(RowGrand),new Variant(ColumnGrand),new Variant(SaveData),new Variant(HasAutoFormat),new Variant(AutoPage),new Variant(Reserved),new Variant(BackgroundQuery),new Variant(OptimizeCache),new Variant(PageFieldOrder),new Variant(PageFieldWrapCount),new Variant(ReadData),new Variant(Connection)};
        invoke_method_void(args,684,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void PivotTableWizard(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashPivotTableWizard.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,684,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param SourceTypeObject
    * @param SourceDataObject
    * @param TableDestinationObject
    * @param TableNameObject
    * @param RowGrandObject
    * @param ColumnGrandObject
    * @param SaveDataObject
    * @param HasAutoFormatObject
    * @param AutoPageObject
    * @param ReservedObject
    * @param BackgroundQueryObject
    * @param OptimizeCacheObject
    * @param PageFieldOrderObject
    * @param PageFieldWrapCountObject
    * @param ReadDataObject
    * @param SourceTypeObject
    * @param SourceDataObject
    * @param TableDestinationObject
    * @param TableNameObject
    * @param RowGrandObject
    * @param ColumnGrandObject
    * @param SaveDataObject
    * @param HasAutoFormatObject
    * @param AutoPageObject
    * @param ReservedObject
    * @param BackgroundQueryObject
    * @param OptimizeCacheObject
    * @param PageFieldOrderObject
    * @param PageFieldWrapCountObject
    * @param ReadDataObject
    */
    public void PivotTableWizard(Object SourceType,Object SourceData,Object TableDestination,Object TableName,Object RowGrand,Object ColumnGrand,Object SaveData,Object HasAutoFormat,Object AutoPage,Object Reserved,Object BackgroundQuery,Object OptimizeCache,Object PageFieldOrder,Object PageFieldWrapCount,Object ReadData)
    {
        Variant[] args = {new Variant(SourceType),new Variant(SourceData),new Variant(TableDestination),new Variant(TableName),new Variant(RowGrand),new Variant(ColumnGrand),new Variant(SaveData),new Variant(HasAutoFormat),new Variant(AutoPage),new Variant(Reserved),new Variant(BackgroundQuery),new Variant(OptimizeCache),new Variant(PageFieldOrder),new Variant(PageFieldWrapCount),new Variant(ReadData)};
        invoke_method_void(args,684,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param SourceTypeObject
    * @param SourceDataObject
    * @param TableDestinationObject
    * @param TableNameObject
    * @param RowGrandObject
    * @param ColumnGrandObject
    * @param SaveDataObject
    * @param HasAutoFormatObject
    * @param AutoPageObject
    * @param ReservedObject
    * @param BackgroundQueryObject
    * @param OptimizeCacheObject
    * @param PageFieldOrderObject
    * @param PageFieldWrapCountObject
    * @param SourceTypeObject
    * @param SourceDataObject
    * @param TableDestinationObject
    * @param TableNameObject
    * @param RowGrandObject
    * @param ColumnGrandObject
    * @param SaveDataObject
    * @param HasAutoFormatObject
    * @param AutoPageObject
    * @param ReservedObject
    * @param BackgroundQueryObject
    * @param OptimizeCacheObject
    * @param PageFieldOrderObject
    * @param PageFieldWrapCountObject
    */
    public void PivotTableWizard(Object SourceType,Object SourceData,Object TableDestination,Object TableName,Object RowGrand,Object ColumnGrand,Object SaveData,Object HasAutoFormat,Object AutoPage,Object Reserved,Object BackgroundQuery,Object OptimizeCache,Object PageFieldOrder,Object PageFieldWrapCount)
    {
        Variant[] args = {new Variant(SourceType),new Variant(SourceData),new Variant(TableDestination),new Variant(TableName),new Variant(RowGrand),new Variant(ColumnGrand),new Variant(SaveData),new Variant(HasAutoFormat),new Variant(AutoPage),new Variant(Reserved),new Variant(BackgroundQuery),new Variant(OptimizeCache),new Variant(PageFieldOrder),new Variant(PageFieldWrapCount)};
        invoke_method_void(args,684,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param SourceTypeObject
    * @param SourceDataObject
    * @param TableDestinationObject
    * @param TableNameObject
    * @param RowGrandObject
    * @param ColumnGrandObject
    * @param SaveDataObject
    * @param HasAutoFormatObject
    * @param AutoPageObject
    * @param ReservedObject
    * @param BackgroundQueryObject
    * @param OptimizeCacheObject
    * @param PageFieldOrderObject
    * @param SourceTypeObject
    * @param SourceDataObject
    * @param TableDestinationObject
    * @param TableNameObject
    * @param RowGrandObject
    * @param ColumnGrandObject
    * @param SaveDataObject
    * @param HasAutoFormatObject
    * @param AutoPageObject
    * @param ReservedObject
    * @param BackgroundQueryObject
    * @param OptimizeCacheObject
    * @param PageFieldOrderObject
    */
    public void PivotTableWizard(Object SourceType,Object SourceData,Object TableDestination,Object TableName,Object RowGrand,Object ColumnGrand,Object SaveData,Object HasAutoFormat,Object AutoPage,Object Reserved,Object BackgroundQuery,Object OptimizeCache,Object PageFieldOrder)
    {
        Variant[] args = {new Variant(SourceType),new Variant(SourceData),new Variant(TableDestination),new Variant(TableName),new Variant(RowGrand),new Variant(ColumnGrand),new Variant(SaveData),new Variant(HasAutoFormat),new Variant(AutoPage),new Variant(Reserved),new Variant(BackgroundQuery),new Variant(OptimizeCache),new Variant(PageFieldOrder)};
        invoke_method_void(args,684,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param SourceTypeObject
    * @param SourceDataObject
    * @param TableDestinationObject
    * @param TableNameObject
    * @param RowGrandObject
    * @param ColumnGrandObject
    * @param SaveDataObject
    * @param HasAutoFormatObject
    * @param AutoPageObject
    * @param ReservedObject
    * @param BackgroundQueryObject
    * @param OptimizeCacheObject
    * @param SourceTypeObject
    * @param SourceDataObject
    * @param TableDestinationObject
    * @param TableNameObject
    * @param RowGrandObject
    * @param ColumnGrandObject
    * @param SaveDataObject
    * @param HasAutoFormatObject
    * @param AutoPageObject
    * @param ReservedObject
    * @param BackgroundQueryObject
    * @param OptimizeCacheObject
    */
    public void PivotTableWizard(Object SourceType,Object SourceData,Object TableDestination,Object TableName,Object RowGrand,Object ColumnGrand,Object SaveData,Object HasAutoFormat,Object AutoPage,Object Reserved,Object BackgroundQuery,Object OptimizeCache)
    {
        Variant[] args = {new Variant(SourceType),new Variant(SourceData),new Variant(TableDestination),new Variant(TableName),new Variant(RowGrand),new Variant(ColumnGrand),new Variant(SaveData),new Variant(HasAutoFormat),new Variant(AutoPage),new Variant(Reserved),new Variant(BackgroundQuery),new Variant(OptimizeCache)};
        invoke_method_void(args,684,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param SourceTypeObject
    * @param SourceDataObject
    * @param TableDestinationObject
    * @param TableNameObject
    * @param RowGrandObject
    * @param ColumnGrandObject
    * @param SaveDataObject
    * @param HasAutoFormatObject
    * @param AutoPageObject
    * @param ReservedObject
    * @param BackgroundQueryObject
    * @param SourceTypeObject
    * @param SourceDataObject
    * @param TableDestinationObject
    * @param TableNameObject
    * @param RowGrandObject
    * @param ColumnGrandObject
    * @param SaveDataObject
    * @param HasAutoFormatObject
    * @param AutoPageObject
    * @param ReservedObject
    * @param BackgroundQueryObject
    */
    public void PivotTableWizard(Object SourceType,Object SourceData,Object TableDestination,Object TableName,Object RowGrand,Object ColumnGrand,Object SaveData,Object HasAutoFormat,Object AutoPage,Object Reserved,Object BackgroundQuery)
    {
        Variant[] args = {new Variant(SourceType),new Variant(SourceData),new Variant(TableDestination),new Variant(TableName),new Variant(RowGrand),new Variant(ColumnGrand),new Variant(SaveData),new Variant(HasAutoFormat),new Variant(AutoPage),new Variant(Reserved),new Variant(BackgroundQuery)};
        invoke_method_void(args,684,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param SourceTypeObject
    * @param SourceDataObject
    * @param TableDestinationObject
    * @param TableNameObject
    * @param RowGrandObject
    * @param ColumnGrandObject
    * @param SaveDataObject
    * @param HasAutoFormatObject
    * @param AutoPageObject
    * @param ReservedObject
    * @param SourceTypeObject
    * @param SourceDataObject
    * @param TableDestinationObject
    * @param TableNameObject
    * @param RowGrandObject
    * @param ColumnGrandObject
    * @param SaveDataObject
    * @param HasAutoFormatObject
    * @param AutoPageObject
    * @param ReservedObject
    */
    public void PivotTableWizard(Object SourceType,Object SourceData,Object TableDestination,Object TableName,Object RowGrand,Object ColumnGrand,Object SaveData,Object HasAutoFormat,Object AutoPage,Object Reserved)
    {
        Variant[] args = {new Variant(SourceType),new Variant(SourceData),new Variant(TableDestination),new Variant(TableName),new Variant(RowGrand),new Variant(ColumnGrand),new Variant(SaveData),new Variant(HasAutoFormat),new Variant(AutoPage),new Variant(Reserved)};
        invoke_method_void(args,684,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param SourceTypeObject
    * @param SourceDataObject
    * @param TableDestinationObject
    * @param TableNameObject
    * @param RowGrandObject
    * @param ColumnGrandObject
    * @param SaveDataObject
    * @param HasAutoFormatObject
    * @param AutoPageObject
    * @param SourceTypeObject
    * @param SourceDataObject
    * @param TableDestinationObject
    * @param TableNameObject
    * @param RowGrandObject
    * @param ColumnGrandObject
    * @param SaveDataObject
    * @param HasAutoFormatObject
    * @param AutoPageObject
    */
    public void PivotTableWizard(Object SourceType,Object SourceData,Object TableDestination,Object TableName,Object RowGrand,Object ColumnGrand,Object SaveData,Object HasAutoFormat,Object AutoPage)
    {
        Variant[] args = {new Variant(SourceType),new Variant(SourceData),new Variant(TableDestination),new Variant(TableName),new Variant(RowGrand),new Variant(ColumnGrand),new Variant(SaveData),new Variant(HasAutoFormat),new Variant(AutoPage)};
        invoke_method_void(args,684,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param SourceTypeObject
    * @param SourceDataObject
    * @param TableDestinationObject
    * @param TableNameObject
    * @param RowGrandObject
    * @param ColumnGrandObject
    * @param SaveDataObject
    * @param HasAutoFormatObject
    * @param SourceTypeObject
    * @param SourceDataObject
    * @param TableDestinationObject
    * @param TableNameObject
    * @param RowGrandObject
    * @param ColumnGrandObject
    * @param SaveDataObject
    * @param HasAutoFormatObject
    */
    public void PivotTableWizard(Object SourceType,Object SourceData,Object TableDestination,Object TableName,Object RowGrand,Object ColumnGrand,Object SaveData,Object HasAutoFormat)
    {
        Variant[] args = {new Variant(SourceType),new Variant(SourceData),new Variant(TableDestination),new Variant(TableName),new Variant(RowGrand),new Variant(ColumnGrand),new Variant(SaveData),new Variant(HasAutoFormat)};
        invoke_method_void(args,684,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param SourceTypeObject
    * @param SourceDataObject
    * @param TableDestinationObject
    * @param TableNameObject
    * @param RowGrandObject
    * @param ColumnGrandObject
    * @param SaveDataObject
    * @param SourceTypeObject
    * @param SourceDataObject
    * @param TableDestinationObject
    * @param TableNameObject
    * @param RowGrandObject
    * @param ColumnGrandObject
    * @param SaveDataObject
    */
    public void PivotTableWizard(Object SourceType,Object SourceData,Object TableDestination,Object TableName,Object RowGrand,Object ColumnGrand,Object SaveData)
    {
        Variant[] args = {new Variant(SourceType),new Variant(SourceData),new Variant(TableDestination),new Variant(TableName),new Variant(RowGrand),new Variant(ColumnGrand),new Variant(SaveData)};
        invoke_method_void(args,684,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param SourceTypeObject
    * @param SourceDataObject
    * @param TableDestinationObject
    * @param TableNameObject
    * @param RowGrandObject
    * @param ColumnGrandObject
    * @param SourceTypeObject
    * @param SourceDataObject
    * @param TableDestinationObject
    * @param TableNameObject
    * @param RowGrandObject
    * @param ColumnGrandObject
    */
    public void PivotTableWizard(Object SourceType,Object SourceData,Object TableDestination,Object TableName,Object RowGrand,Object ColumnGrand)
    {
        Variant[] args = {new Variant(SourceType),new Variant(SourceData),new Variant(TableDestination),new Variant(TableName),new Variant(RowGrand),new Variant(ColumnGrand)};
        invoke_method_void(args,684,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param SourceTypeObject
    * @param SourceDataObject
    * @param TableDestinationObject
    * @param TableNameObject
    * @param RowGrandObject
    * @param SourceTypeObject
    * @param SourceDataObject
    * @param TableDestinationObject
    * @param TableNameObject
    * @param RowGrandObject
    */
    public void PivotTableWizard(Object SourceType,Object SourceData,Object TableDestination,Object TableName,Object RowGrand)
    {
        Variant[] args = {new Variant(SourceType),new Variant(SourceData),new Variant(TableDestination),new Variant(TableName),new Variant(RowGrand)};
        invoke_method_void(args,684,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param SourceTypeObject
    * @param SourceDataObject
    * @param TableDestinationObject
    * @param TableNameObject
    * @param SourceTypeObject
    * @param SourceDataObject
    * @param TableDestinationObject
    * @param TableNameObject
    */
    public void PivotTableWizard(Object SourceType,Object SourceData,Object TableDestination,Object TableName)
    {
        Variant[] args = {new Variant(SourceType),new Variant(SourceData),new Variant(TableDestination),new Variant(TableName)};
        invoke_method_void(args,684,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param SourceTypeObject
    * @param SourceDataObject
    * @param TableDestinationObject
    * @param SourceTypeObject
    * @param SourceDataObject
    * @param TableDestinationObject
    */
    public void PivotTableWizard(Object SourceType,Object SourceData,Object TableDestination)
    {
        Variant[] args = {new Variant(SourceType),new Variant(SourceData),new Variant(TableDestination)};
        invoke_method_void(args,684,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param SourceTypeObject
    * @param SourceDataObject
    * @param SourceTypeObject
    * @param SourceDataObject
    */
    public void PivotTableWizard(Object SourceType,Object SourceData)
    {
        Variant[] args = {new Variant(SourceType),new Variant(SourceData)};
        invoke_method_void(args,684,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param SourceTypeObject
    * @param SourceTypeObject
    */
    public void PivotTableWizard(Object SourceType)
    {
        Variant[] args = {new Variant(SourceType)};
        invoke_method_void(args,684,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void PivotTableWizard()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,684,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @return boolean
    */
    public boolean getSubtotalHiddenPageItems()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1498,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setSubtotalHiddenPageItems(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1498,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getPageFieldOrder()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1429,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setPageFieldOrder(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1429,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getPageFieldStyle()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1499,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setPageFieldStyle(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1499,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getPageFieldWrapCount()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1430,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setPageFieldWrapCount(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1430,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getPreserveFormatting()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1500,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setPreserveFormatting(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1500,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param NameString
    * @param ModeXlPTSelectionModeEnum
    * @param NameString
    * @param ModeXlPTSelectionModeEnum
    */
    public void PivotSelect(String Name,XlPTSelectionModeEnum Mode)
    {
        Variant[] args = {new Variant(Name),new Variant(Mode.getValue())};
        invoke_method_void(args,1501,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param NameString
    * @param NameString
    */
    public void PivotSelect(String Name)
    {
        Variant[] args = {new Variant(Name)};
        invoke_method_void(args,1501,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @return String
    */
    public String getPivotSelection()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1502,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setPivotSelection(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1502,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return XlPTSelectionModeEnum
    */
    public XlPTSelectionModeEnum getSelectionMode()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1503,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        XlPTSelectionModeEnum ret = XlPTSelectionModeEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1XlPTSelectionModeEnum
    * @param arg1XlPTSelectionModeEnum
    */
    public void setSelectionMode(XlPTSelectionModeEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,1503,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getTableStyle()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1504,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setTableStyle(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1504,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getTag()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1505,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setTag(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1505,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    */
    public void Update()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,680,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @return String
    */
    public String getVacatedStyle()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1506,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setVacatedStyle(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1506,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param FormatxlPivotFormatTypeEnum
    * @param FormatxlPivotFormatTypeEnum
    */
    public void Format(xlPivotFormatTypeEnum Format)
    {
        Variant[] args = {new Variant(Format.getValue())};
        invoke_method_void(args,116,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @return boolean
    */
    public boolean getPrintTitles()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1838,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setPrintTitles(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1838,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return CubeFields
    */
    public CubeFields getCubeFields()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1839,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        CubeFields ret = new CubeFields(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return String
    */
    public String getGrandTotalName()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1840,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setGrandTotalName(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1840,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getSmallGrid()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1841,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setSmallGrid(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1841,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getRepeatItemsOnEachPrintedPage()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1842,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setRepeatItemsOnEachPrintedPage(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1842,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getTotalsAnnotation()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1843,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setTotalsAnnotation(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1843,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

}
