package com.microsoft.excel.gen;
import com.microsoft.excel.*;
import com.microsoft.excel.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object PublishObjects
* DO NOT EDIT THIS CODE 
* EDIT the subclass PublishObjects
* @author S Lewis
*/
public class _PublishObjects extends WDispatch
{
    public static final String clsid = "{00024443-0000-0000-C000-000000000046}";
    protected static Map gParamHashAdd;
    // Static initializer
    // Used to initialize Hash Tables for named parameters
    static {
        gParamHashAdd = new HashMap();
        gParamHashAdd.put("SourceType",new Integer(0));
        gParamHashAdd.put("Filename",new Integer(1));
        gParamHashAdd.put("Sheet",new Integer(2));
        gParamHashAdd.put("Source",new Integer(3));
        gParamHashAdd.put("HtmlType",new Integer(4));
        gParamHashAdd.put("DivID",new Integer(5));
        gParamHashAdd.put("Title",new Integer(6));

    }
    /**
    * default constructor
    */
    public _PublishObjects()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _PublishObjects(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _PublishObjects(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,148,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return XlCreatorEnum
    */
    public XlCreatorEnum getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,149,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        XlCreatorEnum ret = XlCreatorEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,150,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @param SourceTypeXlSourceTypeEnum
    * @param FilenameString
    * @param SheetObject
    * @param SourceObject
    * @param HtmlTypeObject
    * @param DivIDObject
    * @param TitleObject
    * @param SourceTypeXlSourceTypeEnum
    * @param FilenameString
    * @param SheetObject
    * @param SourceObject
    * @param HtmlTypeObject
    * @param DivIDObject
    * @param TitleObject
    * @return PublishObject
    */
    public PublishObject Add(XlSourceTypeEnum SourceType,String Filename,Object Sheet,Object Source,Object HtmlType,Object DivID,Object Title)
    {
        Variant[] args = {new Variant(SourceType.getValue()),new Variant(Filename),new Variant(Sheet),new Variant(Source),new Variant(HtmlType),new Variant(DivID),new Variant(Title)};
        Variant retVar = invoke_method(args,181,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        PublishObject ret = new PublishObject(retVar.toDispatch());
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return PublishObject
    */
    public PublishObject Add(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashAdd.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,181,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        PublishObject ret = new PublishObject(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SourceTypeXlSourceTypeEnum
    * @param FilenameString
    * @param SheetObject
    * @param SourceObject
    * @param HtmlTypeObject
    * @param DivIDObject
    * @param SourceTypeXlSourceTypeEnum
    * @param FilenameString
    * @param SheetObject
    * @param SourceObject
    * @param HtmlTypeObject
    * @param DivIDObject
    * @return PublishObject
    */
    public PublishObject Add(XlSourceTypeEnum SourceType,String Filename,Object Sheet,Object Source,Object HtmlType,Object DivID)
    {
        Variant[] args = {new Variant(SourceType.getValue()),new Variant(Filename),new Variant(Sheet),new Variant(Source),new Variant(HtmlType),new Variant(DivID)};
        Variant retVar = invoke_method(args,181,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        PublishObject ret = new PublishObject(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SourceTypeXlSourceTypeEnum
    * @param FilenameString
    * @param SheetObject
    * @param SourceObject
    * @param HtmlTypeObject
    * @param SourceTypeXlSourceTypeEnum
    * @param FilenameString
    * @param SheetObject
    * @param SourceObject
    * @param HtmlTypeObject
    * @return PublishObject
    */
    public PublishObject Add(XlSourceTypeEnum SourceType,String Filename,Object Sheet,Object Source,Object HtmlType)
    {
        Variant[] args = {new Variant(SourceType.getValue()),new Variant(Filename),new Variant(Sheet),new Variant(Source),new Variant(HtmlType)};
        Variant retVar = invoke_method(args,181,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        PublishObject ret = new PublishObject(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SourceTypeXlSourceTypeEnum
    * @param FilenameString
    * @param SheetObject
    * @param SourceObject
    * @param SourceTypeXlSourceTypeEnum
    * @param FilenameString
    * @param SheetObject
    * @param SourceObject
    * @return PublishObject
    */
    public PublishObject Add(XlSourceTypeEnum SourceType,String Filename,Object Sheet,Object Source)
    {
        Variant[] args = {new Variant(SourceType.getValue()),new Variant(Filename),new Variant(Sheet),new Variant(Source)};
        Variant retVar = invoke_method(args,181,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        PublishObject ret = new PublishObject(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SourceTypeXlSourceTypeEnum
    * @param FilenameString
    * @param SheetObject
    * @param SourceTypeXlSourceTypeEnum
    * @param FilenameString
    * @param SheetObject
    * @return PublishObject
    */
    public PublishObject Add(XlSourceTypeEnum SourceType,String Filename,Object Sheet)
    {
        Variant[] args = {new Variant(SourceType.getValue()),new Variant(Filename),new Variant(Sheet)};
        Variant retVar = invoke_method(args,181,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        PublishObject ret = new PublishObject(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SourceTypeXlSourceTypeEnum
    * @param FilenameString
    * @param SourceTypeXlSourceTypeEnum
    * @param FilenameString
    * @return PublishObject
    */
    public PublishObject Add(XlSourceTypeEnum SourceType,String Filename)
    {
        Variant[] args = {new Variant(SourceType.getValue()),new Variant(Filename)};
        Variant retVar = invoke_method(args,181,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        PublishObject ret = new PublishObject(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCount()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,118,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param IndexObject
    * @param IndexObject
    * @return PublishObject
    */
    public PublishObject getItem(Object Index)
    {
        Variant[] args = {new Variant(Index)};
        Variant retVar = invoke_method(args,170,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        PublishObject ret = new PublishObject(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param IndexObject
    * @param IndexObject
    * @return PublishObject
    */
    public PublishObject get_Default(Object Index)
    {
        Variant[] args = {new Variant(Index)};
        Variant retVar = invoke_method(args,0,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        PublishObject ret = new PublishObject(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return IUnknown
    */
    public IUnknown ambig_get_NewEnum()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,-4,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        IUnknown ret = new IUnknown(retVar.toInt());
        return(ret);
    }

    /**
    */
    public void Delete()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,117,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void Publish()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,1895,DispatchConstants.DISPATCH_METHOD);
    }

}
