package com.microsoft.excel.gen;
import com.microsoft.excel.*;
import com.microsoft.excel.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object Shapes
* DO NOT EDIT THIS CODE 
* EDIT the subclass Shapes
* @author S Lewis
*/
public class _Shapes extends WDispatch
{
    public static final String clsid = "{0002443A-0000-0000-C000-000000000046}";
    protected static Map gParamHashAddOLEObject;
    // Static initializer
    // Used to initialize Hash Tables for named parameters
    static {
        gParamHashAddOLEObject = new HashMap();
        gParamHashAddOLEObject.put("ClassType",new Integer(0));
        gParamHashAddOLEObject.put("Filename",new Integer(1));
        gParamHashAddOLEObject.put("Link",new Integer(2));
        gParamHashAddOLEObject.put("DisplayAsIcon",new Integer(3));
        gParamHashAddOLEObject.put("IconFileName",new Integer(4));
        gParamHashAddOLEObject.put("IconIndex",new Integer(5));
        gParamHashAddOLEObject.put("IconLabel",new Integer(6));
        gParamHashAddOLEObject.put("Left",new Integer(7));
        gParamHashAddOLEObject.put("Top",new Integer(8));
        gParamHashAddOLEObject.put("Width",new Integer(9));
        gParamHashAddOLEObject.put("Height",new Integer(10));

    }
    /**
    * default constructor
    */
    public _Shapes()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _Shapes(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _Shapes(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,148,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return XlCreatorEnum
    */
    public XlCreatorEnum getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,149,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        XlCreatorEnum ret = XlCreatorEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,150,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return int
    */
    public int getCount()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,118,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param IndexObject
    * @param IndexObject
    * @return Shape
    */
    public Shape Item(Object Index)
    {
        Variant[] args = {new Variant(Index)};
        Variant retVar = invoke_method(args,170,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param IndexObject
    * @param IndexObject
    * @return Shape
    */
    public Shape _Default(Object Index)
    {
        Variant[] args = {new Variant(Index)};
        Variant retVar = invoke_method(args,0,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return IUnknown
    */
    public IUnknown ambig_get_NewEnum()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,-4,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        IUnknown ret = new IUnknown(retVar.toInt());
        return(ret);
    }

    /**
    * @param TypeintRealType - MsoCalloutType
    * @param Leftfloat
    * @param Topfloat
    * @param Widthfloat
    * @param Heightfloat
    * @param TypeintRealType - MsoCalloutType
    * @param Leftfloat
    * @param Topfloat
    * @param Widthfloat
    * @param Heightfloat
    * @return Shape
    */
    public Shape AddCallout(int Type,float Left,float Top,float Width,float Height)
    {
        Variant[] args = {new Variant(Type),new Variant(Left),new Variant(Top),new Variant(Width),new Variant(Height)};
        Variant retVar = invoke_method(args,1713,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param TypeintRealType - MsoConnectorType
    * @param BeginXfloat
    * @param BeginYfloat
    * @param EndXfloat
    * @param EndYfloat
    * @param TypeintRealType - MsoConnectorType
    * @param BeginXfloat
    * @param BeginYfloat
    * @param EndXfloat
    * @param EndYfloat
    * @return Shape
    */
    public Shape AddConnector(int Type,float BeginX,float BeginY,float EndX,float EndY)
    {
        Variant[] args = {new Variant(Type),new Variant(BeginX),new Variant(BeginY),new Variant(EndX),new Variant(EndY)};
        Variant retVar = invoke_method(args,1714,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SafeArrayOfPointsObject
    * @param SafeArrayOfPointsObject
    * @return Shape
    */
    public Shape AddCurve(Object SafeArrayOfPoints)
    {
        Variant[] args = {new Variant(SafeArrayOfPoints)};
        Variant retVar = invoke_method(args,1719,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param OrientationintRealType - MsoTextOrientation
    * @param Leftfloat
    * @param Topfloat
    * @param Widthfloat
    * @param Heightfloat
    * @param OrientationintRealType - MsoTextOrientation
    * @param Leftfloat
    * @param Topfloat
    * @param Widthfloat
    * @param Heightfloat
    * @return Shape
    */
    public Shape AddLabel(int Orientation,float Left,float Top,float Width,float Height)
    {
        Variant[] args = {new Variant(Orientation),new Variant(Left),new Variant(Top),new Variant(Width),new Variant(Height)};
        Variant retVar = invoke_method(args,1721,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param BeginXfloat
    * @param BeginYfloat
    * @param EndXfloat
    * @param EndYfloat
    * @param BeginXfloat
    * @param BeginYfloat
    * @param EndXfloat
    * @param EndYfloat
    * @return Shape
    */
    public Shape AddLine(float BeginX,float BeginY,float EndX,float EndY)
    {
        Variant[] args = {new Variant(BeginX),new Variant(BeginY),new Variant(EndX),new Variant(EndY)};
        Variant retVar = invoke_method(args,1722,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FilenameString
    * @param LinkToFileintRealType - MsoTriState
    * @param SaveWithDocumentintRealType - MsoTriState
    * @param Leftfloat
    * @param Topfloat
    * @param Widthfloat
    * @param Heightfloat
    * @param FilenameString
    * @param LinkToFileintRealType - MsoTriState
    * @param SaveWithDocumentintRealType - MsoTriState
    * @param Leftfloat
    * @param Topfloat
    * @param Widthfloat
    * @param Heightfloat
    * @return Shape
    */
    public Shape AddPicture(String Filename,int LinkToFile,int SaveWithDocument,float Left,float Top,float Width,float Height)
    {
        Variant[] args = {new Variant(Filename),new Variant(LinkToFile),new Variant(SaveWithDocument),new Variant(Left),new Variant(Top),new Variant(Width),new Variant(Height)};
        Variant retVar = invoke_method(args,1723,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SafeArrayOfPointsObject
    * @param SafeArrayOfPointsObject
    * @return Shape
    */
    public Shape AddPolyline(Object SafeArrayOfPoints)
    {
        Variant[] args = {new Variant(SafeArrayOfPoints)};
        Variant retVar = invoke_method(args,1726,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param TypeintRealType - MsoAutoShapeType
    * @param Leftfloat
    * @param Topfloat
    * @param Widthfloat
    * @param Heightfloat
    * @param TypeintRealType - MsoAutoShapeType
    * @param Leftfloat
    * @param Topfloat
    * @param Widthfloat
    * @param Heightfloat
    * @return Shape
    */
    public Shape AddShape(int Type,float Left,float Top,float Width,float Height)
    {
        Variant[] args = {new Variant(Type),new Variant(Left),new Variant(Top),new Variant(Width),new Variant(Height)};
        Variant retVar = invoke_method(args,1727,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param PresetTextEffectintRealType - MsoPresetTextEffect
    * @param TextString
    * @param FontNameString
    * @param FontSizefloat
    * @param FontBoldintRealType - MsoTriState
    * @param FontItalicintRealType - MsoTriState
    * @param Leftfloat
    * @param Topfloat
    * @param PresetTextEffectintRealType - MsoPresetTextEffect
    * @param TextString
    * @param FontNameString
    * @param FontSizefloat
    * @param FontBoldintRealType - MsoTriState
    * @param FontItalicintRealType - MsoTriState
    * @param Leftfloat
    * @param Topfloat
    * @return Shape
    */
    public Shape AddTextEffect(int PresetTextEffect,String Text,String FontName,float FontSize,int FontBold,int FontItalic,float Left,float Top)
    {
        Variant[] args = {new Variant(PresetTextEffect),new Variant(Text),new Variant(FontName),new Variant(FontSize),new Variant(FontBold),new Variant(FontItalic),new Variant(Left),new Variant(Top)};
        Variant retVar = invoke_method(args,1728,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param OrientationintRealType - MsoTextOrientation
    * @param Leftfloat
    * @param Topfloat
    * @param Widthfloat
    * @param Heightfloat
    * @param OrientationintRealType - MsoTextOrientation
    * @param Leftfloat
    * @param Topfloat
    * @param Widthfloat
    * @param Heightfloat
    * @return Shape
    */
    public Shape AddTextbox(int Orientation,float Left,float Top,float Width,float Height)
    {
        Variant[] args = {new Variant(Orientation),new Variant(Left),new Variant(Top),new Variant(Width),new Variant(Height)};
        Variant retVar = invoke_method(args,1734,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param EditingTypeintRealType - MsoEditingType
    * @param X1float
    * @param Y1float
    * @param EditingTypeintRealType - MsoEditingType
    * @param X1float
    * @param Y1float
    * @return FreeformBuilder
    */
    public FreeformBuilder BuildFreeform(int EditingType,float X1,float Y1)
    {
        Variant[] args = {new Variant(EditingType),new Variant(X1),new Variant(Y1)};
        Variant retVar = invoke_method(args,1735,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        FreeformBuilder ret = new FreeformBuilder(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param IndexObject
    * @param IndexObject
    * @return ShapeRange
    */
    public ShapeRange getRange(Object Index)
    {
        Variant[] args = {new Variant(Index)};
        Variant retVar = invoke_method(args,197,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        ShapeRange ret = new ShapeRange(retVar.toDispatch());
        return(ret);
    }

    /**
    */
    public void SelectAll()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,1737,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param TypeXlFormControlEnum
    * @param Leftint
    * @param Topint
    * @param Widthint
    * @param Heightint
    * @param TypeXlFormControlEnum
    * @param Leftint
    * @param Topint
    * @param Widthint
    * @param Heightint
    * @return Shape
    */
    public Shape AddFormControl(XlFormControlEnum Type,int Left,int Top,int Width,int Height)
    {
        Variant[] args = {new Variant(Type.getValue()),new Variant(Left),new Variant(Top),new Variant(Width),new Variant(Height)};
        Variant retVar = invoke_method(args,1738,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject
    * @param FilenameObject
    * @param LinkObject
    * @param DisplayAsIconObject
    * @param IconFileNameObject
    * @param IconIndexObject
    * @param IconLabelObject
    * @param LeftObject
    * @param TopObject
    * @param WidthObject
    * @param HeightObject
    * @param ClassTypeObject
    * @param FilenameObject
    * @param LinkObject
    * @param DisplayAsIconObject
    * @param IconFileNameObject
    * @param IconIndexObject
    * @param IconLabelObject
    * @param LeftObject
    * @param TopObject
    * @param WidthObject
    * @param HeightObject
    * @return Shape
    */
    public Shape AddOLEObject(Object ClassType,Object Filename,Object Link,Object DisplayAsIcon,Object IconFileName,Object IconIndex,Object IconLabel,Object Left,Object Top,Object Width,Object Height)
    {
        Variant[] args = {new Variant(ClassType),new Variant(Filename),new Variant(Link),new Variant(DisplayAsIcon),new Variant(IconFileName),new Variant(IconIndex),new Variant(IconLabel),new Variant(Left),new Variant(Top),new Variant(Width),new Variant(Height)};
        Variant retVar = invoke_method(args,1739,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return Shape
    */
    public Shape AddOLEObject(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashAddOLEObject.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,1739,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject
    * @param FilenameObject
    * @param LinkObject
    * @param DisplayAsIconObject
    * @param IconFileNameObject
    * @param IconIndexObject
    * @param IconLabelObject
    * @param LeftObject
    * @param TopObject
    * @param WidthObject
    * @param ClassTypeObject
    * @param FilenameObject
    * @param LinkObject
    * @param DisplayAsIconObject
    * @param IconFileNameObject
    * @param IconIndexObject
    * @param IconLabelObject
    * @param LeftObject
    * @param TopObject
    * @param WidthObject
    * @return Shape
    */
    public Shape AddOLEObject(Object ClassType,Object Filename,Object Link,Object DisplayAsIcon,Object IconFileName,Object IconIndex,Object IconLabel,Object Left,Object Top,Object Width)
    {
        Variant[] args = {new Variant(ClassType),new Variant(Filename),new Variant(Link),new Variant(DisplayAsIcon),new Variant(IconFileName),new Variant(IconIndex),new Variant(IconLabel),new Variant(Left),new Variant(Top),new Variant(Width)};
        Variant retVar = invoke_method(args,1739,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject
    * @param FilenameObject
    * @param LinkObject
    * @param DisplayAsIconObject
    * @param IconFileNameObject
    * @param IconIndexObject
    * @param IconLabelObject
    * @param LeftObject
    * @param TopObject
    * @param ClassTypeObject
    * @param FilenameObject
    * @param LinkObject
    * @param DisplayAsIconObject
    * @param IconFileNameObject
    * @param IconIndexObject
    * @param IconLabelObject
    * @param LeftObject
    * @param TopObject
    * @return Shape
    */
    public Shape AddOLEObject(Object ClassType,Object Filename,Object Link,Object DisplayAsIcon,Object IconFileName,Object IconIndex,Object IconLabel,Object Left,Object Top)
    {
        Variant[] args = {new Variant(ClassType),new Variant(Filename),new Variant(Link),new Variant(DisplayAsIcon),new Variant(IconFileName),new Variant(IconIndex),new Variant(IconLabel),new Variant(Left),new Variant(Top)};
        Variant retVar = invoke_method(args,1739,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject
    * @param FilenameObject
    * @param LinkObject
    * @param DisplayAsIconObject
    * @param IconFileNameObject
    * @param IconIndexObject
    * @param IconLabelObject
    * @param LeftObject
    * @param ClassTypeObject
    * @param FilenameObject
    * @param LinkObject
    * @param DisplayAsIconObject
    * @param IconFileNameObject
    * @param IconIndexObject
    * @param IconLabelObject
    * @param LeftObject
    * @return Shape
    */
    public Shape AddOLEObject(Object ClassType,Object Filename,Object Link,Object DisplayAsIcon,Object IconFileName,Object IconIndex,Object IconLabel,Object Left)
    {
        Variant[] args = {new Variant(ClassType),new Variant(Filename),new Variant(Link),new Variant(DisplayAsIcon),new Variant(IconFileName),new Variant(IconIndex),new Variant(IconLabel),new Variant(Left)};
        Variant retVar = invoke_method(args,1739,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject
    * @param FilenameObject
    * @param LinkObject
    * @param DisplayAsIconObject
    * @param IconFileNameObject
    * @param IconIndexObject
    * @param IconLabelObject
    * @param ClassTypeObject
    * @param FilenameObject
    * @param LinkObject
    * @param DisplayAsIconObject
    * @param IconFileNameObject
    * @param IconIndexObject
    * @param IconLabelObject
    * @return Shape
    */
    public Shape AddOLEObject(Object ClassType,Object Filename,Object Link,Object DisplayAsIcon,Object IconFileName,Object IconIndex,Object IconLabel)
    {
        Variant[] args = {new Variant(ClassType),new Variant(Filename),new Variant(Link),new Variant(DisplayAsIcon),new Variant(IconFileName),new Variant(IconIndex),new Variant(IconLabel)};
        Variant retVar = invoke_method(args,1739,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject
    * @param FilenameObject
    * @param LinkObject
    * @param DisplayAsIconObject
    * @param IconFileNameObject
    * @param IconIndexObject
    * @param ClassTypeObject
    * @param FilenameObject
    * @param LinkObject
    * @param DisplayAsIconObject
    * @param IconFileNameObject
    * @param IconIndexObject
    * @return Shape
    */
    public Shape AddOLEObject(Object ClassType,Object Filename,Object Link,Object DisplayAsIcon,Object IconFileName,Object IconIndex)
    {
        Variant[] args = {new Variant(ClassType),new Variant(Filename),new Variant(Link),new Variant(DisplayAsIcon),new Variant(IconFileName),new Variant(IconIndex)};
        Variant retVar = invoke_method(args,1739,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject
    * @param FilenameObject
    * @param LinkObject
    * @param DisplayAsIconObject
    * @param IconFileNameObject
    * @param ClassTypeObject
    * @param FilenameObject
    * @param LinkObject
    * @param DisplayAsIconObject
    * @param IconFileNameObject
    * @return Shape
    */
    public Shape AddOLEObject(Object ClassType,Object Filename,Object Link,Object DisplayAsIcon,Object IconFileName)
    {
        Variant[] args = {new Variant(ClassType),new Variant(Filename),new Variant(Link),new Variant(DisplayAsIcon),new Variant(IconFileName)};
        Variant retVar = invoke_method(args,1739,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject
    * @param FilenameObject
    * @param LinkObject
    * @param DisplayAsIconObject
    * @param ClassTypeObject
    * @param FilenameObject
    * @param LinkObject
    * @param DisplayAsIconObject
    * @return Shape
    */
    public Shape AddOLEObject(Object ClassType,Object Filename,Object Link,Object DisplayAsIcon)
    {
        Variant[] args = {new Variant(ClassType),new Variant(Filename),new Variant(Link),new Variant(DisplayAsIcon)};
        Variant retVar = invoke_method(args,1739,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject
    * @param FilenameObject
    * @param LinkObject
    * @param ClassTypeObject
    * @param FilenameObject
    * @param LinkObject
    * @return Shape
    */
    public Shape AddOLEObject(Object ClassType,Object Filename,Object Link)
    {
        Variant[] args = {new Variant(ClassType),new Variant(Filename),new Variant(Link)};
        Variant retVar = invoke_method(args,1739,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject
    * @param FilenameObject
    * @param ClassTypeObject
    * @param FilenameObject
    * @return Shape
    */
    public Shape AddOLEObject(Object ClassType,Object Filename)
    {
        Variant[] args = {new Variant(ClassType),new Variant(Filename)};
        Variant retVar = invoke_method(args,1739,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject
    * @param ClassTypeObject
    * @return Shape
    */
    public Shape AddOLEObject(Object ClassType)
    {
        Variant[] args = {new Variant(ClassType)};
        Variant retVar = invoke_method(args,1739,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Shape
    */
    public Shape AddOLEObject()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1739,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

}
