package com.microsoft.excel.gen;
import com.microsoft.excel.*;
import com.microsoft.excel.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object Window
* DO NOT EDIT THIS CODE 
* EDIT the subclass Window
* @author S Lewis
*/
public class _Window extends WDispatch
{
    public static final String clsid = "{00020893-0000-0000-C000-000000000046}";
    protected static Map gParamHashClose;
    protected static Map gParamHashLargeScroll;
    protected static Map gParamHashPrintOut;
    protected static Map gParamHashSmallScroll;
    // Static initializer
    // Used to initialize Hash Tables for named parameters
    static {
        gParamHashClose = new HashMap();
        gParamHashClose.put("SaveChanges",new Integer(0));
        gParamHashClose.put("Filename",new Integer(1));
        gParamHashClose.put("RouteWorkbook",new Integer(2));

        gParamHashLargeScroll = new HashMap();
        gParamHashLargeScroll.put("Down",new Integer(0));
        gParamHashLargeScroll.put("Up",new Integer(1));
        gParamHashLargeScroll.put("ToRight",new Integer(2));
        gParamHashLargeScroll.put("ToLeft",new Integer(3));

        gParamHashPrintOut = new HashMap();
        gParamHashPrintOut.put("From",new Integer(0));
        gParamHashPrintOut.put("To",new Integer(1));
        gParamHashPrintOut.put("Copies",new Integer(2));
        gParamHashPrintOut.put("Preview",new Integer(3));
        gParamHashPrintOut.put("ActivePrinter",new Integer(4));
        gParamHashPrintOut.put("PrintToFile",new Integer(5));
        gParamHashPrintOut.put("Collate",new Integer(6));
        gParamHashPrintOut.put("PrToFileName",new Integer(7));

        gParamHashSmallScroll = new HashMap();
        gParamHashSmallScroll.put("Down",new Integer(0));
        gParamHashSmallScroll.put("Up",new Integer(1));
        gParamHashSmallScroll.put("ToRight",new Integer(2));
        gParamHashSmallScroll.put("ToLeft",new Integer(3));

    }
    /**
    * default constructor
    */
    public _Window()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _Window(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _Window(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,148,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return XlCreatorEnum
    */
    public XlCreatorEnum getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,149,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        XlCreatorEnum ret = XlCreatorEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,150,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return Object
    */
    public Object ambig_Activate()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,304,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @return Object
    */
    public Object ambig_ActivateNext()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1115,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @return Object
    */
    public Object ambig_ActivatePrevious()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1116,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @return Range
    */
    public Range getActiveCell()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,305,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Chart
    */
    public Chart getActiveChart()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,183,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Chart ret = new Chart(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Pane
    */
    public Pane getActivePane()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,642,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Pane ret = new Pane(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getActiveSheet()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,307,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return Object
    */
    public Object ambig_getCaption()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,139,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param arg1Object
    * @param arg1Object
    */
    public void setCaption(Object arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,139,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param SaveChangesObject
    * @param FilenameObject
    * @param RouteWorkbookObject
    * @param SaveChangesObject
    * @param FilenameObject
    * @param RouteWorkbookObject
    * @return boolean
    */
    public boolean Close(Object SaveChanges,Object Filename,Object RouteWorkbook)
    {
        Variant[] args = {new Variant(SaveChanges),new Variant(Filename),new Variant(RouteWorkbook)};
        Variant retVar = invoke_method(args,277,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return boolean
    */
    public boolean Close(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashClose.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,277,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param SaveChangesObject
    * @param FilenameObject
    * @param SaveChangesObject
    * @param FilenameObject
    * @return boolean
    */
    public boolean Close(Object SaveChanges,Object Filename)
    {
        Variant[] args = {new Variant(SaveChanges),new Variant(Filename)};
        Variant retVar = invoke_method(args,277,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param SaveChangesObject
    * @param SaveChangesObject
    * @return boolean
    */
    public boolean Close(Object SaveChanges)
    {
        Variant[] args = {new Variant(SaveChanges)};
        Variant retVar = invoke_method(args,277,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean Close()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,277,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getDisplayFormulas()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,644,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setDisplayFormulas(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,644,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getDisplayGridlines()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,645,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setDisplayGridlines(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,645,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getDisplayHeadings()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,646,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setDisplayHeadings(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,646,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getDisplayHorizontalScrollBar()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,921,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setDisplayHorizontalScrollBar(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,921,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getDisplayOutline()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,647,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setDisplayOutline(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,647,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean get_DisplayRightToLeft()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,648,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void set_DisplayRightToLeft(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,648,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getDisplayVerticalScrollBar()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,922,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setDisplayVerticalScrollBar(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,922,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getDisplayWorkbookTabs()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,923,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setDisplayWorkbookTabs(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,923,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getDisplayZeros()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,649,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setDisplayZeros(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,649,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getEnableResize()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1192,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setEnableResize(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1192,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getFreezePanes()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,650,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setFreezePanes(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,650,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getGridlineColor()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,651,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setGridlineColor(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,651,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return XlColorIndexEnum
    */
    public XlColorIndexEnum getGridlineColorIndex()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,652,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        XlColorIndexEnum ret = XlColorIndexEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1XlColorIndexEnum
    * @param arg1XlColorIndexEnum
    */
    public void setGridlineColorIndex(XlColorIndexEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,652,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return double
    */
    public double getHeight()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,123,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        double ret = retVar.toDouble();
        return(ret);
    }

    /**
    * @param arg1double
    * @param arg1double
    */
    public void setHeight(double arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,123,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getIndex()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,486,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param DownObject
    * @param UpObject
    * @param ToRightObject
    * @param ToLeftObject
    * @param DownObject
    * @param UpObject
    * @param ToRightObject
    * @param ToLeftObject
    * @return Object
    */
    public Object ambig_LargeScroll(Object Down,Object Up,Object ToRight,Object ToLeft)
    {
        Variant[] args = {new Variant(Down),new Variant(Up),new Variant(ToRight),new Variant(ToLeft)};
        Variant retVar = invoke_method(args,547,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return Object
    */
    public Object ambig_LargeScroll(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashLargeScroll.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,547,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param DownObject
    * @param UpObject
    * @param ToRightObject
    * @param DownObject
    * @param UpObject
    * @param ToRightObject
    * @return Object
    */
    public Object ambig_LargeScroll(Object Down,Object Up,Object ToRight)
    {
        Variant[] args = {new Variant(Down),new Variant(Up),new Variant(ToRight)};
        Variant retVar = invoke_method(args,547,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param DownObject
    * @param UpObject
    * @param DownObject
    * @param UpObject
    * @return Object
    */
    public Object ambig_LargeScroll(Object Down,Object Up)
    {
        Variant[] args = {new Variant(Down),new Variant(Up)};
        Variant retVar = invoke_method(args,547,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param DownObject
    * @param DownObject
    * @return Object
    */
    public Object ambig_LargeScroll(Object Down)
    {
        Variant[] args = {new Variant(Down)};
        Variant retVar = invoke_method(args,547,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @return Object
    */
    public Object ambig_LargeScroll()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,547,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @return double
    */
    public double getLeft()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,127,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        double ret = retVar.toDouble();
        return(ret);
    }

    /**
    * @param arg1double
    * @param arg1double
    */
    public void setLeft(double arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,127,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Window
    */
    public Window NewWindow()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,280,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Window ret = new Window(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return String
    */
    public String getOnWindow()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,623,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setOnWindow(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,623,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Panes
    */
    public Panes getPanes()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,653,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Panes ret = new Panes(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FromObject
    * @param ToObject
    * @param CopiesObject
    * @param PreviewObject
    * @param ActivePrinterObject
    * @param PrintToFileObject
    * @param CollateObject
    * @param PrToFileNameObject
    * @param FromObject
    * @param ToObject
    * @param CopiesObject
    * @param PreviewObject
    * @param ActivePrinterObject
    * @param PrintToFileObject
    * @param CollateObject
    * @param PrToFileNameObject
    * @return Object
    */
    public Object ambig_PrintOut(Object From,Object To,Object Copies,Object Preview,Object ActivePrinter,Object PrintToFile,Object Collate,Object PrToFileName)
    {
        Variant[] args = {new Variant(From),new Variant(To),new Variant(Copies),new Variant(Preview),new Variant(ActivePrinter),new Variant(PrintToFile),new Variant(Collate),new Variant(PrToFileName)};
        Variant retVar = invoke_method(args,1772,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return Object
    */
    public Object ambig_PrintOut(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashPrintOut.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,1772,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param FromObject
    * @param ToObject
    * @param CopiesObject
    * @param PreviewObject
    * @param ActivePrinterObject
    * @param PrintToFileObject
    * @param CollateObject
    * @param FromObject
    * @param ToObject
    * @param CopiesObject
    * @param PreviewObject
    * @param ActivePrinterObject
    * @param PrintToFileObject
    * @param CollateObject
    * @return Object
    */
    public Object ambig_PrintOut(Object From,Object To,Object Copies,Object Preview,Object ActivePrinter,Object PrintToFile,Object Collate)
    {
        Variant[] args = {new Variant(From),new Variant(To),new Variant(Copies),new Variant(Preview),new Variant(ActivePrinter),new Variant(PrintToFile),new Variant(Collate)};
        Variant retVar = invoke_method(args,1772,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param FromObject
    * @param ToObject
    * @param CopiesObject
    * @param PreviewObject
    * @param ActivePrinterObject
    * @param PrintToFileObject
    * @param FromObject
    * @param ToObject
    * @param CopiesObject
    * @param PreviewObject
    * @param ActivePrinterObject
    * @param PrintToFileObject
    * @return Object
    */
    public Object ambig_PrintOut(Object From,Object To,Object Copies,Object Preview,Object ActivePrinter,Object PrintToFile)
    {
        Variant[] args = {new Variant(From),new Variant(To),new Variant(Copies),new Variant(Preview),new Variant(ActivePrinter),new Variant(PrintToFile)};
        Variant retVar = invoke_method(args,1772,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param FromObject
    * @param ToObject
    * @param CopiesObject
    * @param PreviewObject
    * @param ActivePrinterObject
    * @param FromObject
    * @param ToObject
    * @param CopiesObject
    * @param PreviewObject
    * @param ActivePrinterObject
    * @return Object
    */
    public Object ambig_PrintOut(Object From,Object To,Object Copies,Object Preview,Object ActivePrinter)
    {
        Variant[] args = {new Variant(From),new Variant(To),new Variant(Copies),new Variant(Preview),new Variant(ActivePrinter)};
        Variant retVar = invoke_method(args,1772,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param FromObject
    * @param ToObject
    * @param CopiesObject
    * @param PreviewObject
    * @param FromObject
    * @param ToObject
    * @param CopiesObject
    * @param PreviewObject
    * @return Object
    */
    public Object ambig_PrintOut(Object From,Object To,Object Copies,Object Preview)
    {
        Variant[] args = {new Variant(From),new Variant(To),new Variant(Copies),new Variant(Preview)};
        Variant retVar = invoke_method(args,1772,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param FromObject
    * @param ToObject
    * @param CopiesObject
    * @param FromObject
    * @param ToObject
    * @param CopiesObject
    * @return Object
    */
    public Object ambig_PrintOut(Object From,Object To,Object Copies)
    {
        Variant[] args = {new Variant(From),new Variant(To),new Variant(Copies)};
        Variant retVar = invoke_method(args,1772,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param FromObject
    * @param ToObject
    * @param FromObject
    * @param ToObject
    * @return Object
    */
    public Object ambig_PrintOut(Object From,Object To)
    {
        Variant[] args = {new Variant(From),new Variant(To)};
        Variant retVar = invoke_method(args,1772,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param FromObject
    * @param FromObject
    * @return Object
    */
    public Object ambig_PrintOut(Object From)
    {
        Variant[] args = {new Variant(From)};
        Variant retVar = invoke_method(args,1772,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @return Object
    */
    public Object ambig_PrintOut()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1772,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param EnableChangesObject
    * @param EnableChangesObject
    * @return Object
    */
    public Object ambig_PrintPreview(Object EnableChanges)
    {
        Variant[] args = {new Variant(EnableChanges)};
        Variant retVar = invoke_method(args,281,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @return Object
    */
    public Object ambig_PrintPreview()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,281,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @return Range
    */
    public Range getRangeSelection()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1189,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getScrollColumn()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,654,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setScrollColumn(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,654,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getScrollRow()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,655,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setScrollRow(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,655,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param SheetsObject
    * @param PositionObject
    * @param SheetsObject
    * @param PositionObject
    * @return Object
    */
    public Object ambig_ScrollWorkbookTabs(Object Sheets,Object Position)
    {
        Variant[] args = {new Variant(Sheets),new Variant(Position)};
        Variant retVar = invoke_method(args,662,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param SheetsObject
    * @param SheetsObject
    * @return Object
    */
    public Object ambig_ScrollWorkbookTabs(Object Sheets)
    {
        Variant[] args = {new Variant(Sheets)};
        Variant retVar = invoke_method(args,662,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @return Object
    */
    public Object ambig_ScrollWorkbookTabs()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,662,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @return Sheets
    */
    public Sheets getSelectedSheets()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,656,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Sheets ret = new Sheets(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getSelection()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,147,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @param DownObject
    * @param UpObject
    * @param ToRightObject
    * @param ToLeftObject
    * @param DownObject
    * @param UpObject
    * @param ToRightObject
    * @param ToLeftObject
    * @return Object
    */
    public Object ambig_SmallScroll(Object Down,Object Up,Object ToRight,Object ToLeft)
    {
        Variant[] args = {new Variant(Down),new Variant(Up),new Variant(ToRight),new Variant(ToLeft)};
        Variant retVar = invoke_method(args,548,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return Object
    */
    public Object ambig_SmallScroll(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashSmallScroll.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,548,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param DownObject
    * @param UpObject
    * @param ToRightObject
    * @param DownObject
    * @param UpObject
    * @param ToRightObject
    * @return Object
    */
    public Object ambig_SmallScroll(Object Down,Object Up,Object ToRight)
    {
        Variant[] args = {new Variant(Down),new Variant(Up),new Variant(ToRight)};
        Variant retVar = invoke_method(args,548,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param DownObject
    * @param UpObject
    * @param DownObject
    * @param UpObject
    * @return Object
    */
    public Object ambig_SmallScroll(Object Down,Object Up)
    {
        Variant[] args = {new Variant(Down),new Variant(Up)};
        Variant retVar = invoke_method(args,548,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param DownObject
    * @param DownObject
    * @return Object
    */
    public Object ambig_SmallScroll(Object Down)
    {
        Variant[] args = {new Variant(Down)};
        Variant retVar = invoke_method(args,548,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @return Object
    */
    public Object ambig_SmallScroll()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,548,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getSplit()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,657,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setSplit(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,657,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getSplitColumn()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,658,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setSplitColumn(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,658,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return double
    */
    public double getSplitHorizontal()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,659,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        double ret = retVar.toDouble();
        return(ret);
    }

    /**
    * @param arg1double
    * @param arg1double
    */
    public void setSplitHorizontal(double arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,659,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getSplitRow()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,660,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setSplitRow(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,660,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return double
    */
    public double getSplitVertical()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,661,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        double ret = retVar.toDouble();
        return(ret);
    }

    /**
    * @param arg1double
    * @param arg1double
    */
    public void setSplitVertical(double arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,661,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return double
    */
    public double getTabRatio()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,673,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        double ret = retVar.toDouble();
        return(ret);
    }

    /**
    * @param arg1double
    * @param arg1double
    */
    public void setTabRatio(double arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,673,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return double
    */
    public double getTop()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,126,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        double ret = retVar.toDouble();
        return(ret);
    }

    /**
    * @param arg1double
    * @param arg1double
    */
    public void setTop(double arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,126,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return XlWindowTypeEnum
    */
    public XlWindowTypeEnum getType()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,108,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        XlWindowTypeEnum ret = XlWindowTypeEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @return double
    */
    public double getUsableHeight()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,389,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        double ret = retVar.toDouble();
        return(ret);
    }

    /**
    * @return double
    */
    public double getUsableWidth()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,390,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        double ret = retVar.toDouble();
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getVisible()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,558,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setVisible(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,558,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Range
    */
    public Range getVisibleRange()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1118,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return double
    */
    public double getWidth()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,122,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        double ret = retVar.toDouble();
        return(ret);
    }

    /**
    * @param arg1double
    * @param arg1double
    */
    public void setWidth(double arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,122,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getWindowNumber()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1119,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return XlWindowStateEnum
    */
    public XlWindowStateEnum getWindowState()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,396,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        XlWindowStateEnum ret = XlWindowStateEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1XlWindowStateEnum
    * @param arg1XlWindowStateEnum
    */
    public void setWindowState(XlWindowStateEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,396,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Object
    */
    public Object ambig_getZoom()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,663,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param arg1Object
    * @param arg1Object
    */
    public void setZoom(Object arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,663,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return XlWindowViewEnum
    */
    public XlWindowViewEnum getView()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1194,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        XlWindowViewEnum ret = XlWindowViewEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1XlWindowViewEnum
    * @param arg1XlWindowViewEnum
    */
    public void setView(XlWindowViewEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,1194,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getDisplayRightToLeft()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1774,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setDisplayRightToLeft(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1774,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param Pointsint
    * @param Pointsint
    * @return int
    */
    public int PointsToScreenPixelsX(int Points)
    {
        Variant[] args = {new Variant(Points)};
        Variant retVar = invoke_method(args,1776,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param Pointsint
    * @param Pointsint
    * @return int
    */
    public int PointsToScreenPixelsY(int Points)
    {
        Variant[] args = {new Variant(Points)};
        Variant retVar = invoke_method(args,1777,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param xint
    * @param yint
    * @param xint
    * @param yint
    * @return Dispatch
    */
    public Dispatch ambig_RangeFromPoint(int x,int y)
    {
        Variant[] args = {new Variant(x),new Variant(y)};
        Variant retVar = invoke_method(args,1778,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @param Leftint
    * @param Topint
    * @param Widthint
    * @param Heightint
    * @param StartObject
    * @param Leftint
    * @param Topint
    * @param Widthint
    * @param Heightint
    * @param StartObject
    */
    public void ScrollIntoView(int Left,int Top,int Width,int Height,Object Start)
    {
        Variant[] args = {new Variant(Left),new Variant(Top),new Variant(Width),new Variant(Height),new Variant(Start)};
        invoke_method_void(args,1781,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param Leftint
    * @param Topint
    * @param Widthint
    * @param Heightint
    * @param Leftint
    * @param Topint
    * @param Widthint
    * @param Heightint
    */
    public void ScrollIntoView(int Left,int Top,int Width,int Height)
    {
        Variant[] args = {new Variant(Left),new Variant(Top),new Variant(Width),new Variant(Height)};
        invoke_method_void(args,1781,DispatchConstants.DISPATCH_METHOD);
    }

}
