package com.microsoft.visio.gen;
import com.microsoft.visio.*;
import com.microsoft.visio.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object IVDocument
* DO NOT EDIT THIS CODE 
* EDIT the subclass IVDocument
* @author S Lewis
*/
public class _IVDocument extends WDispatch
{
    public static final String clsid = "{00021A21-0000-0000-C000-000000000046}";
    protected static Map gParamHashFollowHyperlink;
    protected static Map gParamHashClean;
    protected static Map gParamHashCheckIn;
    protected static Map gParamHashPrintOut;
    // Static initializer
    // Used to initialize Hash Tables for named parameters
    static {
        gParamHashFollowHyperlink = new HashMap();
        gParamHashFollowHyperlink.put("Address",new Integer(0));
        gParamHashFollowHyperlink.put("SubAddress",new Integer(1));
        gParamHashFollowHyperlink.put("ExtraInfo",new Integer(2));
        gParamHashFollowHyperlink.put("Frame",new Integer(3));
        gParamHashFollowHyperlink.put("NewWindow",new Integer(4));
        gParamHashFollowHyperlink.put("res1",new Integer(5));
        gParamHashFollowHyperlink.put("res2",new Integer(6));
        gParamHashFollowHyperlink.put("res3",new Integer(7));

        gParamHashClean = new HashMap();
        gParamHashClean.put("nTargets",new Integer(0));
        gParamHashClean.put("nActions",new Integer(1));
        gParamHashClean.put("nAlerts",new Integer(2));
        gParamHashClean.put("nFixes",new Integer(3));
        gParamHashClean.put("bStopOnError",new Integer(4));
        gParamHashClean.put("bLogFileName",new Integer(5));
        gParamHashClean.put("nReserved",new Integer(6));

        gParamHashCheckIn = new HashMap();
        gParamHashCheckIn.put("SaveChanges",new Integer(0));
        gParamHashCheckIn.put("Comments",new Integer(1));
        gParamHashCheckIn.put("MakePublic",new Integer(2));

        gParamHashPrintOut = new HashMap();
        gParamHashPrintOut.put("PrintRange",new Integer(0));
        gParamHashPrintOut.put("FromPage",new Integer(1));
        gParamHashPrintOut.put("ToPage",new Integer(2));
        gParamHashPrintOut.put("ScaleCurrentViewToPaper",new Integer(3));
        gParamHashPrintOut.put("PrinterName",new Integer(4));
        gParamHashPrintOut.put("PrintToFile",new Integer(5));
        gParamHashPrintOut.put("OutputFileName",new Integer(6));
        gParamHashPrintOut.put("Copies",new Integer(7));
        gParamHashPrintOut.put("Collate",new Integer(8));
        gParamHashPrintOut.put("ColorAsBlack",new Integer(9));

    }
    /**
    * default constructor
    */
    public _IVDocument()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _IVDocument(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _IVDocument(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return IVApplication
    */
    public IVApplication getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        IVApplication ret = new IVApplication(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return short
    */
    public short getStat()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,2,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        short ret = retVar.toShort();
        return(ret);
    }

    /**
    * @return short
    */
    public short getObjectType()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,3,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        short ret = retVar.toShort();
        return(ret);
    }

    /**
    * @return short
    */
    public short getInPlace()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,5,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        short ret = retVar.toShort();
        return(ret);
    }

    /**
    * @return IVMasters
    */
    public IVMasters getMasters()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,6,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        IVMasters ret = new IVMasters(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return IVPages
    */
    public IVPages getPages()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,7,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        IVPages ret = new IVPages(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return IVStyles
    */
    public IVStyles getStyles()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,8,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        IVStyles ret = new IVStyles(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return String
    */
    public String getName()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,0,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @return String
    */
    public String getPath()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,20,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @return String
    */
    public String getFullName()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,21,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param ObjectToDropIUnknown
    * @param xPosshort
    * @param yPosshort
    * @param ObjectToDropIUnknown
    * @param xPosshort
    * @param yPosshort
    * @return IVMaster
    */
    public IVMaster Drop(IUnknown ObjectToDrop,short xPos,short yPos)
    {
        Variant[] args = {new Variant(ObjectToDrop),new Variant(xPos),new Variant(yPos)};
        Variant retVar = invoke_method(args,9,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        IVMaster ret = new IVMaster(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return short
    */
    public short getIndex()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,4,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        short ret = retVar.toShort();
        return(ret);
    }

    /**
    * @return short
    */
    public short getold_Saved()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,10,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        short ret = retVar.toShort();
        return(ret);
    }

    /**
    * @param arg1short
    * @param arg1short
    */
    public void setold_Saved(short arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,10,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return short
    */
    public short getReadOnly()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,11,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        short ret = retVar.toShort();
        return(ret);
    }

    /**
    * @return short
    */
    public short Save()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,12,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        short ret = retVar.toShort();
        return(ret);
    }

    /**
    * @param FileNameString
    * @param FileNameString
    * @return short
    */
    public short SaveAs(String FileName)
    {
        Variant[] args = {new Variant(FileName)};
        Variant retVar = invoke_method(args,13,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        short ret = retVar.toShort();
        return(ret);
    }

    /**
    * @return int
    */
    public int getold_Version()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,14,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setold_Version(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,14,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getTitle()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,15,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setTitle(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,15,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getSubject()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,16,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setSubject(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,16,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,17,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setCreator(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,17,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getKeywords()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,18,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setKeywords(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,18,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getDescription()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,19,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setDescription(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,19,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    */
    public void Print()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,22,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void Close()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,23,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @return IVUIObject
    */
    public IVUIObject getCustomMenus()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,24,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        IVUIObject ret = new IVUIObject(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param MenusObjectIVUIObject
    * @param MenusObjectIVUIObject
    */
    public void SetCustomMenus(IVUIObject MenusObject)
    {
        Variant[] args = {new Variant(MenusObject)};
        invoke_method_void(args,25,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @return String
    */
    public String getCustomMenusFile()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,26,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setCustomMenusFile(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,26,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    */
    public void ClearCustomMenus()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,27,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @return IVUIObject
    */
    public IVUIObject getCustomToolbars()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,28,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        IVUIObject ret = new IVUIObject(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ToolbarsObjectIVUIObject
    * @param ToolbarsObjectIVUIObject
    */
    public void SetCustomToolbars(IVUIObject ToolbarsObject)
    {
        Variant[] args = {new Variant(ToolbarsObject)};
        invoke_method_void(args,29,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @return String
    */
    public String getCustomToolbarsFile()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,30,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setCustomToolbarsFile(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,30,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    */
    public void ClearCustomToolbars()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,31,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @return IVFonts
    */
    public IVFonts getFonts()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,32,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        IVFonts ret = new IVFonts(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return IVColors
    */
    public IVColors getColors()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,33,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        IVColors ret = new IVColors(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return IVEventList
    */
    public IVEventList getEventList()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,34,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        IVEventList ret = new IVEventList(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return String
    */
    public String getTemplate()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,35,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param FileNameString
    * @param SaveFlagsshort
    * @param FileNameString
    * @param SaveFlagsshort
    */
    public void SaveAsEx(String FileName,short SaveFlags)
    {
        Variant[] args = {new Variant(FileName),new Variant(SaveFlags)};
        invoke_method_void(args,36,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @return short
    */
    public short getold_SavePreviewMode()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,37,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        short ret = retVar.toShort();
        return(ret);
    }

    /**
    * @param arg1short
    * @param arg1short
    */
    public void setold_SavePreviewMode(short arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,37,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param IDshort
    * @param FileNameString
    * @param IDshort
    * @param FileNameString
    */
    public void GetIcon(short ID,String FileName)
    {
        Variant[] args = {new Variant(ID),new Variant(FileName)};
        invoke_method_void(args,38,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param IDshort
    * @param Indexshort
    * @param FileNameString
    * @param IDshort
    * @param Indexshort
    * @param FileNameString
    */
    public void SetIcon(short ID,short Index,String FileName)
    {
        Variant[] args = {new Variant(ID),new Variant(Index),new Variant(FileName)};
        invoke_method_void(args,39,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param UnitsNameOrCodeObject
    * @param UnitsNameOrCodeObject
    * @return double
    */
    public double getLeftMargin(Object UnitsNameOrCode)
    {
        Variant[] args = {new Variant(UnitsNameOrCode)};
        Variant retVar = invoke_method(args,40,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        double ret = retVar.toDouble();
        return(ret);
    }

    /**
    * @return double
    */
    public double getLeftMargin()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,40,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        double ret = retVar.toDouble();
        return(ret);
    }

    /**
    * @param UnitsNameOrCodeObject
    * @param arg2double
    * @param UnitsNameOrCodeObject
    * @param arg2double
    */
    public void setLeftMargin(Object UnitsNameOrCode,double arg2)
    {
        Variant[] args = {new Variant(UnitsNameOrCode),new Variant(arg2)};
        invoke_method_void(args,40,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param arg1double
    * @param arg1double
    */
    public void setLeftMargin(double arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,40,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param UnitsNameOrCodeObject
    * @param UnitsNameOrCodeObject
    * @return double
    */
    public double getRightMargin(Object UnitsNameOrCode)
    {
        Variant[] args = {new Variant(UnitsNameOrCode)};
        Variant retVar = invoke_method(args,41,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        double ret = retVar.toDouble();
        return(ret);
    }

    /**
    * @return double
    */
    public double getRightMargin()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,41,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        double ret = retVar.toDouble();
        return(ret);
    }

    /**
    * @param UnitsNameOrCodeObject
    * @param arg2double
    * @param UnitsNameOrCodeObject
    * @param arg2double
    */
    public void setRightMargin(Object UnitsNameOrCode,double arg2)
    {
        Variant[] args = {new Variant(UnitsNameOrCode),new Variant(arg2)};
        invoke_method_void(args,41,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param arg1double
    * @param arg1double
    */
    public void setRightMargin(double arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,41,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param UnitsNameOrCodeObject
    * @param UnitsNameOrCodeObject
    * @return double
    */
    public double getTopMargin(Object UnitsNameOrCode)
    {
        Variant[] args = {new Variant(UnitsNameOrCode)};
        Variant retVar = invoke_method(args,42,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        double ret = retVar.toDouble();
        return(ret);
    }

    /**
    * @return double
    */
    public double getTopMargin()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,42,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        double ret = retVar.toDouble();
        return(ret);
    }

    /**
    * @param UnitsNameOrCodeObject
    * @param arg2double
    * @param UnitsNameOrCodeObject
    * @param arg2double
    */
    public void setTopMargin(Object UnitsNameOrCode,double arg2)
    {
        Variant[] args = {new Variant(UnitsNameOrCode),new Variant(arg2)};
        invoke_method_void(args,42,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param arg1double
    * @param arg1double
    */
    public void setTopMargin(double arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,42,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param UnitsNameOrCodeObject
    * @param UnitsNameOrCodeObject
    * @return double
    */
    public double getBottomMargin(Object UnitsNameOrCode)
    {
        Variant[] args = {new Variant(UnitsNameOrCode)};
        Variant retVar = invoke_method(args,43,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        double ret = retVar.toDouble();
        return(ret);
    }

    /**
    * @return double
    */
    public double getBottomMargin()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,43,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        double ret = retVar.toDouble();
        return(ret);
    }

    /**
    * @param UnitsNameOrCodeObject
    * @param arg2double
    * @param UnitsNameOrCodeObject
    * @param arg2double
    */
    public void setBottomMargin(Object UnitsNameOrCode,double arg2)
    {
        Variant[] args = {new Variant(UnitsNameOrCode),new Variant(arg2)};
        invoke_method_void(args,43,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param arg1double
    * @param arg1double
    */
    public void setBottomMargin(double arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,43,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return short
    */
    public short getold_PrintLandscape()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,44,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        short ret = retVar.toShort();
        return(ret);
    }

    /**
    * @param arg1short
    * @param arg1short
    */
    public void setold_PrintLandscape(short arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,44,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return short
    */
    public short getold_PrintCenteredH()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,45,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        short ret = retVar.toShort();
        return(ret);
    }

    /**
    * @param arg1short
    * @param arg1short
    */
    public void setold_PrintCenteredH(short arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,45,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return short
    */
    public short getold_PrintCenteredV()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,46,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        short ret = retVar.toShort();
        return(ret);
    }

    /**
    * @param arg1short
    * @param arg1short
    */
    public void setold_PrintCenteredV(short arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,46,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return double
    */
    public double getPrintScale()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,47,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        double ret = retVar.toDouble();
        return(ret);
    }

    /**
    * @param arg1double
    * @param arg1double
    */
    public void setPrintScale(double arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,47,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return short
    */
    public short getold_PrintFitOnPages()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,48,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        short ret = retVar.toShort();
        return(ret);
    }

    /**
    * @param arg1short
    * @param arg1short
    */
    public void setold_PrintFitOnPages(short arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,48,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return short
    */
    public short getPrintPagesAcross()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,49,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        short ret = retVar.toShort();
        return(ret);
    }

    /**
    * @param arg1short
    * @param arg1short
    */
    public void setPrintPagesAcross(short arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,49,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return short
    */
    public short getPrintPagesDown()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,50,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        short ret = retVar.toShort();
        return(ret);
    }

    /**
    * @param arg1short
    * @param arg1short
    */
    public void setPrintPagesDown(short arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,50,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getDefaultStyle()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,51,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setDefaultStyle(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,51,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getDefaultLineStyle()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,52,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setDefaultLineStyle(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,52,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getDefaultFillStyle()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,53,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setDefaultFillStyle(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,53,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getDefaultTextStyle()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,54,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setDefaultTextStyle(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,54,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return short
    */
    public short getPersistsEvents()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,55,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        short ret = retVar.toShort();
        return(ret);
    }

    /**
    * @return IVWindow
    */
    public IVWindow OpenStencilWindow()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,56,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        IVWindow ret = new IVWindow(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param LineString
    * @param LineString
    */
    public void ParseLine(String Line)
    {
        Variant[] args = {new Variant(Line)};
        invoke_method_void(args,57,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param LineString
    * @param LineString
    */
    public void ExecuteLine(String Line)
    {
        Variant[] args = {new Variant(Line)};
        invoke_method_void(args,58,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getVBProject()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,59,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @param UnitsNameOrCodeObject
    * @param UnitsNameOrCodeObject
    * @return double
    */
    public double getPaperWidth(Object UnitsNameOrCode)
    {
        Variant[] args = {new Variant(UnitsNameOrCode)};
        Variant retVar = invoke_method(args,60,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        double ret = retVar.toDouble();
        return(ret);
    }

    /**
    * @param UnitsNameOrCodeObject
    * @param UnitsNameOrCodeObject
    * @return double
    */
    public double getPaperHeight(Object UnitsNameOrCode)
    {
        Variant[] args = {new Variant(UnitsNameOrCode)};
        Variant retVar = invoke_method(args,61,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        double ret = retVar.toDouble();
        return(ret);
    }

    /**
    * @return short
    */
    public short getold_PaperSize()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,62,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        short ret = retVar.toShort();
        return(ret);
    }

    /**
    * @param arg1short
    * @param arg1short
    */
    public void setold_PaperSize(short arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,62,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param TargetString
    * @param LocationString
    * @param TargetString
    * @param LocationString
    */
    public void FollowHyperlink45(String Target,String Location)
    {
        Variant[] args = {new Variant(Target),new Variant(Location)};
        invoke_method_void(args,63,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @return String
    */
    public String getCodeName()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,-2147418112,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @return short
    */
    public short getold_Mode()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,64,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        short ret = retVar.toShort();
        return(ret);
    }

    /**
    * @param arg1short
    * @param arg1short
    */
    public void setold_Mode(short arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,64,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return IVOLEObjects
    */
    public IVOLEObjects getOLEObjects()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,65,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        IVOLEObjects ret = new IVOLEObjects(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param AddressString
    * @param SubAddressString
    * @param ExtraInfoObject
    * @param FrameObject
    * @param NewWindowObject
    * @param res1Object
    * @param res2Object
    * @param res3Object
    * @param AddressString
    * @param SubAddressString
    * @param ExtraInfoObject
    * @param FrameObject
    * @param NewWindowObject
    * @param res1Object
    * @param res2Object
    * @param res3Object
    */
    public void FollowHyperlink(String Address,String SubAddress,Object ExtraInfo,Object Frame,Object NewWindow,Object res1,Object res2,Object res3)
    {
        Variant[] args = {new Variant(Address),new Variant(SubAddress),new Variant(ExtraInfo),new Variant(Frame),new Variant(NewWindow),new Variant(res1),new Variant(res2),new Variant(res3)};
        invoke_method_void(args,66,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void FollowHyperlink(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashFollowHyperlink.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,66,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param AddressString
    * @param SubAddressString
    * @param ExtraInfoObject
    * @param FrameObject
    * @param NewWindowObject
    * @param res1Object
    * @param res2Object
    * @param AddressString
    * @param SubAddressString
    * @param ExtraInfoObject
    * @param FrameObject
    * @param NewWindowObject
    * @param res1Object
    * @param res2Object
    */
    public void FollowHyperlink(String Address,String SubAddress,Object ExtraInfo,Object Frame,Object NewWindow,Object res1,Object res2)
    {
        Variant[] args = {new Variant(Address),new Variant(SubAddress),new Variant(ExtraInfo),new Variant(Frame),new Variant(NewWindow),new Variant(res1),new Variant(res2)};
        invoke_method_void(args,66,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param AddressString
    * @param SubAddressString
    * @param ExtraInfoObject
    * @param FrameObject
    * @param NewWindowObject
    * @param res1Object
    * @param AddressString
    * @param SubAddressString
    * @param ExtraInfoObject
    * @param FrameObject
    * @param NewWindowObject
    * @param res1Object
    */
    public void FollowHyperlink(String Address,String SubAddress,Object ExtraInfo,Object Frame,Object NewWindow,Object res1)
    {
        Variant[] args = {new Variant(Address),new Variant(SubAddress),new Variant(ExtraInfo),new Variant(Frame),new Variant(NewWindow),new Variant(res1)};
        invoke_method_void(args,66,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param AddressString
    * @param SubAddressString
    * @param ExtraInfoObject
    * @param FrameObject
    * @param NewWindowObject
    * @param AddressString
    * @param SubAddressString
    * @param ExtraInfoObject
    * @param FrameObject
    * @param NewWindowObject
    */
    public void FollowHyperlink(String Address,String SubAddress,Object ExtraInfo,Object Frame,Object NewWindow)
    {
        Variant[] args = {new Variant(Address),new Variant(SubAddress),new Variant(ExtraInfo),new Variant(Frame),new Variant(NewWindow)};
        invoke_method_void(args,66,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param AddressString
    * @param SubAddressString
    * @param ExtraInfoObject
    * @param FrameObject
    * @param AddressString
    * @param SubAddressString
    * @param ExtraInfoObject
    * @param FrameObject
    */
    public void FollowHyperlink(String Address,String SubAddress,Object ExtraInfo,Object Frame)
    {
        Variant[] args = {new Variant(Address),new Variant(SubAddress),new Variant(ExtraInfo),new Variant(Frame)};
        invoke_method_void(args,66,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param AddressString
    * @param SubAddressString
    * @param ExtraInfoObject
    * @param AddressString
    * @param SubAddressString
    * @param ExtraInfoObject
    */
    public void FollowHyperlink(String Address,String SubAddress,Object ExtraInfo)
    {
        Variant[] args = {new Variant(Address),new Variant(SubAddress),new Variant(ExtraInfo)};
        invoke_method_void(args,66,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param AddressString
    * @param SubAddressString
    * @param AddressString
    * @param SubAddressString
    */
    public void FollowHyperlink(String Address,String SubAddress)
    {
        Variant[] args = {new Variant(Address),new Variant(SubAddress)};
        invoke_method_void(args,66,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @return String
    */
    public String getManager()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,67,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setManager(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,67,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getCompany()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,68,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setCompany(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,68,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getCategory()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,69,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setCategory(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,69,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getHyperlinkBase()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,70,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setHyperlinkBase(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,70,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return IVShape
    */
    public IVShape getDocumentSheet()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,71,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        IVShape ret = new IVShape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getContainer()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,72,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return String
    */
    public String getClassID()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,73,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @return String
    */
    public String getProgID()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,74,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @return IVMasterShortcuts
    */
    public IVMasterShortcuts getMasterShortcuts()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,75,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        IVMasterShortcuts ret = new IVMasterShortcuts(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return String
    */
    public String getAlternateNames()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,76,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setAlternateNames(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,76,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return IVShape
    */
    public IVShape getGestureFormatSheet()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,77,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        IVShape ret = new IVShape(retVar.toDispatch());
        return(ret);
    }

    /**
    */
    public void ClearGestureFormatSheet()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,78,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @return boolean
    */
    public boolean getAutoRecover()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,79,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setAutoRecover(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,79,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getSaved()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743922,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setSaved(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1610743922,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return VisDocVersionsEnum
    */
    public VisDocVersionsEnum getVersion()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743924,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        VisDocVersionsEnum ret = VisDocVersionsEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1VisDocVersionsEnum
    * @param arg1VisDocVersionsEnum
    */
    public void setVersion(VisDocVersionsEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,1610743924,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return VisSavePreviewModeEnum
    */
    public VisSavePreviewModeEnum getSavePreviewMode()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743926,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        VisSavePreviewModeEnum ret = VisSavePreviewModeEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1VisSavePreviewModeEnum
    * @param arg1VisSavePreviewModeEnum
    */
    public void setSavePreviewMode(VisSavePreviewModeEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,1610743926,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getPrintLandscape()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743928,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setPrintLandscape(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1610743928,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getPrintCenteredH()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743930,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setPrintCenteredH(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1610743930,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getPrintCenteredV()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743932,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setPrintCenteredV(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1610743932,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getPrintFitOnPages()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743934,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setPrintFitOnPages(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1610743934,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return VisPaperSizesEnum
    */
    public VisPaperSizesEnum getPaperSize()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743936,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        VisPaperSizesEnum ret = VisPaperSizesEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1VisPaperSizesEnum
    * @param arg1VisPaperSizesEnum
    */
    public void setPaperSize(VisPaperSizesEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,1610743936,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return VisDocModeArgsEnum
    */
    public VisDocModeArgsEnum getMode()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743938,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        VisDocModeArgsEnum ret = VisDocModeArgsEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1VisDocModeArgsEnum
    * @param arg1VisDocModeArgsEnum
    */
    public void setMode(VisDocModeArgsEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,1610743938,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getSnapEnabled()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743940,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setSnapEnabled(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1610743940,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return VisSnapSettingsEnum
    */
    public VisSnapSettingsEnum getSnapSettings()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743942,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        VisSnapSettingsEnum ret = VisSnapSettingsEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1VisSnapSettingsEnum
    * @param arg1VisSnapSettingsEnum
    */
    public void setSnapSettings(VisSnapSettingsEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,1610743942,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return VisSnapExtensionsEnum
    */
    public VisSnapExtensionsEnum getSnapExtensions()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743944,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        VisSnapExtensionsEnum ret = VisSnapExtensionsEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1VisSnapExtensionsEnum
    * @param arg1VisSnapExtensionsEnum
    */
    public void setSnapExtensions(VisSnapExtensionsEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,1610743944,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Object // @@@VT_SAFEARRAY+VT_R8 

    */
    /*
    public Object // @@@VT_SAFEARRAY+VT_R8 
 getSnapAngles()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743946,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Object // @@@VT_SAFEARRAY+VT_R8 
 ret = new Object // @@@VT_SAFEARRAY+VT_R8 
((Dispatch)retVar.ForceObjectVal());
        return(ret);
    }
    */

    /**
    * Undefined Param Type - Edit the XML Source     * @param arg1Object // @@@VT_PTR+VT_SAFEARRAY+VT_R8 

    * @param arg1Object // @@@VT_PTR+VT_SAFEARRAY+VT_R8 

    */
    public void setSnapAngles(Object // @@@VT_PTR+VT_SAFEARRAY+VT_R8 
 arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1610743946,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getGlueEnabled()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743948,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setGlueEnabled(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1610743948,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return VisGlueSettingsEnum
    */
    public VisGlueSettingsEnum getGlueSettings()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743950,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        VisGlueSettingsEnum ret = VisGlueSettingsEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1VisGlueSettingsEnum
    * @param arg1VisGlueSettingsEnum
    */
    public void setGlueSettings(VisGlueSettingsEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,1610743950,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getDynamicGridEnabled()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743952,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setDynamicGridEnabled(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1610743952,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getDefaultGuideStyle()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743954,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setDefaultGuideStyle(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1610743954,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param bstrPasswordObject
    * @param bstrPasswordObject
    * @return VisProtectionEnum
    */
    public VisProtectionEnum getProtection(Object bstrPassword)
    {
        Variant[] args = {new Variant(bstrPassword)};
        Variant retVar = invoke_method(args,1610743956,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        VisProtectionEnum ret = VisProtectionEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @return VisProtectionEnum
    */
    public VisProtectionEnum getProtection()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743956,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        VisProtectionEnum ret = VisProtectionEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param bstrPasswordObject
    * @param arg2VisProtectionEnum
    * @param bstrPasswordObject
    * @param arg2VisProtectionEnum
    */
    public void setProtection(Object bstrPassword,VisProtectionEnum arg2)
    {
        Variant[] args = {new Variant(bstrPassword),new Variant(arg2.getValue())};
        invoke_method_void(args,1610743956,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param arg1VisProtectionEnum
    * @param arg1VisProtectionEnum
    */
    public void setProtection(VisProtectionEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,1610743956,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getPrinter()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743958,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setPrinter(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1610743958,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getPrintCopies()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743960,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setPrintCopies(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1610743960,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getHeaderLeft()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743962,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setHeaderLeft(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1610743962,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getHeaderCenter()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743964,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setHeaderCenter(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1610743964,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getHeaderRight()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743966,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setHeaderRight(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1610743966,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param UnitsNameOrCodeObject
    * @param UnitsNameOrCodeObject
    * @return double
    */
    public double getHeaderMargin(Object UnitsNameOrCode)
    {
        Variant[] args = {new Variant(UnitsNameOrCode)};
        Variant retVar = invoke_method(args,1610743968,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        double ret = retVar.toDouble();
        return(ret);
    }

    /**
    * @return double
    */
    public double getHeaderMargin()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743968,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        double ret = retVar.toDouble();
        return(ret);
    }

    /**
    * @param UnitsNameOrCodeObject
    * @param arg2double
    * @param UnitsNameOrCodeObject
    * @param arg2double
    */
    public void setHeaderMargin(Object UnitsNameOrCode,double arg2)
    {
        Variant[] args = {new Variant(UnitsNameOrCode),new Variant(arg2)};
        invoke_method_void(args,1610743968,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param arg1double
    * @param arg1double
    */
    public void setHeaderMargin(double arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1610743968,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getFooterLeft()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743970,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setFooterLeft(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1610743970,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getFooterCenter()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743972,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setFooterCenter(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1610743972,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getFooterRight()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743974,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setFooterRight(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1610743974,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param UnitsNameOrCodeObject
    * @param UnitsNameOrCodeObject
    * @return double
    */
    public double getFooterMargin(Object UnitsNameOrCode)
    {
        Variant[] args = {new Variant(UnitsNameOrCode)};
        Variant retVar = invoke_method(args,1610743976,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        double ret = retVar.toDouble();
        return(ret);
    }

    /**
    * @return double
    */
    public double getFooterMargin()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743976,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        double ret = retVar.toDouble();
        return(ret);
    }

    /**
    * @param UnitsNameOrCodeObject
    * @param arg2double
    * @param UnitsNameOrCodeObject
    * @param arg2double
    */
    public void setFooterMargin(Object UnitsNameOrCode,double arg2)
    {
        Variant[] args = {new Variant(UnitsNameOrCode),new Variant(arg2)};
        invoke_method_void(args,1610743976,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param arg1double
    * @param arg1double
    */
    public void setFooterMargin(double arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1610743976,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Object // @@@IFontDisp 

    */
    /*
    public Object // @@@IFontDisp 
 getHeaderFooterFont()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743978,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Object // @@@IFontDisp 
 ret = new Object // @@@IFontDisp 
((Dispatch)retVar.ForceObjectVal());
        return(ret);
    }
    */

    /**
    * Undefined Param Type - Edit the XML Source     * @param arg1Object // @@@IFontDisp 

    * @param arg1Object // @@@IFontDisp 

    */
    public void setHeaderFooterFont(Object // @@@IFontDisp 
 arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1610743978,DispatchConstants.DISPATCH_PROPERTYPUTREF);
    }

    /**
    * @return int
    */
    public int getHeaderFooterColor()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743980,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1intRealType - OLE_COLOR
    * @param arg1intRealType - OLE_COLOR
    */
    public void setHeaderFooterColor(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1610743980,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param bstrExistingPasswordObject
    * @param arg2String
    * @param bstrExistingPasswordObject
    * @param arg2String
    */
    public void setPassword(Object bstrExistingPassword,String arg2)
    {
        Variant[] args = {new Variant(bstrExistingPassword),new Variant(arg2)};
        invoke_method_void(args,1610743982,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setPassword(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1610743982,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Object // @@@IPictureDisp 

    */
    /*
    public Object // @@@IPictureDisp 
 getPreviewPicture()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743983,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Object // @@@IPictureDisp 
 ret = new Object // @@@IPictureDisp 
((Dispatch)retVar.ForceObjectVal());
        return(ret);
    }
    */

    /**
    * Undefined Param Type - Edit the XML Source     * @param arg1Object // @@@IPictureDisp 

    * @param arg1Object // @@@IPictureDisp 

    */
    public void setPreviewPicture(Object // @@@IPictureDisp 
 arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1610743983,DispatchConstants.DISPATCH_PROPERTYPUTREF);
    }

    /**
    * @param nTargetsObject
    * @param nActionsObject
    * @param nAlertsObject
    * @param nFixesObject
    * @param bStopOnErrorObject
    * @param bLogFileNameObject
    * @param nReservedObject
    * @param nTargetsObject
    * @param nActionsObject
    * @param nAlertsObject
    * @param nFixesObject
    * @param bStopOnErrorObject
    * @param bLogFileNameObject
    * @param nReservedObject
    */
    public void Clean(Object nTargets,Object nActions,Object nAlerts,Object nFixes,Object bStopOnError,Object bLogFileName,Object nReserved)
    {
        Variant[] args = {new Variant(nTargets),new Variant(nActions),new Variant(nAlerts),new Variant(nFixes),new Variant(bStopOnError),new Variant(bLogFileName),new Variant(nReserved)};
        invoke_method_void(args,1610743985,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void Clean(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashClean.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,1610743985,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param nTargetsObject
    * @param nActionsObject
    * @param nAlertsObject
    * @param nFixesObject
    * @param bStopOnErrorObject
    * @param bLogFileNameObject
    * @param nTargetsObject
    * @param nActionsObject
    * @param nAlertsObject
    * @param nFixesObject
    * @param bStopOnErrorObject
    * @param bLogFileNameObject
    */
    public void Clean(Object nTargets,Object nActions,Object nAlerts,Object nFixes,Object bStopOnError,Object bLogFileName)
    {
        Variant[] args = {new Variant(nTargets),new Variant(nActions),new Variant(nAlerts),new Variant(nFixes),new Variant(bStopOnError),new Variant(bLogFileName)};
        invoke_method_void(args,1610743985,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param nTargetsObject
    * @param nActionsObject
    * @param nAlertsObject
    * @param nFixesObject
    * @param bStopOnErrorObject
    * @param nTargetsObject
    * @param nActionsObject
    * @param nAlertsObject
    * @param nFixesObject
    * @param bStopOnErrorObject
    */
    public void Clean(Object nTargets,Object nActions,Object nAlerts,Object nFixes,Object bStopOnError)
    {
        Variant[] args = {new Variant(nTargets),new Variant(nActions),new Variant(nAlerts),new Variant(nFixes),new Variant(bStopOnError)};
        invoke_method_void(args,1610743985,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param nTargetsObject
    * @param nActionsObject
    * @param nAlertsObject
    * @param nFixesObject
    * @param nTargetsObject
    * @param nActionsObject
    * @param nAlertsObject
    * @param nFixesObject
    */
    public void Clean(Object nTargets,Object nActions,Object nAlerts,Object nFixes)
    {
        Variant[] args = {new Variant(nTargets),new Variant(nActions),new Variant(nAlerts),new Variant(nFixes)};
        invoke_method_void(args,1610743985,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param nTargetsObject
    * @param nActionsObject
    * @param nAlertsObject
    * @param nTargetsObject
    * @param nActionsObject
    * @param nAlertsObject
    */
    public void Clean(Object nTargets,Object nActions,Object nAlerts)
    {
        Variant[] args = {new Variant(nTargets),new Variant(nActions),new Variant(nAlerts)};
        invoke_method_void(args,1610743985,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param nTargetsObject
    * @param nActionsObject
    * @param nTargetsObject
    * @param nActionsObject
    */
    public void Clean(Object nTargets,Object nActions)
    {
        Variant[] args = {new Variant(nTargets),new Variant(nActions)};
        invoke_method_void(args,1610743985,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param nTargetsObject
    * @param nTargetsObject
    */
    public void Clean(Object nTargets)
    {
        Variant[] args = {new Variant(nTargets)};
        invoke_method_void(args,1610743985,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void Clean()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,1610743985,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @return int
    */
    public int getBuildNumberCreated()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743986,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return int
    */
    public int getBuildNumberEdited()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743987,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return java.util.Date
    */
    public java.util.Date getTimeCreated()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743988,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        java.util.Date ret = COMUtilities.fromVBDate(retVar.toDate()).getTime();
        return(ret);
    }

    /**
    * @return java.util.Date
    */
    public java.util.Date getTime()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743989,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        java.util.Date ret = COMUtilities.fromVBDate(retVar.toDate()).getTime();
        return(ret);
    }

    /**
    * @return java.util.Date
    */
    public java.util.Date getTimeEdited()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743990,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        java.util.Date ret = COMUtilities.fromVBDate(retVar.toDate()).getTime();
        return(ret);
    }

    /**
    * @return java.util.Date
    */
    public java.util.Date getTimePrinted()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743991,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        java.util.Date ret = COMUtilities.fromVBDate(retVar.toDate()).getTime();
        return(ret);
    }

    /**
    * @return java.util.Date
    */
    public java.util.Date getTimeSaved()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743992,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        java.util.Date ret = COMUtilities.fromVBDate(retVar.toDate()).getTime();
        return(ret);
    }

    /**
    * @param pSourceDocIVDocument
    * @param pSourceDocIVDocument
    */
    public void CopyPreviewPicture(IVDocument pSourceDoc)
    {
        Variant[] args = {new Variant(pSourceDoc)};
        invoke_method_void(args,1610743993,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @return boolean
    */
    public boolean getContainsWorkspace()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743994,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @return Object // @@@VT_SAFEARRAY+VT_VARIANT 

    */
    /*
    public Object // @@@VT_SAFEARRAY+VT_VARIANT 
 getEmailRoutingData()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743995,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Object // @@@VT_SAFEARRAY+VT_VARIANT 
 ret = new Object // @@@VT_SAFEARRAY+VT_VARIANT 
((Dispatch)retVar.ForceObjectVal());
        return(ret);
    }
    */

    /**
    * @return Object // @@@VT_SAFEARRAY+VT_UI1 

    */
    /*
    public Object // @@@VT_SAFEARRAY+VT_UI1 
 getVBProjectData()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743996,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Object // @@@VT_SAFEARRAY+VT_UI1 
 ret = new Object // @@@VT_SAFEARRAY+VT_UI1 
((Dispatch)retVar.ForceObjectVal());
        return(ret);
    }
    */

    /**
    * @return int
    */
    public int getSolutionXMLElementCount()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610743997,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param Indexint
    * @param Indexint
    * @return String
    */
    public String getSolutionXMLElementName(int Index)
    {
        Variant[] args = {new Variant(Index)};
        Variant retVar = invoke_method(args,1610743998,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param ElementNameString
    * @param ElementNameString
    * @return boolean
    */
    public boolean getSolutionXMLElementExists(String ElementName)
    {
        Variant[] args = {new Variant(ElementName)};
        Variant retVar = invoke_method(args,1610743999,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param ElementNameString
    * @param ElementNameString
    * @return String
    */
    public String getSolutionXMLElement(String ElementName)
    {
        Variant[] args = {new Variant(ElementName)};
        Variant retVar = invoke_method(args,1610744000,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param ElementNameString
    * @param arg2String
    * @param ElementNameString
    * @param arg2String
    */
    public void setSolutionXMLElement(String ElementName,String arg2)
    {
        Variant[] args = {new Variant(ElementName),new Variant(arg2)};
        invoke_method_void(args,1610744000,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param ElementNameString
    * @param ElementNameString
    */
    public void DeleteSolutionXMLElement(String ElementName)
    {
        Variant[] args = {new Variant(ElementName)};
        invoke_method_void(args,1610744002,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @return int
    */
    public int getFullBuildNumberCreated()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610744003,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return int
    */
    public int getFullBuildNumberEdited()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610744004,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return int
    */
    public int getID()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610744005,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getMacrosEnabled()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610744006,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @return VisZoomBehaviorEnum
    */
    public VisZoomBehaviorEnum getZoomBehavior()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610744007,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        VisZoomBehaviorEnum ret = VisZoomBehaviorEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1VisZoomBehaviorEnum
    * @param arg1VisZoomBehaviorEnum
    */
    public void setZoomBehavior(VisZoomBehaviorEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,1610744007,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean CanCheckIn()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610744009,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param SaveChangesboolean
    * @param CommentsObject[]
    * @param MakePublicboolean
    * @param SaveChangesboolean
    * @param CommentsObject[]
    * @param MakePublicboolean
    */
    public void CheckIn(boolean SaveChanges,Object[] Comments,boolean MakePublic)
    {
        Variant[] args = {new Variant(SaveChanges),new Variant(Comments),new Variant(MakePublic)};
        invoke_method_void(args,1610744010,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void CheckIn(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashCheckIn.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,1610744010,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param SaveChangesboolean
    * @param CommentsObject[]
    * @param SaveChangesboolean
    * @param CommentsObject[]
    */
    public void CheckIn(boolean SaveChanges,Object[] Comments)
    {
        Variant[] args = {new Variant(SaveChanges),new Variant(Comments)};
        invoke_method_void(args,1610744010,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param SaveChangesboolean
    * @param SaveChangesboolean
    */
    public void CheckIn(boolean SaveChanges)
    {
        Variant[] args = {new Variant(SaveChanges)};
        invoke_method_void(args,1610744010,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void CheckIn()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,1610744010,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @return VisDocumentTypesEnum
    */
    public VisDocumentTypesEnum getType()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610744011,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        VisDocumentTypesEnum ret = VisDocumentTypesEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @return int
    */
    public int getLanguage()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610744012,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setLanguage(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1610744012,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getRemovePersonalInformation()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610744014,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setRemovePersonalInformation(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1610744014,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param PrintRangeVisPrintOutRangeEnum
    * @param FromPageint
    * @param ToPageint
    * @param ScaleCurrentViewToPaperboolean
    * @param PrinterNameString
    * @param PrintToFileboolean
    * @param OutputFileNameString
    * @param Copiesint
    * @param Collateboolean
    * @param ColorAsBlackboolean
    * @param PrintRangeVisPrintOutRangeEnum
    * @param FromPageint
    * @param ToPageint
    * @param ScaleCurrentViewToPaperboolean
    * @param PrinterNameString
    * @param PrintToFileboolean
    * @param OutputFileNameString
    * @param Copiesint
    * @param Collateboolean
    * @param ColorAsBlackboolean
    */
    public void PrintOut(VisPrintOutRangeEnum PrintRange,int FromPage,int ToPage,boolean ScaleCurrentViewToPaper,String PrinterName,boolean PrintToFile,String OutputFileName,int Copies,boolean Collate,boolean ColorAsBlack)
    {
        Variant[] args = {new Variant(PrintRange.getValue()),new Variant(FromPage),new Variant(ToPage),new Variant(ScaleCurrentViewToPaper),new Variant(PrinterName),new Variant(PrintToFile),new Variant(OutputFileName),new Variant(Copies),new Variant(Collate),new Variant(ColorAsBlack)};
        invoke_method_void(args,1610744016,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void PrintOut(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashPrintOut.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,1610744016,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param PrintRangeVisPrintOutRangeEnum
    * @param FromPageint
    * @param ToPageint
    * @param ScaleCurrentViewToPaperboolean
    * @param PrinterNameString
    * @param PrintToFileboolean
    * @param OutputFileNameString
    * @param Copiesint
    * @param Collateboolean
    * @param PrintRangeVisPrintOutRangeEnum
    * @param FromPageint
    * @param ToPageint
    * @param ScaleCurrentViewToPaperboolean
    * @param PrinterNameString
    * @param PrintToFileboolean
    * @param OutputFileNameString
    * @param Copiesint
    * @param Collateboolean
    */
    public void PrintOut(VisPrintOutRangeEnum PrintRange,int FromPage,int ToPage,boolean ScaleCurrentViewToPaper,String PrinterName,boolean PrintToFile,String OutputFileName,int Copies,boolean Collate)
    {
        Variant[] args = {new Variant(PrintRange.getValue()),new Variant(FromPage),new Variant(ToPage),new Variant(ScaleCurrentViewToPaper),new Variant(PrinterName),new Variant(PrintToFile),new Variant(OutputFileName),new Variant(Copies),new Variant(Collate)};
        invoke_method_void(args,1610744016,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param PrintRangeVisPrintOutRangeEnum
    * @param FromPageint
    * @param ToPageint
    * @param ScaleCurrentViewToPaperboolean
    * @param PrinterNameString
    * @param PrintToFileboolean
    * @param OutputFileNameString
    * @param Copiesint
    * @param PrintRangeVisPrintOutRangeEnum
    * @param FromPageint
    * @param ToPageint
    * @param ScaleCurrentViewToPaperboolean
    * @param PrinterNameString
    * @param PrintToFileboolean
    * @param OutputFileNameString
    * @param Copiesint
    */
    public void PrintOut(VisPrintOutRangeEnum PrintRange,int FromPage,int ToPage,boolean ScaleCurrentViewToPaper,String PrinterName,boolean PrintToFile,String OutputFileName,int Copies)
    {
        Variant[] args = {new Variant(PrintRange.getValue()),new Variant(FromPage),new Variant(ToPage),new Variant(ScaleCurrentViewToPaper),new Variant(PrinterName),new Variant(PrintToFile),new Variant(OutputFileName),new Variant(Copies)};
        invoke_method_void(args,1610744016,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param PrintRangeVisPrintOutRangeEnum
    * @param FromPageint
    * @param ToPageint
    * @param ScaleCurrentViewToPaperboolean
    * @param PrinterNameString
    * @param PrintToFileboolean
    * @param OutputFileNameString
    * @param PrintRangeVisPrintOutRangeEnum
    * @param FromPageint
    * @param ToPageint
    * @param ScaleCurrentViewToPaperboolean
    * @param PrinterNameString
    * @param PrintToFileboolean
    * @param OutputFileNameString
    */
    public void PrintOut(VisPrintOutRangeEnum PrintRange,int FromPage,int ToPage,boolean ScaleCurrentViewToPaper,String PrinterName,boolean PrintToFile,String OutputFileName)
    {
        Variant[] args = {new Variant(PrintRange.getValue()),new Variant(FromPage),new Variant(ToPage),new Variant(ScaleCurrentViewToPaper),new Variant(PrinterName),new Variant(PrintToFile),new Variant(OutputFileName)};
        invoke_method_void(args,1610744016,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param PrintRangeVisPrintOutRangeEnum
    * @param FromPageint
    * @param ToPageint
    * @param ScaleCurrentViewToPaperboolean
    * @param PrinterNameString
    * @param PrintToFileboolean
    * @param PrintRangeVisPrintOutRangeEnum
    * @param FromPageint
    * @param ToPageint
    * @param ScaleCurrentViewToPaperboolean
    * @param PrinterNameString
    * @param PrintToFileboolean
    */
    public void PrintOut(VisPrintOutRangeEnum PrintRange,int FromPage,int ToPage,boolean ScaleCurrentViewToPaper,String PrinterName,boolean PrintToFile)
    {
        Variant[] args = {new Variant(PrintRange.getValue()),new Variant(FromPage),new Variant(ToPage),new Variant(ScaleCurrentViewToPaper),new Variant(PrinterName),new Variant(PrintToFile)};
        invoke_method_void(args,1610744016,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param PrintRangeVisPrintOutRangeEnum
    * @param FromPageint
    * @param ToPageint
    * @param ScaleCurrentViewToPaperboolean
    * @param PrinterNameString
    * @param PrintRangeVisPrintOutRangeEnum
    * @param FromPageint
    * @param ToPageint
    * @param ScaleCurrentViewToPaperboolean
    * @param PrinterNameString
    */
    public void PrintOut(VisPrintOutRangeEnum PrintRange,int FromPage,int ToPage,boolean ScaleCurrentViewToPaper,String PrinterName)
    {
        Variant[] args = {new Variant(PrintRange.getValue()),new Variant(FromPage),new Variant(ToPage),new Variant(ScaleCurrentViewToPaper),new Variant(PrinterName)};
        invoke_method_void(args,1610744016,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param PrintRangeVisPrintOutRangeEnum
    * @param FromPageint
    * @param ToPageint
    * @param ScaleCurrentViewToPaperboolean
    * @param PrintRangeVisPrintOutRangeEnum
    * @param FromPageint
    * @param ToPageint
    * @param ScaleCurrentViewToPaperboolean
    */
    public void PrintOut(VisPrintOutRangeEnum PrintRange,int FromPage,int ToPage,boolean ScaleCurrentViewToPaper)
    {
        Variant[] args = {new Variant(PrintRange.getValue()),new Variant(FromPage),new Variant(ToPage),new Variant(ScaleCurrentViewToPaper)};
        invoke_method_void(args,1610744016,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param PrintRangeVisPrintOutRangeEnum
    * @param FromPageint
    * @param ToPageint
    * @param PrintRangeVisPrintOutRangeEnum
    * @param FromPageint
    * @param ToPageint
    */
    public void PrintOut(VisPrintOutRangeEnum PrintRange,int FromPage,int ToPage)
    {
        Variant[] args = {new Variant(PrintRange.getValue()),new Variant(FromPage),new Variant(ToPage)};
        invoke_method_void(args,1610744016,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param PrintRangeVisPrintOutRangeEnum
    * @param FromPageint
    * @param PrintRangeVisPrintOutRangeEnum
    * @param FromPageint
    */
    public void PrintOut(VisPrintOutRangeEnum PrintRange,int FromPage)
    {
        Variant[] args = {new Variant(PrintRange.getValue()),new Variant(FromPage)};
        invoke_method_void(args,1610744016,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param PrintRangeVisPrintOutRangeEnum
    * @param PrintRangeVisPrintOutRangeEnum
    */
    public void PrintOut(VisPrintOutRangeEnum PrintRange)
    {
        Variant[] args = {new Variant(PrintRange.getValue())};
        invoke_method_void(args,1610744016,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param bstrUndoScopeNameString
    * @param bstrUndoScopeNameString
    * @return int
    */
    public int BeginUndoScope(String bstrUndoScopeName)
    {
        Variant[] args = {new Variant(bstrUndoScopeName)};
        Variant retVar = invoke_method(args,1610744017,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param nScopeIDint
    * @param bCommitboolean
    * @param nScopeIDint
    * @param bCommitboolean
    */
    public void EndUndoScope(int nScopeID,boolean bCommit)
    {
        Variant[] args = {new Variant(nScopeID),new Variant(bCommit)};
        invoke_method_void(args,1610744018,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param pUndoUnitIUnknown
    * @param pUndoUnitIUnknown
    */
    public void AddUndoUnit(IUnknown pUndoUnit)
    {
        Variant[] args = {new Variant(pUndoUnit)};
        invoke_method_void(args,1610744019,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void PurgeUndo()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,1610744020,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @return boolean
    */
    public boolean getUndoEnabled()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610744021,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setUndoEnabled(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1610744021,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param bstrScopeNameString
    * @param bstrScopeNameString
    */
    public void RenameCurrentScope(String bstrScopeName)
    {
        Variant[] args = {new Variant(bstrScopeName)};
        invoke_method_void(args,1610744023,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getSharedWorkspace()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610744024,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getSync()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1610744025,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

}
