package com.microsoft.visio.gen;
import com.microsoft.visio.*;
import com.microsoft.visio.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object IVDocuments
* DO NOT EDIT THIS CODE 
* EDIT the subclass IVDocuments
* @author S Lewis
*/
public class _IVDocuments extends WDispatch
{
    public static final String clsid = "{000D0A00-0000-0000-C000-000000000046}";
    protected static Map gParamHashAddEx;
    // Static initializer
    // Used to initialize Hash Tables for named parameters
    static {
        gParamHashAddEx = new HashMap();
        gParamHashAddEx.put("FileName",new Integer(0));
        gParamHashAddEx.put("MeasurementSystem",new Integer(1));
        gParamHashAddEx.put("Flags",new Integer(2));
        gParamHashAddEx.put("LangID",new Integer(3));

    }
    /**
    * default constructor
    */
    public _IVDocuments()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _IVDocuments(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _IVDocuments(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @param FileNameString
    * @param FileNameString
    * @return IVDocument
    */
    public IVDocument Add(String FileName)
    {
        Variant[] args = {new Variant(FileName)};
        Variant retVar = invoke_method(args,4,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        IVDocument ret = new IVDocument(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameString
    * @param FileNameString
    * @return IVDocument
    */
    public IVDocument Open(String FileName)
    {
        Variant[] args = {new Variant(FileName)};
        Variant retVar = invoke_method(args,5,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        IVDocument ret = new IVDocument(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return IVApplication
    */
    public IVApplication getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,3,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        IVApplication ret = new IVApplication(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return short
    */
    public short getObjectType()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,2,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        short ret = retVar.toShort();
        return(ret);
    }

    /**
    * @param NameOrIndexObject
    * @param NameOrIndexObject
    * @return IVDocument
    */
    public IVDocument getItem(Object NameOrIndex)
    {
        Variant[] args = {new Variant(NameOrIndex)};
        Variant retVar = invoke_method(args,0,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        IVDocument ret = new IVDocument(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return short
    */
    public short getCount()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        short ret = retVar.toShort();
        return(ret);
    }

    /**
    * @param FileNameString
    * @param Flagsshort
    * @param FileNameString
    * @param Flagsshort
    * @return IVDocument
    */
    public IVDocument OpenEx(String FileName,short Flags)
    {
        Variant[] args = {new Variant(FileName),new Variant(Flags)};
        Variant retVar = invoke_method(args,6,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        IVDocument ret = new IVDocument(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return IVEventList
    */
    public IVEventList getEventList()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,7,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        IVEventList ret = new IVEventList(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return short
    */
    public short getPersistsEvents()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,8,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        short ret = retVar.toShort();
        return(ret);
    }

    /**
    * @param NameArrayString[]
    * @param NameArrayString[]
    */
    public void GetNames(String[] NameArray)
    {
        Variant[] args = {new Variant(NameArray)};
        invoke_method_void(args,9,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @return IUnknown
    */
    public IUnknown ambig_get_NewEnum()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,-4,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        IUnknown ret = new IUnknown(retVar.toInt());
        return(ret);
    }

    /**
    * @param ObjectIDint
    * @param ObjectIDint
    * @return IVDocument
    */
    public IVDocument getItemFromID(int ObjectID)
    {
        Variant[] args = {new Variant(ObjectID)};
        Variant retVar = invoke_method(args,1610743819,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        IVDocument ret = new IVDocument(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameString
    * @param FileNameString
    * @return boolean
    */
    public boolean CanCheckOut(String FileName)
    {
        Variant[] args = {new Variant(FileName)};
        Variant retVar = invoke_method(args,1610743820,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param FileNameString
    * @param FileNameString
    */
    public void CheckOut(String FileName)
    {
        Variant[] args = {new Variant(FileName)};
        invoke_method_void(args,1610743821,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param FileNameString
    * @param MeasurementSystemVisMeasurementSystemEnum
    * @param Flagsint
    * @param LangIDint
    * @param FileNameString
    * @param MeasurementSystemVisMeasurementSystemEnum
    * @param Flagsint
    * @param LangIDint
    * @return IVDocument
    */
    public IVDocument AddEx(String FileName,VisMeasurementSystemEnum MeasurementSystem,int Flags,int LangID)
    {
        Variant[] args = {new Variant(FileName),new Variant(MeasurementSystem.getValue()),new Variant(Flags),new Variant(LangID)};
        Variant retVar = invoke_method(args,1610743822,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        IVDocument ret = new IVDocument(retVar.toDispatch());
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return IVDocument
    */
    public IVDocument AddEx(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashAddEx.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,1610743822,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        IVDocument ret = new IVDocument(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameString
    * @param MeasurementSystemVisMeasurementSystemEnum
    * @param Flagsint
    * @param FileNameString
    * @param MeasurementSystemVisMeasurementSystemEnum
    * @param Flagsint
    * @return IVDocument
    */
    public IVDocument AddEx(String FileName,VisMeasurementSystemEnum MeasurementSystem,int Flags)
    {
        Variant[] args = {new Variant(FileName),new Variant(MeasurementSystem.getValue()),new Variant(Flags)};
        Variant retVar = invoke_method(args,1610743822,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        IVDocument ret = new IVDocument(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameString
    * @param MeasurementSystemVisMeasurementSystemEnum
    * @param FileNameString
    * @param MeasurementSystemVisMeasurementSystemEnum
    * @return IVDocument
    */
    public IVDocument AddEx(String FileName,VisMeasurementSystemEnum MeasurementSystem)
    {
        Variant[] args = {new Variant(FileName),new Variant(MeasurementSystem.getValue())};
        Variant retVar = invoke_method(args,1610743822,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        IVDocument ret = new IVDocument(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameString
    * @param FileNameString
    * @return IVDocument
    */
    public IVDocument AddEx(String FileName)
    {
        Variant[] args = {new Variant(FileName)};
        Variant retVar = invoke_method(args,1610743822,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        IVDocument ret = new IVDocument(retVar.toDispatch());
        return(ret);
    }

}
