package com.microsoft.word.gen;
import com.microsoft.word.*;
import com.microsoft.word.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object AutoCorrect
* DO NOT EDIT THIS CODE 
* EDIT the subclass AutoCorrect
* @author S Lewis
*/
public class _AutoCorrect extends WDispatch
{
    public static final String clsid = "{00020949-0000-0000-C000-000000000046}";
    /**
    * default constructor
    */
    public _AutoCorrect()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _AutoCorrect(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _AutoCorrect(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1000,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1001,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1002,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getCorrectDays()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setCorrectDays(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getCorrectInitialCaps()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,2,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setCorrectInitialCaps(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,2,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getCorrectSentenceCaps()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,3,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setCorrectSentenceCaps(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,3,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getReplaceText()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,4,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setReplaceText(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,4,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return AutoCorrectEntries
    */
    public AutoCorrectEntries getEntries()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,6,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        AutoCorrectEntries ret = new AutoCorrectEntries(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return FirstLetterExceptions
    */
    public FirstLetterExceptions getFirstLetterExceptions()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,7,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        FirstLetterExceptions ret = new FirstLetterExceptions(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getFirstLetterAutoAdd()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,8,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setFirstLetterAutoAdd(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,8,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return TwoInitialCapsExceptions
    */
    public TwoInitialCapsExceptions getTwoInitialCapsExceptions()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,9,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        TwoInitialCapsExceptions ret = new TwoInitialCapsExceptions(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getTwoInitialCapsAutoAdd()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,10,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setTwoInitialCapsAutoAdd(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,10,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getCorrectCapsLock()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,11,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setCorrectCapsLock(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,11,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getCorrectHangulAndAlphabet()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,12,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setCorrectHangulAndAlphabet(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,12,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return HangulAndAlphabetExceptions
    */
    public HangulAndAlphabetExceptions getHangulAndAlphabetExceptions()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,13,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        HangulAndAlphabetExceptions ret = new HangulAndAlphabetExceptions(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getHangulAndAlphabetAutoAdd()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,14,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setHangulAndAlphabetAutoAdd(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,14,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getReplaceTextFromSpellingChecker()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,15,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setReplaceTextFromSpellingChecker(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,15,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getOtherCorrectionsAutoAdd()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,16,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setOtherCorrectionsAutoAdd(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,16,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return OtherCorrectionsExceptions
    */
    public OtherCorrectionsExceptions getOtherCorrectionsExceptions()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,17,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        OtherCorrectionsExceptions ret = new OtherCorrectionsExceptions(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getCorrectKeyboardSetting()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,18,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setCorrectKeyboardSetting(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,18,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

}
