package com.microsoft.word.gen;
import com.microsoft.word.*;
import com.microsoft.word.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object AutoCorrectEntries
* DO NOT EDIT THIS CODE 
* EDIT the subclass AutoCorrectEntries
* @author S Lewis
*/
public class _AutoCorrectEntries extends WDispatch
{
    public static final String clsid = "{00020948-0000-0000-C000-000000000046}";
    /**
    * default constructor
    */
    public _AutoCorrectEntries()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _AutoCorrectEntries(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _AutoCorrectEntries(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1000,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1001,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1002,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return IUnknown
    */
    public IUnknown ambig_get_NewEnum()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,-4,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        IUnknown ret = new IUnknown(retVar.toInt());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCount()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param IndexObject[]
    * @param IndexObject[]
    * @return AutoCorrectEntry
    */
    public AutoCorrectEntry Item(Object[] Index)
    {
        Variant[] args = {new Variant(Index)};
        Variant retVar = invoke_method(args,0,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        AutoCorrectEntry ret = new AutoCorrectEntry(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param NameString
    * @param ValueString
    * @param NameString
    * @param ValueString
    * @return AutoCorrectEntry
    */
    public AutoCorrectEntry Add(String Name,String Value)
    {
        Variant[] args = {new Variant(Name),new Variant(Value)};
        Variant retVar = invoke_method(args,101,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        AutoCorrectEntry ret = new AutoCorrectEntry(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param NameString
    * @param RangeRange
    * @param NameString
    * @param RangeRange
    * @return AutoCorrectEntry
    */
    public AutoCorrectEntry AddRichText(String Name,Range Range)
    {
        Variant[] args = {new Variant(Name),new Variant(Range)};
        Variant retVar = invoke_method(args,102,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        AutoCorrectEntry ret = new AutoCorrectEntry(retVar.toDispatch());
        return(ret);
    }

}
