package com.microsoft.word.gen;
import com.microsoft.word.*;
import com.microsoft.word.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object Column
* DO NOT EDIT THIS CODE 
* EDIT the subclass Column
* @author S Lewis
*/
public class _Column extends WDispatch
{
    public static final String clsid = "{0002094F-0000-0000-C000-000000000046}";
    protected static Map gParamHashSortOld;
    protected static Map gParamHashSort;
    // Static initializer
    // Used to initialize Hash Tables for named parameters
    static {
        gParamHashSortOld = new HashMap();
        gParamHashSortOld.put("ExcludeHeader",new Integer(0));
        gParamHashSortOld.put("SortFieldType",new Integer(1));
        gParamHashSortOld.put("SortOrder",new Integer(2));
        gParamHashSortOld.put("CaseSensitive",new Integer(3));
        gParamHashSortOld.put("LanguageID",new Integer(4));

        gParamHashSort = new HashMap();
        gParamHashSort.put("ExcludeHeader",new Integer(0));
        gParamHashSort.put("SortFieldType",new Integer(1));
        gParamHashSort.put("SortOrder",new Integer(2));
        gParamHashSort.put("CaseSensitive",new Integer(3));
        gParamHashSort.put("BidiSort",new Integer(4));
        gParamHashSort.put("IgnoreThe",new Integer(5));
        gParamHashSort.put("IgnoreKashida",new Integer(6));
        gParamHashSort.put("IgnoreDiacritics",new Integer(7));
        gParamHashSort.put("IgnoreHe",new Integer(8));
        gParamHashSort.put("LanguageID",new Integer(9));

    }
    /**
    * default constructor
    */
    public _Column()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _Column(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _Column(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1000,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1001,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1002,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return float
    */
    public float getWidth()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,3,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setWidth(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,3,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getIsFirst()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,4,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getIsLast()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,5,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @return int
    */
    public int getIndex()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,6,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Cells
    */
    public Cells getCells()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,100,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Cells ret = new Cells(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Borders
    */
    public Borders getBorders()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1100,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Borders ret = new Borders(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param arg1Borders
    * @param arg1Borders
    */
    public void setBorders(Borders arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1100,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Shading
    */
    public Shading getShading()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,102,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Shading ret = new Shading(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Column
    */
    public Column getNext()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,103,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Column ret = new Column(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Column
    */
    public Column getPrevious()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,104,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Column ret = new Column(retVar.toDispatch());
        return(ret);
    }

    /**
    */
    public void Select()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,65535,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void Delete()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,200,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ColumnWidthfloat
    * @param RulerStyleWdRulerStyleEnum
    * @param ColumnWidthfloat
    * @param RulerStyleWdRulerStyleEnum
    */
    public void SetWidth(float ColumnWidth,WdRulerStyleEnum RulerStyle)
    {
        Variant[] args = {new Variant(ColumnWidth),new Variant(RulerStyle.getValue())};
        invoke_method_void(args,201,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void AutoFit()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,202,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param CaseSensitiveObject[]
    * @param LanguageIDObject[]
    * @param ExcludeHeaderObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param CaseSensitiveObject[]
    * @param LanguageIDObject[]
    */
    public void SortOld(Object[] ExcludeHeader,Object[] SortFieldType,Object[] SortOrder,Object[] CaseSensitive,Object[] LanguageID)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(SortFieldType),new Variant(SortOrder),new Variant(CaseSensitive),new Variant(LanguageID)};
        invoke_method_void(args,203,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void SortOld(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashSortOld.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,203,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param CaseSensitiveObject[]
    * @param ExcludeHeaderObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param CaseSensitiveObject[]
    */
    public void SortOld(Object[] ExcludeHeader,Object[] SortFieldType,Object[] SortOrder,Object[] CaseSensitive)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(SortFieldType),new Variant(SortOrder),new Variant(CaseSensitive)};
        invoke_method_void(args,203,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param ExcludeHeaderObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    */
    public void SortOld(Object[] ExcludeHeader,Object[] SortFieldType,Object[] SortOrder)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(SortFieldType),new Variant(SortOrder)};
        invoke_method_void(args,203,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param SortFieldTypeObject[]
    * @param ExcludeHeaderObject[]
    * @param SortFieldTypeObject[]
    */
    public void SortOld(Object[] ExcludeHeader,Object[] SortFieldType)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(SortFieldType)};
        invoke_method_void(args,203,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param ExcludeHeaderObject[]
    */
    public void SortOld(Object[] ExcludeHeader)
    {
        Variant[] args = {new Variant(ExcludeHeader)};
        invoke_method_void(args,203,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void SortOld()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,203,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param IgnoreTheObject[]
    * @param IgnoreKashidaObject[]
    * @param IgnoreDiacriticsObject[]
    * @param IgnoreHeObject[]
    * @param LanguageIDObject[]
    * @param ExcludeHeaderObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param IgnoreTheObject[]
    * @param IgnoreKashidaObject[]
    * @param IgnoreDiacriticsObject[]
    * @param IgnoreHeObject[]
    * @param LanguageIDObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] SortFieldType,Object[] SortOrder,Object[] CaseSensitive,Object[] BidiSort,Object[] IgnoreThe,Object[] IgnoreKashida,Object[] IgnoreDiacritics,Object[] IgnoreHe,Object[] LanguageID)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(SortFieldType),new Variant(SortOrder),new Variant(CaseSensitive),new Variant(BidiSort),new Variant(IgnoreThe),new Variant(IgnoreKashida),new Variant(IgnoreDiacritics),new Variant(IgnoreHe),new Variant(LanguageID)};
        invoke_method_void(args,204,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void Sort(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashSort.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,204,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param IgnoreTheObject[]
    * @param IgnoreKashidaObject[]
    * @param IgnoreDiacriticsObject[]
    * @param IgnoreHeObject[]
    * @param ExcludeHeaderObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param IgnoreTheObject[]
    * @param IgnoreKashidaObject[]
    * @param IgnoreDiacriticsObject[]
    * @param IgnoreHeObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] SortFieldType,Object[] SortOrder,Object[] CaseSensitive,Object[] BidiSort,Object[] IgnoreThe,Object[] IgnoreKashida,Object[] IgnoreDiacritics,Object[] IgnoreHe)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(SortFieldType),new Variant(SortOrder),new Variant(CaseSensitive),new Variant(BidiSort),new Variant(IgnoreThe),new Variant(IgnoreKashida),new Variant(IgnoreDiacritics),new Variant(IgnoreHe)};
        invoke_method_void(args,204,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param IgnoreTheObject[]
    * @param IgnoreKashidaObject[]
    * @param IgnoreDiacriticsObject[]
    * @param ExcludeHeaderObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param IgnoreTheObject[]
    * @param IgnoreKashidaObject[]
    * @param IgnoreDiacriticsObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] SortFieldType,Object[] SortOrder,Object[] CaseSensitive,Object[] BidiSort,Object[] IgnoreThe,Object[] IgnoreKashida,Object[] IgnoreDiacritics)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(SortFieldType),new Variant(SortOrder),new Variant(CaseSensitive),new Variant(BidiSort),new Variant(IgnoreThe),new Variant(IgnoreKashida),new Variant(IgnoreDiacritics)};
        invoke_method_void(args,204,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param IgnoreTheObject[]
    * @param IgnoreKashidaObject[]
    * @param ExcludeHeaderObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param IgnoreTheObject[]
    * @param IgnoreKashidaObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] SortFieldType,Object[] SortOrder,Object[] CaseSensitive,Object[] BidiSort,Object[] IgnoreThe,Object[] IgnoreKashida)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(SortFieldType),new Variant(SortOrder),new Variant(CaseSensitive),new Variant(BidiSort),new Variant(IgnoreThe),new Variant(IgnoreKashida)};
        invoke_method_void(args,204,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param IgnoreTheObject[]
    * @param ExcludeHeaderObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param IgnoreTheObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] SortFieldType,Object[] SortOrder,Object[] CaseSensitive,Object[] BidiSort,Object[] IgnoreThe)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(SortFieldType),new Variant(SortOrder),new Variant(CaseSensitive),new Variant(BidiSort),new Variant(IgnoreThe)};
        invoke_method_void(args,204,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    * @param ExcludeHeaderObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param CaseSensitiveObject[]
    * @param BidiSortObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] SortFieldType,Object[] SortOrder,Object[] CaseSensitive,Object[] BidiSort)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(SortFieldType),new Variant(SortOrder),new Variant(CaseSensitive),new Variant(BidiSort)};
        invoke_method_void(args,204,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param CaseSensitiveObject[]
    * @param ExcludeHeaderObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param CaseSensitiveObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] SortFieldType,Object[] SortOrder,Object[] CaseSensitive)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(SortFieldType),new Variant(SortOrder),new Variant(CaseSensitive)};
        invoke_method_void(args,204,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    * @param ExcludeHeaderObject[]
    * @param SortFieldTypeObject[]
    * @param SortOrderObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] SortFieldType,Object[] SortOrder)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(SortFieldType),new Variant(SortOrder)};
        invoke_method_void(args,204,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param SortFieldTypeObject[]
    * @param ExcludeHeaderObject[]
    * @param SortFieldTypeObject[]
    */
    public void Sort(Object[] ExcludeHeader,Object[] SortFieldType)
    {
        Variant[] args = {new Variant(ExcludeHeader),new Variant(SortFieldType)};
        invoke_method_void(args,204,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExcludeHeaderObject[]
    * @param ExcludeHeaderObject[]
    */
    public void Sort(Object[] ExcludeHeader)
    {
        Variant[] args = {new Variant(ExcludeHeader)};
        invoke_method_void(args,204,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void Sort()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,204,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @return int
    */
    public int getNestingLevel()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,105,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return float
    */
    public float getPreferredWidth()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,106,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setPreferredWidth(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,106,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdPreferredWidthTypeEnum
    */
    public WdPreferredWidthTypeEnum getPreferredWidthType()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,107,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdPreferredWidthTypeEnum ret = WdPreferredWidthTypeEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdPreferredWidthTypeEnum
    * @param arg1WdPreferredWidthTypeEnum
    */
    public void setPreferredWidthType(WdPreferredWidthTypeEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,107,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

}
