package com.microsoft.word.gen;
import com.microsoft.word.*;
import com.microsoft.word.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object Documents
* DO NOT EDIT THIS CODE 
* EDIT the subclass Documents
* @author S Lewis
*/
public class _Documents extends WDispatch
{
    public static final String clsid = "{0002096C-0000-0000-C000-000000000046}";
    protected static Map gParamHashClose;
    protected static Map gParamHashOpenOld;
    protected static Map gParamHashAdd;
    protected static Map gParamHashOpen;
    // Static initializer
    // Used to initialize Hash Tables for named parameters
    static {
        gParamHashClose = new HashMap();
        gParamHashClose.put("SaveChanges",new Integer(0));
        gParamHashClose.put("OriginalFormat",new Integer(1));
        gParamHashClose.put("RouteDocument",new Integer(2));

        gParamHashOpenOld = new HashMap();
        gParamHashOpenOld.put("FileName",new Integer(0));
        gParamHashOpenOld.put("ConfirmConversions",new Integer(1));
        gParamHashOpenOld.put("ReadOnly",new Integer(2));
        gParamHashOpenOld.put("AddToRecentFiles",new Integer(3));
        gParamHashOpenOld.put("PasswordDocument",new Integer(4));
        gParamHashOpenOld.put("PasswordTemplate",new Integer(5));
        gParamHashOpenOld.put("Revert",new Integer(6));
        gParamHashOpenOld.put("WritePasswordDocument",new Integer(7));
        gParamHashOpenOld.put("WritePasswordTemplate",new Integer(8));
        gParamHashOpenOld.put("Format",new Integer(9));

        gParamHashAdd = new HashMap();
        gParamHashAdd.put("Template",new Integer(0));
        gParamHashAdd.put("NewTemplate",new Integer(1));
        gParamHashAdd.put("DocumentType",new Integer(2));
        gParamHashAdd.put("Visible",new Integer(3));

        gParamHashOpen = new HashMap();
        gParamHashOpen.put("FileName",new Integer(0));
        gParamHashOpen.put("ConfirmConversions",new Integer(1));
        gParamHashOpen.put("ReadOnly",new Integer(2));
        gParamHashOpen.put("AddToRecentFiles",new Integer(3));
        gParamHashOpen.put("PasswordDocument",new Integer(4));
        gParamHashOpen.put("PasswordTemplate",new Integer(5));
        gParamHashOpen.put("Revert",new Integer(6));
        gParamHashOpen.put("WritePasswordDocument",new Integer(7));
        gParamHashOpen.put("WritePasswordTemplate",new Integer(8));
        gParamHashOpen.put("Format",new Integer(9));
        gParamHashOpen.put("Encoding",new Integer(10));
        gParamHashOpen.put("Visible",new Integer(11));

    }
    /**
    * default constructor
    */
    public _Documents()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _Documents(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _Documents(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return IUnknown
    */
    public IUnknown ambig_get_NewEnum()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,-4,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        IUnknown ret = new IUnknown(retVar.toInt());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCount()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,2,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1000,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1001,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1002,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @param IndexObject[]
    * @param IndexObject[]
    * @return Document
    */
    public Document Item(Object[] Index)
    {
        Variant[] args = {new Variant(Index)};
        Variant retVar = invoke_method(args,0,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SaveChangesObject[]
    * @param OriginalFormatObject[]
    * @param RouteDocumentObject[]
    * @param SaveChangesObject[]
    * @param OriginalFormatObject[]
    * @param RouteDocumentObject[]
    */
    public void Close(Object[] SaveChanges,Object[] OriginalFormat,Object[] RouteDocument)
    {
        Variant[] args = {new Variant(SaveChanges),new Variant(OriginalFormat),new Variant(RouteDocument)};
        invoke_method_void(args,1105,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void Close(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashClose.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,1105,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param SaveChangesObject[]
    * @param OriginalFormatObject[]
    * @param SaveChangesObject[]
    * @param OriginalFormatObject[]
    */
    public void Close(Object[] SaveChanges,Object[] OriginalFormat)
    {
        Variant[] args = {new Variant(SaveChanges),new Variant(OriginalFormat)};
        invoke_method_void(args,1105,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param SaveChangesObject[]
    * @param SaveChangesObject[]
    */
    public void Close(Object[] SaveChanges)
    {
        Variant[] args = {new Variant(SaveChanges)};
        invoke_method_void(args,1105,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void Close()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,1105,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param TemplateObject[]
    * @param NewTemplateObject[]
    * @param TemplateObject[]
    * @param NewTemplateObject[]
    * @return Document
    */
    public Document AddOld(Object[] Template,Object[] NewTemplate)
    {
        Variant[] args = {new Variant(Template),new Variant(NewTemplate)};
        Variant retVar = invoke_method(args,11,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param TemplateObject[]
    * @param TemplateObject[]
    * @return Document
    */
    public Document AddOld(Object[] Template)
    {
        Variant[] args = {new Variant(Template)};
        Variant retVar = invoke_method(args,11,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Document
    */
    public Document AddOld()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,11,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param RevertObject[]
    * @param WritePasswordDocumentObject[]
    * @param WritePasswordTemplateObject[]
    * @param FormatObject[]
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param RevertObject[]
    * @param WritePasswordDocumentObject[]
    * @param WritePasswordTemplateObject[]
    * @param FormatObject[]
    * @return Document
    */
    public Document OpenOld(Object[] FileName,Object[] ConfirmConversions,Object[] ReadOnly,Object[] AddToRecentFiles,Object[] PasswordDocument,Object[] PasswordTemplate,Object[] Revert,Object[] WritePasswordDocument,Object[] WritePasswordTemplate,Object[] Format)
    {
        Variant[] args = {new Variant(FileName),new Variant(ConfirmConversions),new Variant(ReadOnly),new Variant(AddToRecentFiles),new Variant(PasswordDocument),new Variant(PasswordTemplate),new Variant(Revert),new Variant(WritePasswordDocument),new Variant(WritePasswordTemplate),new Variant(Format)};
        Variant retVar = invoke_method(args,12,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return Document
    */
    public Document OpenOld(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashOpenOld.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,12,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param RevertObject[]
    * @param WritePasswordDocumentObject[]
    * @param WritePasswordTemplateObject[]
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param RevertObject[]
    * @param WritePasswordDocumentObject[]
    * @param WritePasswordTemplateObject[]
    * @return Document
    */
    public Document OpenOld(Object[] FileName,Object[] ConfirmConversions,Object[] ReadOnly,Object[] AddToRecentFiles,Object[] PasswordDocument,Object[] PasswordTemplate,Object[] Revert,Object[] WritePasswordDocument,Object[] WritePasswordTemplate)
    {
        Variant[] args = {new Variant(FileName),new Variant(ConfirmConversions),new Variant(ReadOnly),new Variant(AddToRecentFiles),new Variant(PasswordDocument),new Variant(PasswordTemplate),new Variant(Revert),new Variant(WritePasswordDocument),new Variant(WritePasswordTemplate)};
        Variant retVar = invoke_method(args,12,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param RevertObject[]
    * @param WritePasswordDocumentObject[]
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param RevertObject[]
    * @param WritePasswordDocumentObject[]
    * @return Document
    */
    public Document OpenOld(Object[] FileName,Object[] ConfirmConversions,Object[] ReadOnly,Object[] AddToRecentFiles,Object[] PasswordDocument,Object[] PasswordTemplate,Object[] Revert,Object[] WritePasswordDocument)
    {
        Variant[] args = {new Variant(FileName),new Variant(ConfirmConversions),new Variant(ReadOnly),new Variant(AddToRecentFiles),new Variant(PasswordDocument),new Variant(PasswordTemplate),new Variant(Revert),new Variant(WritePasswordDocument)};
        Variant retVar = invoke_method(args,12,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param RevertObject[]
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param RevertObject[]
    * @return Document
    */
    public Document OpenOld(Object[] FileName,Object[] ConfirmConversions,Object[] ReadOnly,Object[] AddToRecentFiles,Object[] PasswordDocument,Object[] PasswordTemplate,Object[] Revert)
    {
        Variant[] args = {new Variant(FileName),new Variant(ConfirmConversions),new Variant(ReadOnly),new Variant(AddToRecentFiles),new Variant(PasswordDocument),new Variant(PasswordTemplate),new Variant(Revert)};
        Variant retVar = invoke_method(args,12,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @return Document
    */
    public Document OpenOld(Object[] FileName,Object[] ConfirmConversions,Object[] ReadOnly,Object[] AddToRecentFiles,Object[] PasswordDocument,Object[] PasswordTemplate)
    {
        Variant[] args = {new Variant(FileName),new Variant(ConfirmConversions),new Variant(ReadOnly),new Variant(AddToRecentFiles),new Variant(PasswordDocument),new Variant(PasswordTemplate)};
        Variant retVar = invoke_method(args,12,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @param PasswordDocumentObject[]
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @param PasswordDocumentObject[]
    * @return Document
    */
    public Document OpenOld(Object[] FileName,Object[] ConfirmConversions,Object[] ReadOnly,Object[] AddToRecentFiles,Object[] PasswordDocument)
    {
        Variant[] args = {new Variant(FileName),new Variant(ConfirmConversions),new Variant(ReadOnly),new Variant(AddToRecentFiles),new Variant(PasswordDocument)};
        Variant retVar = invoke_method(args,12,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @return Document
    */
    public Document OpenOld(Object[] FileName,Object[] ConfirmConversions,Object[] ReadOnly,Object[] AddToRecentFiles)
    {
        Variant[] args = {new Variant(FileName),new Variant(ConfirmConversions),new Variant(ReadOnly),new Variant(AddToRecentFiles)};
        Variant retVar = invoke_method(args,12,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @return Document
    */
    public Document OpenOld(Object[] FileName,Object[] ConfirmConversions,Object[] ReadOnly)
    {
        Variant[] args = {new Variant(FileName),new Variant(ConfirmConversions),new Variant(ReadOnly)};
        Variant retVar = invoke_method(args,12,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @return Document
    */
    public Document OpenOld(Object[] FileName,Object[] ConfirmConversions)
    {
        Variant[] args = {new Variant(FileName),new Variant(ConfirmConversions)};
        Variant retVar = invoke_method(args,12,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameObject[]
    * @param FileNameObject[]
    * @return Document
    */
    public Document OpenOld(Object[] FileName)
    {
        Variant[] args = {new Variant(FileName)};
        Variant retVar = invoke_method(args,12,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param NoPromptObject[]
    * @param OriginalFormatObject[]
    * @param NoPromptObject[]
    * @param OriginalFormatObject[]
    */
    public void Save(Object[] NoPrompt,Object[] OriginalFormat)
    {
        Variant[] args = {new Variant(NoPrompt),new Variant(OriginalFormat)};
        invoke_method_void(args,13,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param NoPromptObject[]
    * @param NoPromptObject[]
    */
    public void Save(Object[] NoPrompt)
    {
        Variant[] args = {new Variant(NoPrompt)};
        invoke_method_void(args,13,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void Save()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,13,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param TemplateObject[]
    * @param NewTemplateObject[]
    * @param DocumentTypeObject[]
    * @param VisibleObject[]
    * @param TemplateObject[]
    * @param NewTemplateObject[]
    * @param DocumentTypeObject[]
    * @param VisibleObject[]
    * @return Document
    */
    public Document Add(Object[] Template,Object[] NewTemplate,Object[] DocumentType,Object[] Visible)
    {
        Variant[] args = {new Variant(Template),new Variant(NewTemplate),new Variant(DocumentType),new Variant(Visible)};
        Variant retVar = invoke_method(args,14,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return Document
    */
    public Document Add(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashAdd.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,14,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param TemplateObject[]
    * @param NewTemplateObject[]
    * @param DocumentTypeObject[]
    * @param TemplateObject[]
    * @param NewTemplateObject[]
    * @param DocumentTypeObject[]
    * @return Document
    */
    public Document Add(Object[] Template,Object[] NewTemplate,Object[] DocumentType)
    {
        Variant[] args = {new Variant(Template),new Variant(NewTemplate),new Variant(DocumentType)};
        Variant retVar = invoke_method(args,14,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param TemplateObject[]
    * @param NewTemplateObject[]
    * @param TemplateObject[]
    * @param NewTemplateObject[]
    * @return Document
    */
    public Document Add(Object[] Template,Object[] NewTemplate)
    {
        Variant[] args = {new Variant(Template),new Variant(NewTemplate)};
        Variant retVar = invoke_method(args,14,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param TemplateObject[]
    * @param TemplateObject[]
    * @return Document
    */
    public Document Add(Object[] Template)
    {
        Variant[] args = {new Variant(Template)};
        Variant retVar = invoke_method(args,14,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Document
    */
    public Document Add()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,14,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param RevertObject[]
    * @param WritePasswordDocumentObject[]
    * @param WritePasswordTemplateObject[]
    * @param FormatObject[]
    * @param EncodingObject[]
    * @param VisibleObject[]
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param RevertObject[]
    * @param WritePasswordDocumentObject[]
    * @param WritePasswordTemplateObject[]
    * @param FormatObject[]
    * @param EncodingObject[]
    * @param VisibleObject[]
    * @return Document
    */
    public Document Open(Object[] FileName,Object[] ConfirmConversions,Object[] ReadOnly,Object[] AddToRecentFiles,Object[] PasswordDocument,Object[] PasswordTemplate,Object[] Revert,Object[] WritePasswordDocument,Object[] WritePasswordTemplate,Object[] Format,Object[] Encoding,Object[] Visible)
    {
        Variant[] args = {new Variant(FileName),new Variant(ConfirmConversions),new Variant(ReadOnly),new Variant(AddToRecentFiles),new Variant(PasswordDocument),new Variant(PasswordTemplate),new Variant(Revert),new Variant(WritePasswordDocument),new Variant(WritePasswordTemplate),new Variant(Format),new Variant(Encoding),new Variant(Visible)};
        Variant retVar = invoke_method(args,15,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return Document
    */
    public Document Open(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashOpen.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,15,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param RevertObject[]
    * @param WritePasswordDocumentObject[]
    * @param WritePasswordTemplateObject[]
    * @param FormatObject[]
    * @param EncodingObject[]
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param RevertObject[]
    * @param WritePasswordDocumentObject[]
    * @param WritePasswordTemplateObject[]
    * @param FormatObject[]
    * @param EncodingObject[]
    * @return Document
    */
    public Document Open(Object[] FileName,Object[] ConfirmConversions,Object[] ReadOnly,Object[] AddToRecentFiles,Object[] PasswordDocument,Object[] PasswordTemplate,Object[] Revert,Object[] WritePasswordDocument,Object[] WritePasswordTemplate,Object[] Format,Object[] Encoding)
    {
        Variant[] args = {new Variant(FileName),new Variant(ConfirmConversions),new Variant(ReadOnly),new Variant(AddToRecentFiles),new Variant(PasswordDocument),new Variant(PasswordTemplate),new Variant(Revert),new Variant(WritePasswordDocument),new Variant(WritePasswordTemplate),new Variant(Format),new Variant(Encoding)};
        Variant retVar = invoke_method(args,15,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param RevertObject[]
    * @param WritePasswordDocumentObject[]
    * @param WritePasswordTemplateObject[]
    * @param FormatObject[]
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param RevertObject[]
    * @param WritePasswordDocumentObject[]
    * @param WritePasswordTemplateObject[]
    * @param FormatObject[]
    * @return Document
    */
    public Document Open(Object[] FileName,Object[] ConfirmConversions,Object[] ReadOnly,Object[] AddToRecentFiles,Object[] PasswordDocument,Object[] PasswordTemplate,Object[] Revert,Object[] WritePasswordDocument,Object[] WritePasswordTemplate,Object[] Format)
    {
        Variant[] args = {new Variant(FileName),new Variant(ConfirmConversions),new Variant(ReadOnly),new Variant(AddToRecentFiles),new Variant(PasswordDocument),new Variant(PasswordTemplate),new Variant(Revert),new Variant(WritePasswordDocument),new Variant(WritePasswordTemplate),new Variant(Format)};
        Variant retVar = invoke_method(args,15,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param RevertObject[]
    * @param WritePasswordDocumentObject[]
    * @param WritePasswordTemplateObject[]
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param RevertObject[]
    * @param WritePasswordDocumentObject[]
    * @param WritePasswordTemplateObject[]
    * @return Document
    */
    public Document Open(Object[] FileName,Object[] ConfirmConversions,Object[] ReadOnly,Object[] AddToRecentFiles,Object[] PasswordDocument,Object[] PasswordTemplate,Object[] Revert,Object[] WritePasswordDocument,Object[] WritePasswordTemplate)
    {
        Variant[] args = {new Variant(FileName),new Variant(ConfirmConversions),new Variant(ReadOnly),new Variant(AddToRecentFiles),new Variant(PasswordDocument),new Variant(PasswordTemplate),new Variant(Revert),new Variant(WritePasswordDocument),new Variant(WritePasswordTemplate)};
        Variant retVar = invoke_method(args,15,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param RevertObject[]
    * @param WritePasswordDocumentObject[]
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param RevertObject[]
    * @param WritePasswordDocumentObject[]
    * @return Document
    */
    public Document Open(Object[] FileName,Object[] ConfirmConversions,Object[] ReadOnly,Object[] AddToRecentFiles,Object[] PasswordDocument,Object[] PasswordTemplate,Object[] Revert,Object[] WritePasswordDocument)
    {
        Variant[] args = {new Variant(FileName),new Variant(ConfirmConversions),new Variant(ReadOnly),new Variant(AddToRecentFiles),new Variant(PasswordDocument),new Variant(PasswordTemplate),new Variant(Revert),new Variant(WritePasswordDocument)};
        Variant retVar = invoke_method(args,15,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param RevertObject[]
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param RevertObject[]
    * @return Document
    */
    public Document Open(Object[] FileName,Object[] ConfirmConversions,Object[] ReadOnly,Object[] AddToRecentFiles,Object[] PasswordDocument,Object[] PasswordTemplate,Object[] Revert)
    {
        Variant[] args = {new Variant(FileName),new Variant(ConfirmConversions),new Variant(ReadOnly),new Variant(AddToRecentFiles),new Variant(PasswordDocument),new Variant(PasswordTemplate),new Variant(Revert)};
        Variant retVar = invoke_method(args,15,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @param PasswordDocumentObject[]
    * @param PasswordTemplateObject[]
    * @return Document
    */
    public Document Open(Object[] FileName,Object[] ConfirmConversions,Object[] ReadOnly,Object[] AddToRecentFiles,Object[] PasswordDocument,Object[] PasswordTemplate)
    {
        Variant[] args = {new Variant(FileName),new Variant(ConfirmConversions),new Variant(ReadOnly),new Variant(AddToRecentFiles),new Variant(PasswordDocument),new Variant(PasswordTemplate)};
        Variant retVar = invoke_method(args,15,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @param PasswordDocumentObject[]
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @param PasswordDocumentObject[]
    * @return Document
    */
    public Document Open(Object[] FileName,Object[] ConfirmConversions,Object[] ReadOnly,Object[] AddToRecentFiles,Object[] PasswordDocument)
    {
        Variant[] args = {new Variant(FileName),new Variant(ConfirmConversions),new Variant(ReadOnly),new Variant(AddToRecentFiles),new Variant(PasswordDocument)};
        Variant retVar = invoke_method(args,15,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param AddToRecentFilesObject[]
    * @return Document
    */
    public Document Open(Object[] FileName,Object[] ConfirmConversions,Object[] ReadOnly,Object[] AddToRecentFiles)
    {
        Variant[] args = {new Variant(FileName),new Variant(ConfirmConversions),new Variant(ReadOnly),new Variant(AddToRecentFiles)};
        Variant retVar = invoke_method(args,15,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param ReadOnlyObject[]
    * @return Document
    */
    public Document Open(Object[] FileName,Object[] ConfirmConversions,Object[] ReadOnly)
    {
        Variant[] args = {new Variant(FileName),new Variant(ConfirmConversions),new Variant(ReadOnly)};
        Variant retVar = invoke_method(args,15,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @param FileNameObject[]
    * @param ConfirmConversionsObject[]
    * @return Document
    */
    public Document Open(Object[] FileName,Object[] ConfirmConversions)
    {
        Variant[] args = {new Variant(FileName),new Variant(ConfirmConversions)};
        Variant retVar = invoke_method(args,15,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameObject[]
    * @param FileNameObject[]
    * @return Document
    */
    public Document Open(Object[] FileName)
    {
        Variant[] args = {new Variant(FileName)};
        Variant retVar = invoke_method(args,15,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Document ret = new Document(retVar.toDispatch());
        return(ret);
    }

}
