package com.microsoft.word.gen;
import com.microsoft.word.*;
import com.microsoft.word.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object Envelope
* DO NOT EDIT THIS CODE 
* EDIT the subclass Envelope
* @author S Lewis
*/
public class _Envelope extends WDispatch
{
    public static final String clsid = "{00020918-0000-0000-C000-000000000046}";
    protected static Map gParamHashInsert;
    protected static Map gParamHashPrintOut;
    // Static initializer
    // Used to initialize Hash Tables for named parameters
    static {
        gParamHashInsert = new HashMap();
        gParamHashInsert.put("ExtractAddress",new Integer(0));
        gParamHashInsert.put("Address",new Integer(1));
        gParamHashInsert.put("AutoText",new Integer(2));
        gParamHashInsert.put("OmitReturnAddress",new Integer(3));
        gParamHashInsert.put("ReturnAddress",new Integer(4));
        gParamHashInsert.put("ReturnAutoText",new Integer(5));
        gParamHashInsert.put("PrintBarCode",new Integer(6));
        gParamHashInsert.put("PrintFIMA",new Integer(7));
        gParamHashInsert.put("Size",new Integer(8));
        gParamHashInsert.put("Height",new Integer(9));
        gParamHashInsert.put("Width",new Integer(10));
        gParamHashInsert.put("FeedSource",new Integer(11));
        gParamHashInsert.put("AddressFromLeft",new Integer(12));
        gParamHashInsert.put("AddressFromTop",new Integer(13));
        gParamHashInsert.put("ReturnAddressFromLeft",new Integer(14));
        gParamHashInsert.put("ReturnAddressFromTop",new Integer(15));
        gParamHashInsert.put("DefaultFaceUp",new Integer(16));
        gParamHashInsert.put("DefaultOrientation",new Integer(17));

        gParamHashPrintOut = new HashMap();
        gParamHashPrintOut.put("ExtractAddress",new Integer(0));
        gParamHashPrintOut.put("Address",new Integer(1));
        gParamHashPrintOut.put("AutoText",new Integer(2));
        gParamHashPrintOut.put("OmitReturnAddress",new Integer(3));
        gParamHashPrintOut.put("ReturnAddress",new Integer(4));
        gParamHashPrintOut.put("ReturnAutoText",new Integer(5));
        gParamHashPrintOut.put("PrintBarCode",new Integer(6));
        gParamHashPrintOut.put("PrintFIMA",new Integer(7));
        gParamHashPrintOut.put("Size",new Integer(8));
        gParamHashPrintOut.put("Height",new Integer(9));
        gParamHashPrintOut.put("Width",new Integer(10));
        gParamHashPrintOut.put("FeedSource",new Integer(11));
        gParamHashPrintOut.put("AddressFromLeft",new Integer(12));
        gParamHashPrintOut.put("AddressFromTop",new Integer(13));
        gParamHashPrintOut.put("ReturnAddressFromLeft",new Integer(14));
        gParamHashPrintOut.put("ReturnAddressFromTop",new Integer(15));
        gParamHashPrintOut.put("DefaultFaceUp",new Integer(16));
        gParamHashPrintOut.put("DefaultOrientation",new Integer(17));

    }
    /**
    * default constructor
    */
    public _Envelope()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _Envelope(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _Envelope(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1000,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1001,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1002,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return Range
    */
    public Range getAddress()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Range
    */
    public Range getReturnAddress()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,2,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getDefaultPrintBarCode()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,4,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setDefaultPrintBarCode(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,4,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getDefaultPrintFIMA()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,5,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setDefaultPrintFIMA(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,5,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getDefaultHeight()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,6,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setDefaultHeight(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,6,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getDefaultWidth()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,7,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setDefaultWidth(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,7,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getDefaultSize()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,0,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setDefaultSize(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,0,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getDefaultOmitReturnAddress()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,9,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setDefaultOmitReturnAddress(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,9,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdPaperTrayEnum
    */
    public WdPaperTrayEnum getFeedSource()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,12,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdPaperTrayEnum ret = WdPaperTrayEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdPaperTrayEnum
    * @param arg1WdPaperTrayEnum
    */
    public void setFeedSource(WdPaperTrayEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,12,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getAddressFromLeft()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,13,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setAddressFromLeft(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,13,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getAddressFromTop()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,14,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setAddressFromTop(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,14,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getReturnAddressFromLeft()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,15,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setReturnAddressFromLeft(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,15,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getReturnAddressFromTop()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,16,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setReturnAddressFromTop(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,16,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Style
    */
    public Style getAddressStyle()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,17,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Style ret = new Style(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Style
    */
    public Style getReturnAddressStyle()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,18,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Style ret = new Style(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return WdEnvelopeOrientationEnum
    */
    public WdEnvelopeOrientationEnum getDefaultOrientation()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,19,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdEnvelopeOrientationEnum ret = WdEnvelopeOrientationEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdEnvelopeOrientationEnum
    * @param arg1WdEnvelopeOrientationEnum
    */
    public void setDefaultOrientation(WdEnvelopeOrientationEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,19,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getDefaultFaceUp()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,20,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setDefaultFaceUp(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,20,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    * @param FeedSourceObject[]
    * @param AddressFromLeftObject[]
    * @param AddressFromTopObject[]
    * @param ReturnAddressFromLeftObject[]
    * @param ReturnAddressFromTopObject[]
    * @param DefaultFaceUpObject[]
    * @param DefaultOrientationObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    * @param FeedSourceObject[]
    * @param AddressFromLeftObject[]
    * @param AddressFromTopObject[]
    * @param ReturnAddressFromLeftObject[]
    * @param ReturnAddressFromTopObject[]
    * @param DefaultFaceUpObject[]
    * @param DefaultOrientationObject[]
    */
    public void Insert(Object[] ExtractAddress,Object[] Address,Object[] AutoText,Object[] OmitReturnAddress,Object[] ReturnAddress,Object[] ReturnAutoText,Object[] PrintBarCode,Object[] PrintFIMA,Object[] Size,Object[] Height,Object[] Width,Object[] FeedSource,Object[] AddressFromLeft,Object[] AddressFromTop,Object[] ReturnAddressFromLeft,Object[] ReturnAddressFromTop,Object[] DefaultFaceUp,Object[] DefaultOrientation)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText),new Variant(OmitReturnAddress),new Variant(ReturnAddress),new Variant(ReturnAutoText),new Variant(PrintBarCode),new Variant(PrintFIMA),new Variant(Size),new Variant(Height),new Variant(Width),new Variant(FeedSource),new Variant(AddressFromLeft),new Variant(AddressFromTop),new Variant(ReturnAddressFromLeft),new Variant(ReturnAddressFromTop),new Variant(DefaultFaceUp),new Variant(DefaultOrientation)};
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void Insert(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashInsert.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    * @param FeedSourceObject[]
    * @param AddressFromLeftObject[]
    * @param AddressFromTopObject[]
    * @param ReturnAddressFromLeftObject[]
    * @param ReturnAddressFromTopObject[]
    * @param DefaultFaceUpObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    * @param FeedSourceObject[]
    * @param AddressFromLeftObject[]
    * @param AddressFromTopObject[]
    * @param ReturnAddressFromLeftObject[]
    * @param ReturnAddressFromTopObject[]
    * @param DefaultFaceUpObject[]
    */
    public void Insert(Object[] ExtractAddress,Object[] Address,Object[] AutoText,Object[] OmitReturnAddress,Object[] ReturnAddress,Object[] ReturnAutoText,Object[] PrintBarCode,Object[] PrintFIMA,Object[] Size,Object[] Height,Object[] Width,Object[] FeedSource,Object[] AddressFromLeft,Object[] AddressFromTop,Object[] ReturnAddressFromLeft,Object[] ReturnAddressFromTop,Object[] DefaultFaceUp)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText),new Variant(OmitReturnAddress),new Variant(ReturnAddress),new Variant(ReturnAutoText),new Variant(PrintBarCode),new Variant(PrintFIMA),new Variant(Size),new Variant(Height),new Variant(Width),new Variant(FeedSource),new Variant(AddressFromLeft),new Variant(AddressFromTop),new Variant(ReturnAddressFromLeft),new Variant(ReturnAddressFromTop),new Variant(DefaultFaceUp)};
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    * @param FeedSourceObject[]
    * @param AddressFromLeftObject[]
    * @param AddressFromTopObject[]
    * @param ReturnAddressFromLeftObject[]
    * @param ReturnAddressFromTopObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    * @param FeedSourceObject[]
    * @param AddressFromLeftObject[]
    * @param AddressFromTopObject[]
    * @param ReturnAddressFromLeftObject[]
    * @param ReturnAddressFromTopObject[]
    */
    public void Insert(Object[] ExtractAddress,Object[] Address,Object[] AutoText,Object[] OmitReturnAddress,Object[] ReturnAddress,Object[] ReturnAutoText,Object[] PrintBarCode,Object[] PrintFIMA,Object[] Size,Object[] Height,Object[] Width,Object[] FeedSource,Object[] AddressFromLeft,Object[] AddressFromTop,Object[] ReturnAddressFromLeft,Object[] ReturnAddressFromTop)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText),new Variant(OmitReturnAddress),new Variant(ReturnAddress),new Variant(ReturnAutoText),new Variant(PrintBarCode),new Variant(PrintFIMA),new Variant(Size),new Variant(Height),new Variant(Width),new Variant(FeedSource),new Variant(AddressFromLeft),new Variant(AddressFromTop),new Variant(ReturnAddressFromLeft),new Variant(ReturnAddressFromTop)};
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    * @param FeedSourceObject[]
    * @param AddressFromLeftObject[]
    * @param AddressFromTopObject[]
    * @param ReturnAddressFromLeftObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    * @param FeedSourceObject[]
    * @param AddressFromLeftObject[]
    * @param AddressFromTopObject[]
    * @param ReturnAddressFromLeftObject[]
    */
    public void Insert(Object[] ExtractAddress,Object[] Address,Object[] AutoText,Object[] OmitReturnAddress,Object[] ReturnAddress,Object[] ReturnAutoText,Object[] PrintBarCode,Object[] PrintFIMA,Object[] Size,Object[] Height,Object[] Width,Object[] FeedSource,Object[] AddressFromLeft,Object[] AddressFromTop,Object[] ReturnAddressFromLeft)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText),new Variant(OmitReturnAddress),new Variant(ReturnAddress),new Variant(ReturnAutoText),new Variant(PrintBarCode),new Variant(PrintFIMA),new Variant(Size),new Variant(Height),new Variant(Width),new Variant(FeedSource),new Variant(AddressFromLeft),new Variant(AddressFromTop),new Variant(ReturnAddressFromLeft)};
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    * @param FeedSourceObject[]
    * @param AddressFromLeftObject[]
    * @param AddressFromTopObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    * @param FeedSourceObject[]
    * @param AddressFromLeftObject[]
    * @param AddressFromTopObject[]
    */
    public void Insert(Object[] ExtractAddress,Object[] Address,Object[] AutoText,Object[] OmitReturnAddress,Object[] ReturnAddress,Object[] ReturnAutoText,Object[] PrintBarCode,Object[] PrintFIMA,Object[] Size,Object[] Height,Object[] Width,Object[] FeedSource,Object[] AddressFromLeft,Object[] AddressFromTop)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText),new Variant(OmitReturnAddress),new Variant(ReturnAddress),new Variant(ReturnAutoText),new Variant(PrintBarCode),new Variant(PrintFIMA),new Variant(Size),new Variant(Height),new Variant(Width),new Variant(FeedSource),new Variant(AddressFromLeft),new Variant(AddressFromTop)};
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    * @param FeedSourceObject[]
    * @param AddressFromLeftObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    * @param FeedSourceObject[]
    * @param AddressFromLeftObject[]
    */
    public void Insert(Object[] ExtractAddress,Object[] Address,Object[] AutoText,Object[] OmitReturnAddress,Object[] ReturnAddress,Object[] ReturnAutoText,Object[] PrintBarCode,Object[] PrintFIMA,Object[] Size,Object[] Height,Object[] Width,Object[] FeedSource,Object[] AddressFromLeft)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText),new Variant(OmitReturnAddress),new Variant(ReturnAddress),new Variant(ReturnAutoText),new Variant(PrintBarCode),new Variant(PrintFIMA),new Variant(Size),new Variant(Height),new Variant(Width),new Variant(FeedSource),new Variant(AddressFromLeft)};
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    * @param FeedSourceObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    * @param FeedSourceObject[]
    */
    public void Insert(Object[] ExtractAddress,Object[] Address,Object[] AutoText,Object[] OmitReturnAddress,Object[] ReturnAddress,Object[] ReturnAutoText,Object[] PrintBarCode,Object[] PrintFIMA,Object[] Size,Object[] Height,Object[] Width,Object[] FeedSource)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText),new Variant(OmitReturnAddress),new Variant(ReturnAddress),new Variant(ReturnAutoText),new Variant(PrintBarCode),new Variant(PrintFIMA),new Variant(Size),new Variant(Height),new Variant(Width),new Variant(FeedSource)};
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    */
    public void Insert(Object[] ExtractAddress,Object[] Address,Object[] AutoText,Object[] OmitReturnAddress,Object[] ReturnAddress,Object[] ReturnAutoText,Object[] PrintBarCode,Object[] PrintFIMA,Object[] Size,Object[] Height,Object[] Width)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText),new Variant(OmitReturnAddress),new Variant(ReturnAddress),new Variant(ReturnAutoText),new Variant(PrintBarCode),new Variant(PrintFIMA),new Variant(Size),new Variant(Height),new Variant(Width)};
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    */
    public void Insert(Object[] ExtractAddress,Object[] Address,Object[] AutoText,Object[] OmitReturnAddress,Object[] ReturnAddress,Object[] ReturnAutoText,Object[] PrintBarCode,Object[] PrintFIMA,Object[] Size,Object[] Height)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText),new Variant(OmitReturnAddress),new Variant(ReturnAddress),new Variant(ReturnAutoText),new Variant(PrintBarCode),new Variant(PrintFIMA),new Variant(Size),new Variant(Height)};
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    */
    public void Insert(Object[] ExtractAddress,Object[] Address,Object[] AutoText,Object[] OmitReturnAddress,Object[] ReturnAddress,Object[] ReturnAutoText,Object[] PrintBarCode,Object[] PrintFIMA,Object[] Size)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText),new Variant(OmitReturnAddress),new Variant(ReturnAddress),new Variant(ReturnAutoText),new Variant(PrintBarCode),new Variant(PrintFIMA),new Variant(Size)};
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    */
    public void Insert(Object[] ExtractAddress,Object[] Address,Object[] AutoText,Object[] OmitReturnAddress,Object[] ReturnAddress,Object[] ReturnAutoText,Object[] PrintBarCode,Object[] PrintFIMA)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText),new Variant(OmitReturnAddress),new Variant(ReturnAddress),new Variant(ReturnAutoText),new Variant(PrintBarCode),new Variant(PrintFIMA)};
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    */
    public void Insert(Object[] ExtractAddress,Object[] Address,Object[] AutoText,Object[] OmitReturnAddress,Object[] ReturnAddress,Object[] ReturnAutoText,Object[] PrintBarCode)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText),new Variant(OmitReturnAddress),new Variant(ReturnAddress),new Variant(ReturnAutoText),new Variant(PrintBarCode)};
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    */
    public void Insert(Object[] ExtractAddress,Object[] Address,Object[] AutoText,Object[] OmitReturnAddress,Object[] ReturnAddress,Object[] ReturnAutoText)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText),new Variant(OmitReturnAddress),new Variant(ReturnAddress),new Variant(ReturnAutoText)};
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    */
    public void Insert(Object[] ExtractAddress,Object[] Address,Object[] AutoText,Object[] OmitReturnAddress,Object[] ReturnAddress)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText),new Variant(OmitReturnAddress),new Variant(ReturnAddress)};
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    */
    public void Insert(Object[] ExtractAddress,Object[] Address,Object[] AutoText,Object[] OmitReturnAddress)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText),new Variant(OmitReturnAddress)};
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    */
    public void Insert(Object[] ExtractAddress,Object[] Address,Object[] AutoText)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText)};
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    */
    public void Insert(Object[] ExtractAddress,Object[] Address)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address)};
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param ExtractAddressObject[]
    */
    public void Insert(Object[] ExtractAddress)
    {
        Variant[] args = {new Variant(ExtractAddress)};
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void Insert()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    * @param FeedSourceObject[]
    * @param AddressFromLeftObject[]
    * @param AddressFromTopObject[]
    * @param ReturnAddressFromLeftObject[]
    * @param ReturnAddressFromTopObject[]
    * @param DefaultFaceUpObject[]
    * @param DefaultOrientationObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    * @param FeedSourceObject[]
    * @param AddressFromLeftObject[]
    * @param AddressFromTopObject[]
    * @param ReturnAddressFromLeftObject[]
    * @param ReturnAddressFromTopObject[]
    * @param DefaultFaceUpObject[]
    * @param DefaultOrientationObject[]
    */
    public void PrintOut(Object[] ExtractAddress,Object[] Address,Object[] AutoText,Object[] OmitReturnAddress,Object[] ReturnAddress,Object[] ReturnAutoText,Object[] PrintBarCode,Object[] PrintFIMA,Object[] Size,Object[] Height,Object[] Width,Object[] FeedSource,Object[] AddressFromLeft,Object[] AddressFromTop,Object[] ReturnAddressFromLeft,Object[] ReturnAddressFromTop,Object[] DefaultFaceUp,Object[] DefaultOrientation)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText),new Variant(OmitReturnAddress),new Variant(ReturnAddress),new Variant(ReturnAutoText),new Variant(PrintBarCode),new Variant(PrintFIMA),new Variant(Size),new Variant(Height),new Variant(Width),new Variant(FeedSource),new Variant(AddressFromLeft),new Variant(AddressFromTop),new Variant(ReturnAddressFromLeft),new Variant(ReturnAddressFromTop),new Variant(DefaultFaceUp),new Variant(DefaultOrientation)};
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void PrintOut(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashPrintOut.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    * @param FeedSourceObject[]
    * @param AddressFromLeftObject[]
    * @param AddressFromTopObject[]
    * @param ReturnAddressFromLeftObject[]
    * @param ReturnAddressFromTopObject[]
    * @param DefaultFaceUpObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    * @param FeedSourceObject[]
    * @param AddressFromLeftObject[]
    * @param AddressFromTopObject[]
    * @param ReturnAddressFromLeftObject[]
    * @param ReturnAddressFromTopObject[]
    * @param DefaultFaceUpObject[]
    */
    public void PrintOut(Object[] ExtractAddress,Object[] Address,Object[] AutoText,Object[] OmitReturnAddress,Object[] ReturnAddress,Object[] ReturnAutoText,Object[] PrintBarCode,Object[] PrintFIMA,Object[] Size,Object[] Height,Object[] Width,Object[] FeedSource,Object[] AddressFromLeft,Object[] AddressFromTop,Object[] ReturnAddressFromLeft,Object[] ReturnAddressFromTop,Object[] DefaultFaceUp)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText),new Variant(OmitReturnAddress),new Variant(ReturnAddress),new Variant(ReturnAutoText),new Variant(PrintBarCode),new Variant(PrintFIMA),new Variant(Size),new Variant(Height),new Variant(Width),new Variant(FeedSource),new Variant(AddressFromLeft),new Variant(AddressFromTop),new Variant(ReturnAddressFromLeft),new Variant(ReturnAddressFromTop),new Variant(DefaultFaceUp)};
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    * @param FeedSourceObject[]
    * @param AddressFromLeftObject[]
    * @param AddressFromTopObject[]
    * @param ReturnAddressFromLeftObject[]
    * @param ReturnAddressFromTopObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    * @param FeedSourceObject[]
    * @param AddressFromLeftObject[]
    * @param AddressFromTopObject[]
    * @param ReturnAddressFromLeftObject[]
    * @param ReturnAddressFromTopObject[]
    */
    public void PrintOut(Object[] ExtractAddress,Object[] Address,Object[] AutoText,Object[] OmitReturnAddress,Object[] ReturnAddress,Object[] ReturnAutoText,Object[] PrintBarCode,Object[] PrintFIMA,Object[] Size,Object[] Height,Object[] Width,Object[] FeedSource,Object[] AddressFromLeft,Object[] AddressFromTop,Object[] ReturnAddressFromLeft,Object[] ReturnAddressFromTop)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText),new Variant(OmitReturnAddress),new Variant(ReturnAddress),new Variant(ReturnAutoText),new Variant(PrintBarCode),new Variant(PrintFIMA),new Variant(Size),new Variant(Height),new Variant(Width),new Variant(FeedSource),new Variant(AddressFromLeft),new Variant(AddressFromTop),new Variant(ReturnAddressFromLeft),new Variant(ReturnAddressFromTop)};
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    * @param FeedSourceObject[]
    * @param AddressFromLeftObject[]
    * @param AddressFromTopObject[]
    * @param ReturnAddressFromLeftObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    * @param FeedSourceObject[]
    * @param AddressFromLeftObject[]
    * @param AddressFromTopObject[]
    * @param ReturnAddressFromLeftObject[]
    */
    public void PrintOut(Object[] ExtractAddress,Object[] Address,Object[] AutoText,Object[] OmitReturnAddress,Object[] ReturnAddress,Object[] ReturnAutoText,Object[] PrintBarCode,Object[] PrintFIMA,Object[] Size,Object[] Height,Object[] Width,Object[] FeedSource,Object[] AddressFromLeft,Object[] AddressFromTop,Object[] ReturnAddressFromLeft)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText),new Variant(OmitReturnAddress),new Variant(ReturnAddress),new Variant(ReturnAutoText),new Variant(PrintBarCode),new Variant(PrintFIMA),new Variant(Size),new Variant(Height),new Variant(Width),new Variant(FeedSource),new Variant(AddressFromLeft),new Variant(AddressFromTop),new Variant(ReturnAddressFromLeft)};
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    * @param FeedSourceObject[]
    * @param AddressFromLeftObject[]
    * @param AddressFromTopObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    * @param FeedSourceObject[]
    * @param AddressFromLeftObject[]
    * @param AddressFromTopObject[]
    */
    public void PrintOut(Object[] ExtractAddress,Object[] Address,Object[] AutoText,Object[] OmitReturnAddress,Object[] ReturnAddress,Object[] ReturnAutoText,Object[] PrintBarCode,Object[] PrintFIMA,Object[] Size,Object[] Height,Object[] Width,Object[] FeedSource,Object[] AddressFromLeft,Object[] AddressFromTop)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText),new Variant(OmitReturnAddress),new Variant(ReturnAddress),new Variant(ReturnAutoText),new Variant(PrintBarCode),new Variant(PrintFIMA),new Variant(Size),new Variant(Height),new Variant(Width),new Variant(FeedSource),new Variant(AddressFromLeft),new Variant(AddressFromTop)};
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    * @param FeedSourceObject[]
    * @param AddressFromLeftObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    * @param FeedSourceObject[]
    * @param AddressFromLeftObject[]
    */
    public void PrintOut(Object[] ExtractAddress,Object[] Address,Object[] AutoText,Object[] OmitReturnAddress,Object[] ReturnAddress,Object[] ReturnAutoText,Object[] PrintBarCode,Object[] PrintFIMA,Object[] Size,Object[] Height,Object[] Width,Object[] FeedSource,Object[] AddressFromLeft)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText),new Variant(OmitReturnAddress),new Variant(ReturnAddress),new Variant(ReturnAutoText),new Variant(PrintBarCode),new Variant(PrintFIMA),new Variant(Size),new Variant(Height),new Variant(Width),new Variant(FeedSource),new Variant(AddressFromLeft)};
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    * @param FeedSourceObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    * @param FeedSourceObject[]
    */
    public void PrintOut(Object[] ExtractAddress,Object[] Address,Object[] AutoText,Object[] OmitReturnAddress,Object[] ReturnAddress,Object[] ReturnAutoText,Object[] PrintBarCode,Object[] PrintFIMA,Object[] Size,Object[] Height,Object[] Width,Object[] FeedSource)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText),new Variant(OmitReturnAddress),new Variant(ReturnAddress),new Variant(ReturnAutoText),new Variant(PrintBarCode),new Variant(PrintFIMA),new Variant(Size),new Variant(Height),new Variant(Width),new Variant(FeedSource)};
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param WidthObject[]
    */
    public void PrintOut(Object[] ExtractAddress,Object[] Address,Object[] AutoText,Object[] OmitReturnAddress,Object[] ReturnAddress,Object[] ReturnAutoText,Object[] PrintBarCode,Object[] PrintFIMA,Object[] Size,Object[] Height,Object[] Width)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText),new Variant(OmitReturnAddress),new Variant(ReturnAddress),new Variant(ReturnAutoText),new Variant(PrintBarCode),new Variant(PrintFIMA),new Variant(Size),new Variant(Height),new Variant(Width)};
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param HeightObject[]
    */
    public void PrintOut(Object[] ExtractAddress,Object[] Address,Object[] AutoText,Object[] OmitReturnAddress,Object[] ReturnAddress,Object[] ReturnAutoText,Object[] PrintBarCode,Object[] PrintFIMA,Object[] Size,Object[] Height)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText),new Variant(OmitReturnAddress),new Variant(ReturnAddress),new Variant(ReturnAutoText),new Variant(PrintBarCode),new Variant(PrintFIMA),new Variant(Size),new Variant(Height)};
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param SizeObject[]
    */
    public void PrintOut(Object[] ExtractAddress,Object[] Address,Object[] AutoText,Object[] OmitReturnAddress,Object[] ReturnAddress,Object[] ReturnAutoText,Object[] PrintBarCode,Object[] PrintFIMA,Object[] Size)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText),new Variant(OmitReturnAddress),new Variant(ReturnAddress),new Variant(ReturnAutoText),new Variant(PrintBarCode),new Variant(PrintFIMA),new Variant(Size)};
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param PrintFIMAObject[]
    */
    public void PrintOut(Object[] ExtractAddress,Object[] Address,Object[] AutoText,Object[] OmitReturnAddress,Object[] ReturnAddress,Object[] ReturnAutoText,Object[] PrintBarCode,Object[] PrintFIMA)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText),new Variant(OmitReturnAddress),new Variant(ReturnAddress),new Variant(ReturnAutoText),new Variant(PrintBarCode),new Variant(PrintFIMA)};
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param PrintBarCodeObject[]
    */
    public void PrintOut(Object[] ExtractAddress,Object[] Address,Object[] AutoText,Object[] OmitReturnAddress,Object[] ReturnAddress,Object[] ReturnAutoText,Object[] PrintBarCode)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText),new Variant(OmitReturnAddress),new Variant(ReturnAddress),new Variant(ReturnAutoText),new Variant(PrintBarCode)};
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ReturnAutoTextObject[]
    */
    public void PrintOut(Object[] ExtractAddress,Object[] Address,Object[] AutoText,Object[] OmitReturnAddress,Object[] ReturnAddress,Object[] ReturnAutoText)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText),new Variant(OmitReturnAddress),new Variant(ReturnAddress),new Variant(ReturnAutoText)};
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ReturnAddressObject[]
    */
    public void PrintOut(Object[] ExtractAddress,Object[] Address,Object[] AutoText,Object[] OmitReturnAddress,Object[] ReturnAddress)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText),new Variant(OmitReturnAddress),new Variant(ReturnAddress)};
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param OmitReturnAddressObject[]
    */
    public void PrintOut(Object[] ExtractAddress,Object[] Address,Object[] AutoText,Object[] OmitReturnAddress)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText),new Variant(OmitReturnAddress)};
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param AutoTextObject[]
    */
    public void PrintOut(Object[] ExtractAddress,Object[] Address,Object[] AutoText)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address),new Variant(AutoText)};
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    * @param ExtractAddressObject[]
    * @param AddressObject[]
    */
    public void PrintOut(Object[] ExtractAddress,Object[] Address)
    {
        Variant[] args = {new Variant(ExtractAddress),new Variant(Address)};
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ExtractAddressObject[]
    * @param ExtractAddressObject[]
    */
    public void PrintOut(Object[] ExtractAddress)
    {
        Variant[] args = {new Variant(ExtractAddress)};
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void PrintOut()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void UpdateDocument()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,103,DispatchConstants.DISPATCH_METHOD);
    }

}
