package com.microsoft.word.gen;
import com.microsoft.word.*;
import com.microsoft.word.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object Frame
* DO NOT EDIT THIS CODE 
* EDIT the subclass Frame
* @author S Lewis
*/
public class _Frame extends WDispatch
{
    public static final String clsid = "{0002092A-0000-0000-C000-000000000046}";
    /**
    * default constructor
    */
    public _Frame()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _Frame(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _Frame(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1000,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1001,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1002,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return WdFrameSizeRuleEnum
    */
    public WdFrameSizeRuleEnum getHeightRule()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdFrameSizeRuleEnum ret = WdFrameSizeRuleEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdFrameSizeRuleEnum
    * @param arg1WdFrameSizeRuleEnum
    */
    public void setHeightRule(WdFrameSizeRuleEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,1,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdFrameSizeRuleEnum
    */
    public WdFrameSizeRuleEnum getWidthRule()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,2,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdFrameSizeRuleEnum ret = WdFrameSizeRuleEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdFrameSizeRuleEnum
    * @param arg1WdFrameSizeRuleEnum
    */
    public void setWidthRule(WdFrameSizeRuleEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,2,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getHorizontalDistanceFromText()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,3,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setHorizontalDistanceFromText(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,3,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getHeight()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,4,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setHeight(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,4,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getHorizontalPosition()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,5,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setHorizontalPosition(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,5,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getLockAnchor()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,6,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setLockAnchor(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,6,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdRelativeHorizontalPositionEnum
    */
    public WdRelativeHorizontalPositionEnum getRelativeHorizontalPosition()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,7,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdRelativeHorizontalPositionEnum ret = WdRelativeHorizontalPositionEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdRelativeHorizontalPositionEnum
    * @param arg1WdRelativeHorizontalPositionEnum
    */
    public void setRelativeHorizontalPosition(WdRelativeHorizontalPositionEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,7,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdRelativeVerticalPositionEnum
    */
    public WdRelativeVerticalPositionEnum getRelativeVerticalPosition()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,8,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdRelativeVerticalPositionEnum ret = WdRelativeVerticalPositionEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdRelativeVerticalPositionEnum
    * @param arg1WdRelativeVerticalPositionEnum
    */
    public void setRelativeVerticalPosition(WdRelativeVerticalPositionEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,8,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getVerticalDistanceFromText()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,9,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setVerticalDistanceFromText(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,9,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getVerticalPosition()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,10,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setVerticalPosition(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,10,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getWidth()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,11,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setWidth(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,11,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getTextWrap()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,12,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setTextWrap(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,12,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Shading
    */
    public Shading getShading()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,13,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Shading ret = new Shading(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Borders
    */
    public Borders getBorders()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1100,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Borders ret = new Borders(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param arg1Borders
    * @param arg1Borders
    */
    public void setBorders(Borders arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1100,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Range
    */
    public Range getRange()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,15,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    */
    public void Delete()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,100,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void Select()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,65535,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void Copy()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void Cut()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

}
