package com.microsoft.word.gen;
import com.microsoft.word.*;
import com.microsoft.word.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object Hyperlinks
* DO NOT EDIT THIS CODE 
* EDIT the subclass Hyperlinks
* @author S Lewis
*/
public class _Hyperlinks extends WDispatch
{
    public static final String clsid = "{0002099C-0000-0000-C000-000000000046}";
    protected static Map gParamHashAdd;
    // Static initializer
    // Used to initialize Hash Tables for named parameters
    static {
        gParamHashAdd = new HashMap();
        gParamHashAdd.put("Anchor",new Integer(0));
        gParamHashAdd.put("Address",new Integer(1));
        gParamHashAdd.put("SubAddress",new Integer(2));
        gParamHashAdd.put("ScreenTip",new Integer(3));
        gParamHashAdd.put("TextToDisplay",new Integer(4));
        gParamHashAdd.put("Target",new Integer(5));

    }
    /**
    * default constructor
    */
    public _Hyperlinks()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _Hyperlinks(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _Hyperlinks(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1000,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1001,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1002,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return int
    */
    public int getCount()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return IUnknown
    */
    public IUnknown ambig_get_NewEnum()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,-4,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        IUnknown ret = new IUnknown(retVar.toInt());
        return(ret);
    }

    /**
    * @param IndexObject[]
    * @param IndexObject[]
    * @return Hyperlink
    */
    public Hyperlink Item(Object[] Index)
    {
        Variant[] args = {new Variant(Index)};
        Variant retVar = invoke_method(args,0,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Hyperlink ret = new Hyperlink(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param AnchorDispatch
    * @param AddressObject[]
    * @param SubAddressObject[]
    * @param AnchorDispatch
    * @param AddressObject[]
    * @param SubAddressObject[]
    * @return Hyperlink
    */
    public Hyperlink _Add(Dispatch Anchor,Object[] Address,Object[] SubAddress)
    {
        Variant[] args = {new Variant(Anchor),new Variant(Address),new Variant(SubAddress)};
        Variant retVar = invoke_method(args,100,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Hyperlink ret = new Hyperlink(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param AnchorDispatch
    * @param AddressObject[]
    * @param AnchorDispatch
    * @param AddressObject[]
    * @return Hyperlink
    */
    public Hyperlink _Add(Dispatch Anchor,Object[] Address)
    {
        Variant[] args = {new Variant(Anchor),new Variant(Address)};
        Variant retVar = invoke_method(args,100,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Hyperlink ret = new Hyperlink(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param AnchorDispatch
    * @param AnchorDispatch
    * @return Hyperlink
    */
    public Hyperlink _Add(Dispatch Anchor)
    {
        Variant[] args = {new Variant(Anchor)};
        Variant retVar = invoke_method(args,100,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Hyperlink ret = new Hyperlink(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param AnchorDispatch
    * @param AddressObject[]
    * @param SubAddressObject[]
    * @param ScreenTipObject[]
    * @param TextToDisplayObject[]
    * @param TargetObject[]
    * @param AnchorDispatch
    * @param AddressObject[]
    * @param SubAddressObject[]
    * @param ScreenTipObject[]
    * @param TextToDisplayObject[]
    * @param TargetObject[]
    * @return Hyperlink
    */
    public Hyperlink Add(Dispatch Anchor,Object[] Address,Object[] SubAddress,Object[] ScreenTip,Object[] TextToDisplay,Object[] Target)
    {
        Variant[] args = {new Variant(Anchor),new Variant(Address),new Variant(SubAddress),new Variant(ScreenTip),new Variant(TextToDisplay),new Variant(Target)};
        Variant retVar = invoke_method(args,101,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Hyperlink ret = new Hyperlink(retVar.toDispatch());
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return Hyperlink
    */
    public Hyperlink Add(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashAdd.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,101,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Hyperlink ret = new Hyperlink(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param AnchorDispatch
    * @param AddressObject[]
    * @param SubAddressObject[]
    * @param ScreenTipObject[]
    * @param TextToDisplayObject[]
    * @param AnchorDispatch
    * @param AddressObject[]
    * @param SubAddressObject[]
    * @param ScreenTipObject[]
    * @param TextToDisplayObject[]
    * @return Hyperlink
    */
    public Hyperlink Add(Dispatch Anchor,Object[] Address,Object[] SubAddress,Object[] ScreenTip,Object[] TextToDisplay)
    {
        Variant[] args = {new Variant(Anchor),new Variant(Address),new Variant(SubAddress),new Variant(ScreenTip),new Variant(TextToDisplay)};
        Variant retVar = invoke_method(args,101,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Hyperlink ret = new Hyperlink(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param AnchorDispatch
    * @param AddressObject[]
    * @param SubAddressObject[]
    * @param ScreenTipObject[]
    * @param AnchorDispatch
    * @param AddressObject[]
    * @param SubAddressObject[]
    * @param ScreenTipObject[]
    * @return Hyperlink
    */
    public Hyperlink Add(Dispatch Anchor,Object[] Address,Object[] SubAddress,Object[] ScreenTip)
    {
        Variant[] args = {new Variant(Anchor),new Variant(Address),new Variant(SubAddress),new Variant(ScreenTip)};
        Variant retVar = invoke_method(args,101,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Hyperlink ret = new Hyperlink(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param AnchorDispatch
    * @param AddressObject[]
    * @param SubAddressObject[]
    * @param AnchorDispatch
    * @param AddressObject[]
    * @param SubAddressObject[]
    * @return Hyperlink
    */
    public Hyperlink Add(Dispatch Anchor,Object[] Address,Object[] SubAddress)
    {
        Variant[] args = {new Variant(Anchor),new Variant(Address),new Variant(SubAddress)};
        Variant retVar = invoke_method(args,101,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Hyperlink ret = new Hyperlink(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param AnchorDispatch
    * @param AddressObject[]
    * @param AnchorDispatch
    * @param AddressObject[]
    * @return Hyperlink
    */
    public Hyperlink Add(Dispatch Anchor,Object[] Address)
    {
        Variant[] args = {new Variant(Anchor),new Variant(Address)};
        Variant retVar = invoke_method(args,101,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Hyperlink ret = new Hyperlink(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param AnchorDispatch
    * @param AnchorDispatch
    * @return Hyperlink
    */
    public Hyperlink Add(Dispatch Anchor)
    {
        Variant[] args = {new Variant(Anchor)};
        Variant retVar = invoke_method(args,101,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Hyperlink ret = new Hyperlink(retVar.toDispatch());
        return(ret);
    }

}
