package com.microsoft.word.gen;
import com.microsoft.word.*;
import com.microsoft.word.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object InlineShapes
* DO NOT EDIT THIS CODE 
* EDIT the subclass InlineShapes
* @author S Lewis
*/
public class _InlineShapes extends WDispatch
{
    public static final String clsid = "{000209A9-0000-0000-C000-000000000046}";
    protected static Map gParamHashAddPicture;
    protected static Map gParamHashAddOLEObject;
    // Static initializer
    // Used to initialize Hash Tables for named parameters
    static {
        gParamHashAddPicture = new HashMap();
        gParamHashAddPicture.put("FileName",new Integer(0));
        gParamHashAddPicture.put("LinkToFile",new Integer(1));
        gParamHashAddPicture.put("SaveWithDocument",new Integer(2));
        gParamHashAddPicture.put("Range",new Integer(3));

        gParamHashAddOLEObject = new HashMap();
        gParamHashAddOLEObject.put("ClassType",new Integer(0));
        gParamHashAddOLEObject.put("FileName",new Integer(1));
        gParamHashAddOLEObject.put("LinkToFile",new Integer(2));
        gParamHashAddOLEObject.put("DisplayAsIcon",new Integer(3));
        gParamHashAddOLEObject.put("IconFileName",new Integer(4));
        gParamHashAddOLEObject.put("IconIndex",new Integer(5));
        gParamHashAddOLEObject.put("IconLabel",new Integer(6));
        gParamHashAddOLEObject.put("Range",new Integer(7));

    }
    /**
    * default constructor
    */
    public _InlineShapes()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _InlineShapes(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _InlineShapes(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1000,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1001,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1002,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return int
    */
    public int getCount()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return IUnknown
    */
    public IUnknown ambig_get_NewEnum()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,-4,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        IUnknown ret = new IUnknown(retVar.toInt());
        return(ret);
    }

    /**
    * @param Indexint
    * @param Indexint
    * @return InlineShape
    */
    public InlineShape Item(int Index)
    {
        Variant[] args = {new Variant(Index)};
        Variant retVar = invoke_method(args,0,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        InlineShape ret = new InlineShape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameString
    * @param LinkToFileObject[]
    * @param SaveWithDocumentObject[]
    * @param RangeObject[]
    * @param FileNameString
    * @param LinkToFileObject[]
    * @param SaveWithDocumentObject[]
    * @param RangeObject[]
    * @return InlineShape
    */
    public InlineShape AddPicture(String FileName,Object[] LinkToFile,Object[] SaveWithDocument,Object[] Range)
    {
        Variant[] args = {new Variant(FileName),new Variant(LinkToFile),new Variant(SaveWithDocument),new Variant(Range)};
        Variant retVar = invoke_method(args,100,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        InlineShape ret = new InlineShape(retVar.toDispatch());
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return InlineShape
    */
    public InlineShape AddPicture(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashAddPicture.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,100,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        InlineShape ret = new InlineShape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameString
    * @param LinkToFileObject[]
    * @param SaveWithDocumentObject[]
    * @param FileNameString
    * @param LinkToFileObject[]
    * @param SaveWithDocumentObject[]
    * @return InlineShape
    */
    public InlineShape AddPicture(String FileName,Object[] LinkToFile,Object[] SaveWithDocument)
    {
        Variant[] args = {new Variant(FileName),new Variant(LinkToFile),new Variant(SaveWithDocument)};
        Variant retVar = invoke_method(args,100,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        InlineShape ret = new InlineShape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameString
    * @param LinkToFileObject[]
    * @param FileNameString
    * @param LinkToFileObject[]
    * @return InlineShape
    */
    public InlineShape AddPicture(String FileName,Object[] LinkToFile)
    {
        Variant[] args = {new Variant(FileName),new Variant(LinkToFile)};
        Variant retVar = invoke_method(args,100,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        InlineShape ret = new InlineShape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameString
    * @param FileNameString
    * @return InlineShape
    */
    public InlineShape AddPicture(String FileName)
    {
        Variant[] args = {new Variant(FileName)};
        Variant retVar = invoke_method(args,100,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        InlineShape ret = new InlineShape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @param DisplayAsIconObject[]
    * @param IconFileNameObject[]
    * @param IconIndexObject[]
    * @param IconLabelObject[]
    * @param RangeObject[]
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @param DisplayAsIconObject[]
    * @param IconFileNameObject[]
    * @param IconIndexObject[]
    * @param IconLabelObject[]
    * @param RangeObject[]
    * @return InlineShape
    */
    public InlineShape AddOLEObject(Object[] ClassType,Object[] FileName,Object[] LinkToFile,Object[] DisplayAsIcon,Object[] IconFileName,Object[] IconIndex,Object[] IconLabel,Object[] Range)
    {
        Variant[] args = {new Variant(ClassType),new Variant(FileName),new Variant(LinkToFile),new Variant(DisplayAsIcon),new Variant(IconFileName),new Variant(IconIndex),new Variant(IconLabel),new Variant(Range)};
        Variant retVar = invoke_method(args,24,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        InlineShape ret = new InlineShape(retVar.toDispatch());
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return InlineShape
    */
    public InlineShape AddOLEObject(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashAddOLEObject.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,24,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        InlineShape ret = new InlineShape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @param DisplayAsIconObject[]
    * @param IconFileNameObject[]
    * @param IconIndexObject[]
    * @param IconLabelObject[]
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @param DisplayAsIconObject[]
    * @param IconFileNameObject[]
    * @param IconIndexObject[]
    * @param IconLabelObject[]
    * @return InlineShape
    */
    public InlineShape AddOLEObject(Object[] ClassType,Object[] FileName,Object[] LinkToFile,Object[] DisplayAsIcon,Object[] IconFileName,Object[] IconIndex,Object[] IconLabel)
    {
        Variant[] args = {new Variant(ClassType),new Variant(FileName),new Variant(LinkToFile),new Variant(DisplayAsIcon),new Variant(IconFileName),new Variant(IconIndex),new Variant(IconLabel)};
        Variant retVar = invoke_method(args,24,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        InlineShape ret = new InlineShape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @param DisplayAsIconObject[]
    * @param IconFileNameObject[]
    * @param IconIndexObject[]
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @param DisplayAsIconObject[]
    * @param IconFileNameObject[]
    * @param IconIndexObject[]
    * @return InlineShape
    */
    public InlineShape AddOLEObject(Object[] ClassType,Object[] FileName,Object[] LinkToFile,Object[] DisplayAsIcon,Object[] IconFileName,Object[] IconIndex)
    {
        Variant[] args = {new Variant(ClassType),new Variant(FileName),new Variant(LinkToFile),new Variant(DisplayAsIcon),new Variant(IconFileName),new Variant(IconIndex)};
        Variant retVar = invoke_method(args,24,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        InlineShape ret = new InlineShape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @param DisplayAsIconObject[]
    * @param IconFileNameObject[]
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @param DisplayAsIconObject[]
    * @param IconFileNameObject[]
    * @return InlineShape
    */
    public InlineShape AddOLEObject(Object[] ClassType,Object[] FileName,Object[] LinkToFile,Object[] DisplayAsIcon,Object[] IconFileName)
    {
        Variant[] args = {new Variant(ClassType),new Variant(FileName),new Variant(LinkToFile),new Variant(DisplayAsIcon),new Variant(IconFileName)};
        Variant retVar = invoke_method(args,24,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        InlineShape ret = new InlineShape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @param DisplayAsIconObject[]
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @param DisplayAsIconObject[]
    * @return InlineShape
    */
    public InlineShape AddOLEObject(Object[] ClassType,Object[] FileName,Object[] LinkToFile,Object[] DisplayAsIcon)
    {
        Variant[] args = {new Variant(ClassType),new Variant(FileName),new Variant(LinkToFile),new Variant(DisplayAsIcon)};
        Variant retVar = invoke_method(args,24,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        InlineShape ret = new InlineShape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param LinkToFileObject[]
    * @return InlineShape
    */
    public InlineShape AddOLEObject(Object[] ClassType,Object[] FileName,Object[] LinkToFile)
    {
        Variant[] args = {new Variant(ClassType),new Variant(FileName),new Variant(LinkToFile)};
        Variant retVar = invoke_method(args,24,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        InlineShape ret = new InlineShape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @param ClassTypeObject[]
    * @param FileNameObject[]
    * @return InlineShape
    */
    public InlineShape AddOLEObject(Object[] ClassType,Object[] FileName)
    {
        Variant[] args = {new Variant(ClassType),new Variant(FileName)};
        Variant retVar = invoke_method(args,24,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        InlineShape ret = new InlineShape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject[]
    * @param ClassTypeObject[]
    * @return InlineShape
    */
    public InlineShape AddOLEObject(Object[] ClassType)
    {
        Variant[] args = {new Variant(ClassType)};
        Variant retVar = invoke_method(args,24,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        InlineShape ret = new InlineShape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return InlineShape
    */
    public InlineShape AddOLEObject()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,24,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        InlineShape ret = new InlineShape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject[]
    * @param RangeObject[]
    * @param ClassTypeObject[]
    * @param RangeObject[]
    * @return InlineShape
    */
    public InlineShape AddOLEControl(Object[] ClassType,Object[] Range)
    {
        Variant[] args = {new Variant(ClassType),new Variant(Range)};
        Variant retVar = invoke_method(args,102,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        InlineShape ret = new InlineShape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param ClassTypeObject[]
    * @param ClassTypeObject[]
    * @return InlineShape
    */
    public InlineShape AddOLEControl(Object[] ClassType)
    {
        Variant[] args = {new Variant(ClassType)};
        Variant retVar = invoke_method(args,102,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        InlineShape ret = new InlineShape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return InlineShape
    */
    public InlineShape AddOLEControl()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,102,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        InlineShape ret = new InlineShape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param RangeRange
    * @param RangeRange
    * @return InlineShape
    */
    public InlineShape New(Range Range)
    {
        Variant[] args = {new Variant(Range)};
        Variant retVar = invoke_method(args,200,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        InlineShape ret = new InlineShape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameString
    * @param RangeObject[]
    * @param FileNameString
    * @param RangeObject[]
    * @return InlineShape
    */
    public InlineShape AddHorizontalLine(String FileName,Object[] Range)
    {
        Variant[] args = {new Variant(FileName),new Variant(Range)};
        Variant retVar = invoke_method(args,104,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        InlineShape ret = new InlineShape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameString
    * @param FileNameString
    * @return InlineShape
    */
    public InlineShape AddHorizontalLine(String FileName)
    {
        Variant[] args = {new Variant(FileName)};
        Variant retVar = invoke_method(args,104,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        InlineShape ret = new InlineShape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param RangeObject[]
    * @param RangeObject[]
    * @return InlineShape
    */
    public InlineShape AddHorizontalLineStandard(Object[] Range)
    {
        Variant[] args = {new Variant(Range)};
        Variant retVar = invoke_method(args,105,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        InlineShape ret = new InlineShape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return InlineShape
    */
    public InlineShape AddHorizontalLineStandard()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,105,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        InlineShape ret = new InlineShape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameString
    * @param RangeObject[]
    * @param FileNameString
    * @param RangeObject[]
    * @return InlineShape
    */
    public InlineShape AddPictureBullet(String FileName,Object[] Range)
    {
        Variant[] args = {new Variant(FileName),new Variant(Range)};
        Variant retVar = invoke_method(args,106,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        InlineShape ret = new InlineShape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param FileNameString
    * @param FileNameString
    * @return InlineShape
    */
    public InlineShape AddPictureBullet(String FileName)
    {
        Variant[] args = {new Variant(FileName)};
        Variant retVar = invoke_method(args,106,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        InlineShape ret = new InlineShape(retVar.toDispatch());
        return(ret);
    }

}
