package com.microsoft.word.gen;
import com.microsoft.word.*;
import com.microsoft.word.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object KeyBinding
* DO NOT EDIT THIS CODE 
* EDIT the subclass KeyBinding
* @author S Lewis
*/
public class _KeyBinding extends WDispatch
{
    public static final String clsid = "{00020998-0000-0000-C000-000000000046}";
    /**
    * default constructor
    */
    public _KeyBinding()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _KeyBinding(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _KeyBinding(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1000,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1001,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1002,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return String
    */
    public String getCommand()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @return String
    */
    public String getKeyString()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,2,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getProtected()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,3,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @return WdKeyCategoryEnum
    */
    public WdKeyCategoryEnum getKeyCategory()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,4,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdKeyCategoryEnum ret = WdKeyCategoryEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @return int
    */
    public int getKeyCode()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,6,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return int
    */
    public int getKeyCode2()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,7,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return String
    */
    public String getCommandParameter()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,8,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getContext()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,10,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    */
    public void Clear()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void Disable()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void Execute()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,103,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param KeyCategoryWdKeyCategoryEnum
    * @param CommandString
    * @param CommandParameterObject[]
    * @param KeyCategoryWdKeyCategoryEnum
    * @param CommandString
    * @param CommandParameterObject[]
    */
    public void Rebind(WdKeyCategoryEnum KeyCategory,String Command,Object[] CommandParameter)
    {
        Variant[] args = {new Variant(KeyCategory.getValue()),new Variant(Command),new Variant(CommandParameter)};
        invoke_method_void(args,104,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param KeyCategoryWdKeyCategoryEnum
    * @param CommandString
    * @param KeyCategoryWdKeyCategoryEnum
    * @param CommandString
    */
    public void Rebind(WdKeyCategoryEnum KeyCategory,String Command)
    {
        Variant[] args = {new Variant(KeyCategory.getValue()),new Variant(Command)};
        invoke_method_void(args,104,DispatchConstants.DISPATCH_METHOD);
    }

}
