package com.microsoft.word.gen;
import com.microsoft.word.*;
import com.microsoft.word.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object List
* DO NOT EDIT THIS CODE 
* EDIT the subclass List
* @author S Lewis
*/
public class _List extends WDispatch
{
    public static final String clsid = "{00020992-0000-0000-C000-000000000046}";
    /**
    * default constructor
    */
    public _List()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _List(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _List(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return Range
    */
    public Range getRange()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return ListParagraphs
    */
    public ListParagraphs getListParagraphs()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,2,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        ListParagraphs ret = new ListParagraphs(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getSingleListTemplate()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,3,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1000,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1001,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1002,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @param NumberTypeObject[]
    * @param NumberTypeObject[]
    */
    public void ConvertNumbersToText(Object[] NumberType)
    {
        Variant[] args = {new Variant(NumberType)};
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void ConvertNumbersToText()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param NumberTypeObject[]
    * @param NumberTypeObject[]
    */
    public void RemoveNumbers(Object[] NumberType)
    {
        Variant[] args = {new Variant(NumberType)};
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void RemoveNumbers()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param NumberTypeObject[]
    * @param LevelObject[]
    * @param NumberTypeObject[]
    * @param LevelObject[]
    * @return int
    */
    public int CountNumberedItems(Object[] NumberType,Object[] Level)
    {
        Variant[] args = {new Variant(NumberType),new Variant(Level)};
        Variant retVar = invoke_method(args,103,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param NumberTypeObject[]
    * @param NumberTypeObject[]
    * @return int
    */
    public int CountNumberedItems(Object[] NumberType)
    {
        Variant[] args = {new Variant(NumberType)};
        Variant retVar = invoke_method(args,103,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return int
    */
    public int CountNumberedItems()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,103,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param ListTemplateListTemplate
    * @param ContinuePreviousListObject[]
    * @param ListTemplateListTemplate
    * @param ContinuePreviousListObject[]
    */
    public void ApplyListTemplateOld(ListTemplate ListTemplate,Object[] ContinuePreviousList)
    {
        Variant[] args = {new Variant(ListTemplate),new Variant(ContinuePreviousList)};
        invoke_method_void(args,104,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ListTemplateListTemplate
    * @param ListTemplateListTemplate
    */
    public void ApplyListTemplateOld(ListTemplate ListTemplate)
    {
        Variant[] args = {new Variant(ListTemplate)};
        invoke_method_void(args,104,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ListTemplateListTemplate
    * @param ListTemplateListTemplate
    * @return WdContinueEnum
    */
    public WdContinueEnum CanContinuePreviousList(ListTemplate ListTemplate)
    {
        Variant[] args = {new Variant(ListTemplate)};
        Variant retVar = invoke_method(args,105,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        WdContinueEnum ret = WdContinueEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param ListTemplateListTemplate
    * @param ContinuePreviousListObject[]
    * @param DefaultListBehaviorObject[]
    * @param ListTemplateListTemplate
    * @param ContinuePreviousListObject[]
    * @param DefaultListBehaviorObject[]
    */
    public void ApplyListTemplate(ListTemplate ListTemplate,Object[] ContinuePreviousList,Object[] DefaultListBehavior)
    {
        Variant[] args = {new Variant(ListTemplate),new Variant(ContinuePreviousList),new Variant(DefaultListBehavior)};
        invoke_method_void(args,106,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ListTemplateListTemplate
    * @param ContinuePreviousListObject[]
    * @param ListTemplateListTemplate
    * @param ContinuePreviousListObject[]
    */
    public void ApplyListTemplate(ListTemplate ListTemplate,Object[] ContinuePreviousList)
    {
        Variant[] args = {new Variant(ListTemplate),new Variant(ContinuePreviousList)};
        invoke_method_void(args,106,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ListTemplateListTemplate
    * @param ListTemplateListTemplate
    */
    public void ApplyListTemplate(ListTemplate ListTemplate)
    {
        Variant[] args = {new Variant(ListTemplate)};
        invoke_method_void(args,106,DispatchConstants.DISPATCH_METHOD);
    }

}
