package com.microsoft.word.gen;
import com.microsoft.word.*;
import com.microsoft.word.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object ListFormat
* DO NOT EDIT THIS CODE 
* EDIT the subclass ListFormat
* @author S Lewis
*/
public class _ListFormat extends WDispatch
{
    public static final String clsid = "{000209C0-0000-0000-C000-000000000046}";
    protected static Map gParamHashApplyListTemplate;
    // Static initializer
    // Used to initialize Hash Tables for named parameters
    static {
        gParamHashApplyListTemplate = new HashMap();
        gParamHashApplyListTemplate.put("ListTemplate",new Integer(0));
        gParamHashApplyListTemplate.put("ContinuePreviousList",new Integer(1));
        gParamHashApplyListTemplate.put("ApplyTo",new Integer(2));
        gParamHashApplyListTemplate.put("DefaultListBehavior",new Integer(3));

    }
    /**
    * default constructor
    */
    public _ListFormat()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _ListFormat(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _ListFormat(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return int
    */
    public int getListLevelNumber()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,68,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setListLevelNumber(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,68,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return List
    */
    public List getList()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,69,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        List ret = new List(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return ListTemplate
    */
    public ListTemplate getListTemplate()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,70,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        ListTemplate ret = new ListTemplate(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getListValue()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,71,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getSingleList()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,72,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getSingleListTemplate()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,73,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @return WdListTypeEnum
    */
    public WdListTypeEnum getListType()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,74,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdListTypeEnum ret = WdListTypeEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @return String
    */
    public String getListString()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,75,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1000,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1001,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1002,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @param ListTemplateListTemplate
    * @param ListTemplateListTemplate
    * @return WdContinueEnum
    */
    public WdContinueEnum CanContinuePreviousList(ListTemplate ListTemplate)
    {
        Variant[] args = {new Variant(ListTemplate)};
        Variant retVar = invoke_method(args,184,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        WdContinueEnum ret = WdContinueEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param NumberTypeObject[]
    * @param NumberTypeObject[]
    */
    public void RemoveNumbers(Object[] NumberType)
    {
        Variant[] args = {new Variant(NumberType)};
        invoke_method_void(args,185,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void RemoveNumbers()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,185,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param NumberTypeObject[]
    * @param NumberTypeObject[]
    */
    public void ConvertNumbersToText(Object[] NumberType)
    {
        Variant[] args = {new Variant(NumberType)};
        invoke_method_void(args,186,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void ConvertNumbersToText()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,186,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param NumberTypeObject[]
    * @param LevelObject[]
    * @param NumberTypeObject[]
    * @param LevelObject[]
    * @return int
    */
    public int CountNumberedItems(Object[] NumberType,Object[] Level)
    {
        Variant[] args = {new Variant(NumberType),new Variant(Level)};
        Variant retVar = invoke_method(args,187,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param NumberTypeObject[]
    * @param NumberTypeObject[]
    * @return int
    */
    public int CountNumberedItems(Object[] NumberType)
    {
        Variant[] args = {new Variant(NumberType)};
        Variant retVar = invoke_method(args,187,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return int
    */
    public int CountNumberedItems()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,187,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    */
    public void ApplyBulletDefaultOld()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,188,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void ApplyNumberDefaultOld()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,189,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void ApplyOutlineNumberDefaultOld()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,190,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ListTemplateListTemplate
    * @param ContinuePreviousListObject[]
    * @param ApplyToObject[]
    * @param ListTemplateListTemplate
    * @param ContinuePreviousListObject[]
    * @param ApplyToObject[]
    */
    public void ApplyListTemplateOld(ListTemplate ListTemplate,Object[] ContinuePreviousList,Object[] ApplyTo)
    {
        Variant[] args = {new Variant(ListTemplate),new Variant(ContinuePreviousList),new Variant(ApplyTo)};
        invoke_method_void(args,191,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ListTemplateListTemplate
    * @param ContinuePreviousListObject[]
    * @param ListTemplateListTemplate
    * @param ContinuePreviousListObject[]
    */
    public void ApplyListTemplateOld(ListTemplate ListTemplate,Object[] ContinuePreviousList)
    {
        Variant[] args = {new Variant(ListTemplate),new Variant(ContinuePreviousList)};
        invoke_method_void(args,191,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ListTemplateListTemplate
    * @param ListTemplateListTemplate
    */
    public void ApplyListTemplateOld(ListTemplate ListTemplate)
    {
        Variant[] args = {new Variant(ListTemplate)};
        invoke_method_void(args,191,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void ListOutdent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,210,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void ListIndent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,211,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param DefaultListBehaviorObject[]
    * @param DefaultListBehaviorObject[]
    */
    public void ApplyBulletDefault(Object[] DefaultListBehavior)
    {
        Variant[] args = {new Variant(DefaultListBehavior)};
        invoke_method_void(args,212,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void ApplyBulletDefault()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,212,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param DefaultListBehaviorObject[]
    * @param DefaultListBehaviorObject[]
    */
    public void ApplyNumberDefault(Object[] DefaultListBehavior)
    {
        Variant[] args = {new Variant(DefaultListBehavior)};
        invoke_method_void(args,213,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void ApplyNumberDefault()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,213,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param DefaultListBehaviorObject[]
    * @param DefaultListBehaviorObject[]
    */
    public void ApplyOutlineNumberDefault(Object[] DefaultListBehavior)
    {
        Variant[] args = {new Variant(DefaultListBehavior)};
        invoke_method_void(args,214,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void ApplyOutlineNumberDefault()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,214,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ListTemplateListTemplate
    * @param ContinuePreviousListObject[]
    * @param ApplyToObject[]
    * @param DefaultListBehaviorObject[]
    * @param ListTemplateListTemplate
    * @param ContinuePreviousListObject[]
    * @param ApplyToObject[]
    * @param DefaultListBehaviorObject[]
    */
    public void ApplyListTemplate(ListTemplate ListTemplate,Object[] ContinuePreviousList,Object[] ApplyTo,Object[] DefaultListBehavior)
    {
        Variant[] args = {new Variant(ListTemplate),new Variant(ContinuePreviousList),new Variant(ApplyTo),new Variant(DefaultListBehavior)};
        invoke_method_void(args,215,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    */
    public void ApplyListTemplate(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashApplyListTemplate.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        invoke_method_void(args,215,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ListTemplateListTemplate
    * @param ContinuePreviousListObject[]
    * @param ApplyToObject[]
    * @param ListTemplateListTemplate
    * @param ContinuePreviousListObject[]
    * @param ApplyToObject[]
    */
    public void ApplyListTemplate(ListTemplate ListTemplate,Object[] ContinuePreviousList,Object[] ApplyTo)
    {
        Variant[] args = {new Variant(ListTemplate),new Variant(ContinuePreviousList),new Variant(ApplyTo)};
        invoke_method_void(args,215,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ListTemplateListTemplate
    * @param ContinuePreviousListObject[]
    * @param ListTemplateListTemplate
    * @param ContinuePreviousListObject[]
    */
    public void ApplyListTemplate(ListTemplate ListTemplate,Object[] ContinuePreviousList)
    {
        Variant[] args = {new Variant(ListTemplate),new Variant(ContinuePreviousList)};
        invoke_method_void(args,215,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ListTemplateListTemplate
    * @param ListTemplateListTemplate
    */
    public void ApplyListTemplate(ListTemplate ListTemplate)
    {
        Variant[] args = {new Variant(ListTemplate)};
        invoke_method_void(args,215,DispatchConstants.DISPATCH_METHOD);
    }

}
