package com.microsoft.word.gen;
import com.microsoft.word.*;
import com.microsoft.word.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object MailMergeFields
* DO NOT EDIT THIS CODE 
* EDIT the subclass MailMergeFields
* @author S Lewis
*/
public class _MailMergeFields extends WDispatch
{
    public static final String clsid = "{0002091F-0000-0000-C000-000000000046}";
    protected static Map gParamHashAddAsk;
    protected static Map gParamHashAddFillIn;
    protected static Map gParamHashAddIf;
    // Static initializer
    // Used to initialize Hash Tables for named parameters
    static {
        gParamHashAddAsk = new HashMap();
        gParamHashAddAsk.put("Range",new Integer(0));
        gParamHashAddAsk.put("Name",new Integer(1));
        gParamHashAddAsk.put("Prompt",new Integer(2));
        gParamHashAddAsk.put("DefaultAskText",new Integer(3));
        gParamHashAddAsk.put("AskOnce",new Integer(4));

        gParamHashAddFillIn = new HashMap();
        gParamHashAddFillIn.put("Range",new Integer(0));
        gParamHashAddFillIn.put("Prompt",new Integer(1));
        gParamHashAddFillIn.put("DefaultFillInText",new Integer(2));
        gParamHashAddFillIn.put("AskOnce",new Integer(3));

        gParamHashAddIf = new HashMap();
        gParamHashAddIf.put("Range",new Integer(0));
        gParamHashAddIf.put("MergeField",new Integer(1));
        gParamHashAddIf.put("Comparison",new Integer(2));
        gParamHashAddIf.put("CompareTo",new Integer(3));
        gParamHashAddIf.put("TrueAutoText",new Integer(4));
        gParamHashAddIf.put("TrueText",new Integer(5));
        gParamHashAddIf.put("FalseAutoText",new Integer(6));
        gParamHashAddIf.put("FalseText",new Integer(7));

    }
    /**
    * default constructor
    */
    public _MailMergeFields()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _MailMergeFields(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _MailMergeFields(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1000,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1001,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1002,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return IUnknown
    */
    public IUnknown ambig_get_NewEnum()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,-4,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        IUnknown ret = new IUnknown(retVar.toInt());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCount()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param Indexint
    * @param Indexint
    * @return MailMergeField
    */
    public MailMergeField Item(int Index)
    {
        Variant[] args = {new Variant(Index)};
        Variant retVar = invoke_method(args,0,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        MailMergeField ret = new MailMergeField(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param RangeRange
    * @param NameString
    * @param RangeRange
    * @param NameString
    * @return MailMergeField
    */
    public MailMergeField Add(Range Range,String Name)
    {
        Variant[] args = {new Variant(Range),new Variant(Name)};
        Variant retVar = invoke_method(args,101,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        MailMergeField ret = new MailMergeField(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param RangeRange
    * @param NameString
    * @param PromptObject[]
    * @param DefaultAskTextObject[]
    * @param AskOnceObject[]
    * @param RangeRange
    * @param NameString
    * @param PromptObject[]
    * @param DefaultAskTextObject[]
    * @param AskOnceObject[]
    * @return MailMergeField
    */
    public MailMergeField AddAsk(Range Range,String Name,Object[] Prompt,Object[] DefaultAskText,Object[] AskOnce)
    {
        Variant[] args = {new Variant(Range),new Variant(Name),new Variant(Prompt),new Variant(DefaultAskText),new Variant(AskOnce)};
        Variant retVar = invoke_method(args,102,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        MailMergeField ret = new MailMergeField(retVar.toDispatch());
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return MailMergeField
    */
    public MailMergeField AddAsk(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashAddAsk.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,102,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        MailMergeField ret = new MailMergeField(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param RangeRange
    * @param NameString
    * @param PromptObject[]
    * @param DefaultAskTextObject[]
    * @param RangeRange
    * @param NameString
    * @param PromptObject[]
    * @param DefaultAskTextObject[]
    * @return MailMergeField
    */
    public MailMergeField AddAsk(Range Range,String Name,Object[] Prompt,Object[] DefaultAskText)
    {
        Variant[] args = {new Variant(Range),new Variant(Name),new Variant(Prompt),new Variant(DefaultAskText)};
        Variant retVar = invoke_method(args,102,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        MailMergeField ret = new MailMergeField(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param RangeRange
    * @param NameString
    * @param PromptObject[]
    * @param RangeRange
    * @param NameString
    * @param PromptObject[]
    * @return MailMergeField
    */
    public MailMergeField AddAsk(Range Range,String Name,Object[] Prompt)
    {
        Variant[] args = {new Variant(Range),new Variant(Name),new Variant(Prompt)};
        Variant retVar = invoke_method(args,102,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        MailMergeField ret = new MailMergeField(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param RangeRange
    * @param NameString
    * @param RangeRange
    * @param NameString
    * @return MailMergeField
    */
    public MailMergeField AddAsk(Range Range,String Name)
    {
        Variant[] args = {new Variant(Range),new Variant(Name)};
        Variant retVar = invoke_method(args,102,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        MailMergeField ret = new MailMergeField(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param RangeRange
    * @param PromptObject[]
    * @param DefaultFillInTextObject[]
    * @param AskOnceObject[]
    * @param RangeRange
    * @param PromptObject[]
    * @param DefaultFillInTextObject[]
    * @param AskOnceObject[]
    * @return MailMergeField
    */
    public MailMergeField AddFillIn(Range Range,Object[] Prompt,Object[] DefaultFillInText,Object[] AskOnce)
    {
        Variant[] args = {new Variant(Range),new Variant(Prompt),new Variant(DefaultFillInText),new Variant(AskOnce)};
        Variant retVar = invoke_method(args,103,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        MailMergeField ret = new MailMergeField(retVar.toDispatch());
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return MailMergeField
    */
    public MailMergeField AddFillIn(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashAddFillIn.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,103,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        MailMergeField ret = new MailMergeField(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param RangeRange
    * @param PromptObject[]
    * @param DefaultFillInTextObject[]
    * @param RangeRange
    * @param PromptObject[]
    * @param DefaultFillInTextObject[]
    * @return MailMergeField
    */
    public MailMergeField AddFillIn(Range Range,Object[] Prompt,Object[] DefaultFillInText)
    {
        Variant[] args = {new Variant(Range),new Variant(Prompt),new Variant(DefaultFillInText)};
        Variant retVar = invoke_method(args,103,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        MailMergeField ret = new MailMergeField(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param RangeRange
    * @param PromptObject[]
    * @param RangeRange
    * @param PromptObject[]
    * @return MailMergeField
    */
    public MailMergeField AddFillIn(Range Range,Object[] Prompt)
    {
        Variant[] args = {new Variant(Range),new Variant(Prompt)};
        Variant retVar = invoke_method(args,103,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        MailMergeField ret = new MailMergeField(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param RangeRange
    * @param RangeRange
    * @return MailMergeField
    */
    public MailMergeField AddFillIn(Range Range)
    {
        Variant[] args = {new Variant(Range)};
        Variant retVar = invoke_method(args,103,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        MailMergeField ret = new MailMergeField(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param RangeRange
    * @param MergeFieldString
    * @param ComparisonWdMailMergeComparisonEnum
    * @param CompareToObject[]
    * @param TrueAutoTextObject[]
    * @param TrueTextObject[]
    * @param FalseAutoTextObject[]
    * @param FalseTextObject[]
    * @param RangeRange
    * @param MergeFieldString
    * @param ComparisonWdMailMergeComparisonEnum
    * @param CompareToObject[]
    * @param TrueAutoTextObject[]
    * @param TrueTextObject[]
    * @param FalseAutoTextObject[]
    * @param FalseTextObject[]
    * @return MailMergeField
    */
    public MailMergeField AddIf(Range Range,String MergeField,WdMailMergeComparisonEnum Comparison,Object[] CompareTo,Object[] TrueAutoText,Object[] TrueText,Object[] FalseAutoText,Object[] FalseText)
    {
        Variant[] args = {new Variant(Range),new Variant(MergeField),new Variant(Comparison.getValue()),new Variant(CompareTo),new Variant(TrueAutoText),new Variant(TrueText),new Variant(FalseAutoText),new Variant(FalseText)};
        Variant retVar = invoke_method(args,104,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        MailMergeField ret = new MailMergeField(retVar.toDispatch());
        return(ret);
    }

    /**
    * This call supports calling with named arguments as does VB
    * @param TheParams non-null Map where key is 
    *    param name and value is param value
    * @return MailMergeField
    */
    public MailMergeField AddIf(Map TheParams)
    {
        Variant[] args = {new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null), new Variant(null)};
        Iterator it = TheParams.keySet().iterator();
        while(it.hasNext()) {
            String ParamName = (String)it.next();
            Integer Item = (Integer)gParamHashAddIf.get(ParamName);
            Variant RealItem = new Variant(TheParams.get(ParamName));
            args[Item.intValue()] = RealItem;
        }
        Variant retVar = invoke_method(args,104,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        MailMergeField ret = new MailMergeField(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param RangeRange
    * @param MergeFieldString
    * @param ComparisonWdMailMergeComparisonEnum
    * @param CompareToObject[]
    * @param TrueAutoTextObject[]
    * @param TrueTextObject[]
    * @param FalseAutoTextObject[]
    * @param RangeRange
    * @param MergeFieldString
    * @param ComparisonWdMailMergeComparisonEnum
    * @param CompareToObject[]
    * @param TrueAutoTextObject[]
    * @param TrueTextObject[]
    * @param FalseAutoTextObject[]
    * @return MailMergeField
    */
    public MailMergeField AddIf(Range Range,String MergeField,WdMailMergeComparisonEnum Comparison,Object[] CompareTo,Object[] TrueAutoText,Object[] TrueText,Object[] FalseAutoText)
    {
        Variant[] args = {new Variant(Range),new Variant(MergeField),new Variant(Comparison.getValue()),new Variant(CompareTo),new Variant(TrueAutoText),new Variant(TrueText),new Variant(FalseAutoText)};
        Variant retVar = invoke_method(args,104,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        MailMergeField ret = new MailMergeField(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param RangeRange
    * @param MergeFieldString
    * @param ComparisonWdMailMergeComparisonEnum
    * @param CompareToObject[]
    * @param TrueAutoTextObject[]
    * @param TrueTextObject[]
    * @param RangeRange
    * @param MergeFieldString
    * @param ComparisonWdMailMergeComparisonEnum
    * @param CompareToObject[]
    * @param TrueAutoTextObject[]
    * @param TrueTextObject[]
    * @return MailMergeField
    */
    public MailMergeField AddIf(Range Range,String MergeField,WdMailMergeComparisonEnum Comparison,Object[] CompareTo,Object[] TrueAutoText,Object[] TrueText)
    {
        Variant[] args = {new Variant(Range),new Variant(MergeField),new Variant(Comparison.getValue()),new Variant(CompareTo),new Variant(TrueAutoText),new Variant(TrueText)};
        Variant retVar = invoke_method(args,104,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        MailMergeField ret = new MailMergeField(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param RangeRange
    * @param MergeFieldString
    * @param ComparisonWdMailMergeComparisonEnum
    * @param CompareToObject[]
    * @param TrueAutoTextObject[]
    * @param RangeRange
    * @param MergeFieldString
    * @param ComparisonWdMailMergeComparisonEnum
    * @param CompareToObject[]
    * @param TrueAutoTextObject[]
    * @return MailMergeField
    */
    public MailMergeField AddIf(Range Range,String MergeField,WdMailMergeComparisonEnum Comparison,Object[] CompareTo,Object[] TrueAutoText)
    {
        Variant[] args = {new Variant(Range),new Variant(MergeField),new Variant(Comparison.getValue()),new Variant(CompareTo),new Variant(TrueAutoText)};
        Variant retVar = invoke_method(args,104,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        MailMergeField ret = new MailMergeField(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param RangeRange
    * @param MergeFieldString
    * @param ComparisonWdMailMergeComparisonEnum
    * @param CompareToObject[]
    * @param RangeRange
    * @param MergeFieldString
    * @param ComparisonWdMailMergeComparisonEnum
    * @param CompareToObject[]
    * @return MailMergeField
    */
    public MailMergeField AddIf(Range Range,String MergeField,WdMailMergeComparisonEnum Comparison,Object[] CompareTo)
    {
        Variant[] args = {new Variant(Range),new Variant(MergeField),new Variant(Comparison.getValue()),new Variant(CompareTo)};
        Variant retVar = invoke_method(args,104,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        MailMergeField ret = new MailMergeField(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param RangeRange
    * @param MergeFieldString
    * @param ComparisonWdMailMergeComparisonEnum
    * @param RangeRange
    * @param MergeFieldString
    * @param ComparisonWdMailMergeComparisonEnum
    * @return MailMergeField
    */
    public MailMergeField AddIf(Range Range,String MergeField,WdMailMergeComparisonEnum Comparison)
    {
        Variant[] args = {new Variant(Range),new Variant(MergeField),new Variant(Comparison.getValue())};
        Variant retVar = invoke_method(args,104,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        MailMergeField ret = new MailMergeField(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param RangeRange
    * @param RangeRange
    * @return MailMergeField
    */
    public MailMergeField AddMergeRec(Range Range)
    {
        Variant[] args = {new Variant(Range)};
        Variant retVar = invoke_method(args,105,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        MailMergeField ret = new MailMergeField(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param RangeRange
    * @param RangeRange
    * @return MailMergeField
    */
    public MailMergeField AddMergeSeq(Range Range)
    {
        Variant[] args = {new Variant(Range)};
        Variant retVar = invoke_method(args,106,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        MailMergeField ret = new MailMergeField(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param RangeRange
    * @param RangeRange
    * @return MailMergeField
    */
    public MailMergeField AddNext(Range Range)
    {
        Variant[] args = {new Variant(Range)};
        Variant retVar = invoke_method(args,107,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        MailMergeField ret = new MailMergeField(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param RangeRange
    * @param MergeFieldString
    * @param ComparisonWdMailMergeComparisonEnum
    * @param CompareToObject[]
    * @param RangeRange
    * @param MergeFieldString
    * @param ComparisonWdMailMergeComparisonEnum
    * @param CompareToObject[]
    * @return MailMergeField
    */
    public MailMergeField AddNextIf(Range Range,String MergeField,WdMailMergeComparisonEnum Comparison,Object[] CompareTo)
    {
        Variant[] args = {new Variant(Range),new Variant(MergeField),new Variant(Comparison.getValue()),new Variant(CompareTo)};
        Variant retVar = invoke_method(args,108,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        MailMergeField ret = new MailMergeField(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param RangeRange
    * @param MergeFieldString
    * @param ComparisonWdMailMergeComparisonEnum
    * @param RangeRange
    * @param MergeFieldString
    * @param ComparisonWdMailMergeComparisonEnum
    * @return MailMergeField
    */
    public MailMergeField AddNextIf(Range Range,String MergeField,WdMailMergeComparisonEnum Comparison)
    {
        Variant[] args = {new Variant(Range),new Variant(MergeField),new Variant(Comparison.getValue())};
        Variant retVar = invoke_method(args,108,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        MailMergeField ret = new MailMergeField(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param RangeRange
    * @param NameString
    * @param ValueTextObject[]
    * @param ValueAutoTextObject[]
    * @param RangeRange
    * @param NameString
    * @param ValueTextObject[]
    * @param ValueAutoTextObject[]
    * @return MailMergeField
    */
    public MailMergeField AddSet(Range Range,String Name,Object[] ValueText,Object[] ValueAutoText)
    {
        Variant[] args = {new Variant(Range),new Variant(Name),new Variant(ValueText),new Variant(ValueAutoText)};
        Variant retVar = invoke_method(args,109,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        MailMergeField ret = new MailMergeField(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param RangeRange
    * @param NameString
    * @param ValueTextObject[]
    * @param RangeRange
    * @param NameString
    * @param ValueTextObject[]
    * @return MailMergeField
    */
    public MailMergeField AddSet(Range Range,String Name,Object[] ValueText)
    {
        Variant[] args = {new Variant(Range),new Variant(Name),new Variant(ValueText)};
        Variant retVar = invoke_method(args,109,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        MailMergeField ret = new MailMergeField(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param RangeRange
    * @param NameString
    * @param RangeRange
    * @param NameString
    * @return MailMergeField
    */
    public MailMergeField AddSet(Range Range,String Name)
    {
        Variant[] args = {new Variant(Range),new Variant(Name)};
        Variant retVar = invoke_method(args,109,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        MailMergeField ret = new MailMergeField(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param RangeRange
    * @param MergeFieldString
    * @param ComparisonWdMailMergeComparisonEnum
    * @param CompareToObject[]
    * @param RangeRange
    * @param MergeFieldString
    * @param ComparisonWdMailMergeComparisonEnum
    * @param CompareToObject[]
    * @return MailMergeField
    */
    public MailMergeField AddSkipIf(Range Range,String MergeField,WdMailMergeComparisonEnum Comparison,Object[] CompareTo)
    {
        Variant[] args = {new Variant(Range),new Variant(MergeField),new Variant(Comparison.getValue()),new Variant(CompareTo)};
        Variant retVar = invoke_method(args,110,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        MailMergeField ret = new MailMergeField(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param RangeRange
    * @param MergeFieldString
    * @param ComparisonWdMailMergeComparisonEnum
    * @param RangeRange
    * @param MergeFieldString
    * @param ComparisonWdMailMergeComparisonEnum
    * @return MailMergeField
    */
    public MailMergeField AddSkipIf(Range Range,String MergeField,WdMailMergeComparisonEnum Comparison)
    {
        Variant[] args = {new Variant(Range),new Variant(MergeField),new Variant(Comparison.getValue())};
        Variant retVar = invoke_method(args,110,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        MailMergeField ret = new MailMergeField(retVar.toDispatch());
        return(ret);
    }

}
