package com.microsoft.word.gen;
import com.microsoft.word.*;
import com.microsoft.word.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object PageSetup
* DO NOT EDIT THIS CODE 
* EDIT the subclass PageSetup
* @author S Lewis
*/
public class _PageSetup extends WDispatch
{
    public static final String clsid = "{00020971-0000-0000-C000-000000000046}";
    /**
    * default constructor
    */
    public _PageSetup()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _PageSetup(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _PageSetup(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1000,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1001,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1002,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return float
    */
    public float getTopMargin()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,100,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setTopMargin(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,100,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getBottomMargin()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,101,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setBottomMargin(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,101,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getLeftMargin()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,102,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setLeftMargin(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,102,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getRightMargin()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,103,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setRightMargin(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,103,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getGutter()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,104,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setGutter(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,104,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getPageWidth()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,105,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setPageWidth(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,105,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getPageHeight()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,106,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setPageHeight(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,106,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdOrientationEnum
    */
    public WdOrientationEnum getOrientation()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,107,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdOrientationEnum ret = WdOrientationEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdOrientationEnum
    * @param arg1WdOrientationEnum
    */
    public void setOrientation(WdOrientationEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,107,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdPaperTrayEnum
    */
    public WdPaperTrayEnum getFirstPageTray()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,108,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdPaperTrayEnum ret = WdPaperTrayEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdPaperTrayEnum
    * @param arg1WdPaperTrayEnum
    */
    public void setFirstPageTray(WdPaperTrayEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,108,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdPaperTrayEnum
    */
    public WdPaperTrayEnum getOtherPagesTray()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,109,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdPaperTrayEnum ret = WdPaperTrayEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdPaperTrayEnum
    * @param arg1WdPaperTrayEnum
    */
    public void setOtherPagesTray(WdPaperTrayEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,109,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdVerticalAlignmentEnum
    */
    public WdVerticalAlignmentEnum getVerticalAlignment()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,110,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdVerticalAlignmentEnum ret = WdVerticalAlignmentEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdVerticalAlignmentEnum
    * @param arg1WdVerticalAlignmentEnum
    */
    public void setVerticalAlignment(WdVerticalAlignmentEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,110,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getMirrorMargins()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,111,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setMirrorMargins(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,111,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getHeaderDistance()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,112,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setHeaderDistance(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,112,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getFooterDistance()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,113,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setFooterDistance(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,113,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdSectionStartEnum
    */
    public WdSectionStartEnum getSectionStart()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,114,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdSectionStartEnum ret = WdSectionStartEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdSectionStartEnum
    * @param arg1WdSectionStartEnum
    */
    public void setSectionStart(WdSectionStartEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,114,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getOddAndEvenPagesHeaderFooter()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,115,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setOddAndEvenPagesHeaderFooter(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,115,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getDifferentFirstPageHeaderFooter()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,116,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setDifferentFirstPageHeaderFooter(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,116,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getSuppressEndnotes()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,117,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setSuppressEndnotes(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,117,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return LineNumbering
    */
    public LineNumbering getLineNumbering()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,118,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        LineNumbering ret = new LineNumbering(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param arg1LineNumbering
    * @param arg1LineNumbering
    */
    public void setLineNumbering(LineNumbering arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,118,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return TextColumns
    */
    public TextColumns getTextColumns()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,119,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        TextColumns ret = new TextColumns(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param arg1TextColumns
    * @param arg1TextColumns
    */
    public void setTextColumns(TextColumns arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,119,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdPaperSizeEnum
    */
    public WdPaperSizeEnum getPaperSize()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,120,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdPaperSizeEnum ret = WdPaperSizeEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdPaperSizeEnum
    * @param arg1WdPaperSizeEnum
    */
    public void setPaperSize(WdPaperSizeEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,120,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getTwoPagesOnOne()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,121,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setTwoPagesOnOne(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,121,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getGutterOnTop()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,122,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setGutterOnTop(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,122,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getCharsLine()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,123,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setCharsLine(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,123,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getLinesPage()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,124,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setLinesPage(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,124,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getShowGrid()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,128,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setShowGrid(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,128,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    */
    public void TogglePortrait()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,201,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void SetAsTemplateDefault()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,202,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @return WdGutterStyleOldEnum
    */
    public WdGutterStyleOldEnum getGutterStyle()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,129,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdGutterStyleOldEnum ret = WdGutterStyleOldEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdGutterStyleOldEnum
    * @param arg1WdGutterStyleOldEnum
    */
    public void setGutterStyle(WdGutterStyleOldEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,129,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdSectionDirectionEnum
    */
    public WdSectionDirectionEnum getSectionDirection()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,130,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdSectionDirectionEnum ret = WdSectionDirectionEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdSectionDirectionEnum
    * @param arg1WdSectionDirectionEnum
    */
    public void setSectionDirection(WdSectionDirectionEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,130,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdLayoutModeEnum
    */
    public WdLayoutModeEnum getLayoutMode()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,131,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdLayoutModeEnum ret = WdLayoutModeEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdLayoutModeEnum
    * @param arg1WdLayoutModeEnum
    */
    public void setLayoutMode(WdLayoutModeEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,131,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdGutterStyleEnum
    */
    public WdGutterStyleEnum getGutterPos()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1222,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdGutterStyleEnum ret = WdGutterStyleEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdGutterStyleEnum
    * @param arg1WdGutterStyleEnum
    */
    public void setGutterPos(WdGutterStyleEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,1222,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

}
