package com.microsoft.word.gen;
import com.microsoft.word.*;
import com.microsoft.word.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object RoutingSlip
* DO NOT EDIT THIS CODE 
* EDIT the subclass RoutingSlip
* @author S Lewis
*/
public class _RoutingSlip extends WDispatch
{
    public static final String clsid = "{00020969-0000-0000-C000-000000000046}";
    /**
    * default constructor
    */
    public _RoutingSlip()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _RoutingSlip(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _RoutingSlip(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1000,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1001,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1002,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return String
    */
    public String getSubject()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setSubject(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getMessage()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,2,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setMessage(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,2,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdRoutingSlipDeliveryEnum
    */
    public WdRoutingSlipDeliveryEnum getDelivery()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,3,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdRoutingSlipDeliveryEnum ret = WdRoutingSlipDeliveryEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdRoutingSlipDeliveryEnum
    * @param arg1WdRoutingSlipDeliveryEnum
    */
    public void setDelivery(WdRoutingSlipDeliveryEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,3,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getTrackStatus()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,4,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setTrackStatus(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,4,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdProtectionTypeEnum
    */
    public WdProtectionTypeEnum getProtect()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,5,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdProtectionTypeEnum ret = WdProtectionTypeEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdProtectionTypeEnum
    * @param arg1WdProtectionTypeEnum
    */
    public void setProtect(WdProtectionTypeEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,5,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getReturnWhenDone()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,6,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setReturnWhenDone(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,6,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdRoutingSlipStatusEnum
    */
    public WdRoutingSlipStatusEnum getStatus()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,7,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdRoutingSlipStatusEnum ret = WdRoutingSlipStatusEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param IndexObject[]
    * @param IndexObject[]
    * @return Object
    */
    public Object ambig_getRecipients(Object[] Index)
    {
        Variant[] args = {new Variant(Index)};
        Variant retVar = invoke_method(args,9,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @return Object
    */
    public Object ambig_getRecipients()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,9,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    */
    public void Reset()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param RecipientString
    * @param RecipientString
    */
    public void AddRecipient(String Recipient)
    {
        Variant[] args = {new Variant(Recipient)};
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

}
