package com.microsoft.word.gen;
import com.microsoft.word.*;
import com.microsoft.word.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object Row
* DO NOT EDIT THIS CODE 
* EDIT the subclass Row
* @author S Lewis
*/
public class _Row extends WDispatch
{
    public static final String clsid = "{00020950-0000-0000-C000-000000000046}";
    /**
    * default constructor
    */
    public _Row()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _Row(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _Row(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return Range
    */
    public Range getRange()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,0,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1000,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1001,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1002,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return int
    */
    public int getAllowBreakAcrossPages()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,3,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setAllowBreakAcrossPages(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,3,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdRowAlignmentEnum
    */
    public WdRowAlignmentEnum getAlignment()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,4,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdRowAlignmentEnum ret = WdRowAlignmentEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdRowAlignmentEnum
    * @param arg1WdRowAlignmentEnum
    */
    public void setAlignment(WdRowAlignmentEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,4,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getHeadingFormat()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,5,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setHeadingFormat(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,5,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getSpaceBetweenColumns()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,6,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setSpaceBetweenColumns(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,6,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getHeight()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,7,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setHeight(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,7,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdRowHeightRuleEnum
    */
    public WdRowHeightRuleEnum getHeightRule()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,8,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdRowHeightRuleEnum ret = WdRowHeightRuleEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdRowHeightRuleEnum
    * @param arg1WdRowHeightRuleEnum
    */
    public void setHeightRule(WdRowHeightRuleEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,8,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getLeftIndent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,9,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setLeftIndent(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,9,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getIsLast()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,10,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getIsFirst()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,11,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @return int
    */
    public int getIndex()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,12,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Cells
    */
    public Cells getCells()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,100,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Cells ret = new Cells(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Borders
    */
    public Borders getBorders()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1100,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Borders ret = new Borders(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param arg1Borders
    * @param arg1Borders
    */
    public void setBorders(Borders arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1100,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Shading
    */
    public Shading getShading()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,103,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Shading ret = new Shading(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Row
    */
    public Row getNext()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,104,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Row ret = new Row(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Row
    */
    public Row getPrevious()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,105,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Row ret = new Row(retVar.toDispatch());
        return(ret);
    }

    /**
    */
    public void Select()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,65535,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    */
    public void Delete()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,200,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param LeftIndentfloat
    * @param RulerStyleWdRulerStyleEnum
    * @param LeftIndentfloat
    * @param RulerStyleWdRulerStyleEnum
    */
    public void SetLeftIndent(float LeftIndent,WdRulerStyleEnum RulerStyle)
    {
        Variant[] args = {new Variant(LeftIndent),new Variant(RulerStyle.getValue())};
        invoke_method_void(args,202,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param RowHeightfloat
    * @param HeightRuleWdRowHeightRuleEnum
    * @param RowHeightfloat
    * @param HeightRuleWdRowHeightRuleEnum
    */
    public void SetHeight(float RowHeight,WdRowHeightRuleEnum HeightRule)
    {
        Variant[] args = {new Variant(RowHeight),new Variant(HeightRule.getValue())};
        invoke_method_void(args,203,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param SeparatorObject[]
    * @param SeparatorObject[]
    * @return Range
    */
    public Range ConvertToTextOld(Object[] Separator)
    {
        Variant[] args = {new Variant(Separator)};
        Variant retVar = invoke_method(args,16,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Range
    */
    public Range ConvertToTextOld()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,16,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param NestedTablesObject[]
    * @param SeparatorObject[]
    * @param NestedTablesObject[]
    * @return Range
    */
    public Range ConvertToText(Object[] Separator,Object[] NestedTables)
    {
        Variant[] args = {new Variant(Separator),new Variant(NestedTables)};
        Variant retVar = invoke_method(args,18,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param SeparatorObject[]
    * @param SeparatorObject[]
    * @return Range
    */
    public Range ConvertToText(Object[] Separator)
    {
        Variant[] args = {new Variant(Separator)};
        Variant retVar = invoke_method(args,18,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Range
    */
    public Range ConvertToText()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,18,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getNestingLevel()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,106,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return String
    */
    public String getID()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,107,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setID(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,107,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

}
