package com.microsoft.word.gen;
import com.microsoft.word.*;
import com.microsoft.word.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object Style
* DO NOT EDIT THIS CODE 
* EDIT the subclass Style
* @author S Lewis
*/
public class _Style extends WDispatch
{
    public static final String clsid = "{0002092C-0000-0000-C000-000000000046}";
    /**
    * default constructor
    */
    public _Style()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _Style(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _Style(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1000,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1001,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1002,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return String
    */
    public String getNameLocal()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,0,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param arg1String
    * @param arg1String
    */
    public void setNameLocal(String arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,0,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Object
    */
    public Object ambig_getBaseStyle()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param arg1Object[]
    * @param arg1Object[]
    */
    public void setBaseStyle(Object[] arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getDescription()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,2,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @return WdStyleTypeEnum
    */
    public WdStyleTypeEnum getType()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,3,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdStyleTypeEnum ret = WdStyleTypeEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getBuiltIn()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,4,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @return Object
    */
    public Object ambig_getNextParagraphStyle()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,5,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Object ret = retVar.ForceObjectVal();
        return(ret);
    }

    /**
    * @param arg1Object[]
    * @param arg1Object[]
    */
    public void setNextParagraphStyle(Object[] arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,5,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getInUse()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,6,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @return Shading
    */
    public Shading getShading()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,7,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Shading ret = new Shading(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Borders
    */
    public Borders getBorders()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,8,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Borders ret = new Borders(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param arg1Borders
    * @param arg1Borders
    */
    public void setBorders(Borders arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,8,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return ParagraphFormat
    */
    public ParagraphFormat getParagraphFormat()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,9,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        ParagraphFormat ret = new ParagraphFormat(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param arg1ParagraphFormat
    * @param arg1ParagraphFormat
    */
    public void setParagraphFormat(ParagraphFormat arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,9,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Font
    */
    public Font getFont()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,10,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Font ret = new Font(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param arg1Font
    * @param arg1Font
    */
    public void setFont(Font arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,10,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Frame
    */
    public Frame getFrame()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,11,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Frame ret = new Frame(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return WdLanguageIDEnum
    */
    public WdLanguageIDEnum getLanguageID()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,12,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdLanguageIDEnum ret = WdLanguageIDEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdLanguageIDEnum
    * @param arg1WdLanguageIDEnum
    */
    public void setLanguageID(WdLanguageIDEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,12,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getAutomaticallyUpdate()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,13,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setAutomaticallyUpdate(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,13,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return ListTemplate
    */
    public ListTemplate getListTemplate()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,14,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        ListTemplate ret = new ListTemplate(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getListLevelNumber()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,15,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return WdLanguageIDEnum
    */
    public WdLanguageIDEnum getLanguageIDFarEast()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,16,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdLanguageIDEnum ret = WdLanguageIDEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdLanguageIDEnum
    * @param arg1WdLanguageIDEnum
    */
    public void setLanguageIDFarEast(WdLanguageIDEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,16,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getHidden()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,17,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setHidden(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,17,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    */
    public void Delete()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,100,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ListTemplateListTemplate
    * @param ListLevelNumberObject[]
    * @param ListTemplateListTemplate
    * @param ListLevelNumberObject[]
    */
    public void LinkToListTemplate(ListTemplate ListTemplate,Object[] ListLevelNumber)
    {
        Variant[] args = {new Variant(ListTemplate),new Variant(ListLevelNumber)};
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param ListTemplateListTemplate
    * @param ListTemplateListTemplate
    */
    public void LinkToListTemplate(ListTemplate ListTemplate)
    {
        Variant[] args = {new Variant(ListTemplate)};
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @return int
    */
    public int getNoProofing()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,18,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setNoProofing(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,18,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

}
