package com.microsoft.word.gen;
import com.microsoft.word.*;
import com.microsoft.word.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object System
* DO NOT EDIT THIS CODE 
* EDIT the subclass System
* @author S Lewis
*/
public class _System extends WDispatch
{
    public static final String clsid = "{00020935-0000-0000-C000-000000000046}";
    /**
    * default constructor
    */
    public _System()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _System(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _System(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1000,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1001,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1002,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return String
    */
    public String getOperatingSystem()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @return String
    */
    public String getProcessorType()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,2,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @return String
    */
    public String getVersion()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,3,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @return int
    */
    public int getFreeDiskSpace()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,4,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return WdCountryEnum
    */
    public WdCountryEnum getCountry()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,5,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdCountryEnum ret = WdCountryEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @return String
    */
    public String getLanguageDesignation()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,6,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @return int
    */
    public int getHorizontalResolution()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,7,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return int
    */
    public int getVerticalResolution()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,8,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param SectionString
    * @param KeyString
    * @param SectionString
    * @param KeyString
    * @return String
    */
    public String getProfileString(String Section,String Key)
    {
        Variant[] args = {new Variant(Section),new Variant(Key)};
        Variant retVar = invoke_method(args,9,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param SectionString
    * @param KeyString
    * @param arg3String
    * @param SectionString
    * @param KeyString
    * @param arg3String
    */
    public void setProfileString(String Section,String Key,String arg3)
    {
        Variant[] args = {new Variant(Section),new Variant(Key),new Variant(arg3)};
        invoke_method_void(args,9,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @param FileNameString
    * @param SectionString
    * @param KeyString
    * @param FileNameString
    * @param SectionString
    * @param KeyString
    * @return String
    */
    public String getPrivateProfileString(String FileName,String Section,String Key)
    {
        Variant[] args = {new Variant(FileName),new Variant(Section),new Variant(Key)};
        Variant retVar = invoke_method(args,10,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @param FileNameString
    * @param SectionString
    * @param KeyString
    * @param arg4String
    * @param FileNameString
    * @param SectionString
    * @param KeyString
    * @param arg4String
    */
    public void setPrivateProfileString(String FileName,String Section,String Key,String arg4)
    {
        Variant[] args = {new Variant(FileName),new Variant(Section),new Variant(Key),new Variant(arg4)};
        invoke_method_void(args,10,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getMathCoprocessorInstalled()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,11,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @return String
    */
    public String getComputerType()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,12,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @return String
    */
    public String getMacintoshName()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,14,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getQuickDrawInstalled()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,15,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @return WdCursorTypeEnum
    */
    public WdCursorTypeEnum getCursor()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,16,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdCursorTypeEnum ret = WdCursorTypeEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdCursorTypeEnum
    * @param arg1WdCursorTypeEnum
    */
    public void setCursor(WdCursorTypeEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,16,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    */
    public void MSInfo()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param PathString
    * @param DriveObject[]
    * @param PasswordObject[]
    * @param PathString
    * @param DriveObject[]
    * @param PasswordObject[]
    */
    public void Connect(String Path,Object[] Drive,Object[] Password)
    {
        Variant[] args = {new Variant(Path),new Variant(Drive),new Variant(Password)};
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param PathString
    * @param DriveObject[]
    * @param PathString
    * @param DriveObject[]
    */
    public void Connect(String Path,Object[] Drive)
    {
        Variant[] args = {new Variant(Path),new Variant(Drive)};
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param PathString
    * @param PathString
    */
    public void Connect(String Path)
    {
        Variant[] args = {new Variant(Path)};
        invoke_method_void(args,102,DispatchConstants.DISPATCH_METHOD);
    }

}
