package com.microsoft.word.gen;
import com.microsoft.word.*;
import com.microsoft.word.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object TextFrame
* DO NOT EDIT THIS CODE 
* EDIT the subclass TextFrame
* @author S Lewis
*/
public class _TextFrame extends WDispatch
{
    public static final String clsid = "{000209B2-0000-0000-C000-000000000046}";
    /**
    * default constructor
    */
    public _TextFrame()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _TextFrame(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _TextFrame(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,8000,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,8001,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Shape
    */
    public Shape getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Shape ret = new Shape(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return float
    */
    public float getMarginBottom()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,100,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setMarginBottom(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,100,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getMarginLeft()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,101,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setMarginLeft(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,101,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getMarginRight()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,102,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setMarginRight(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,102,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return float
    */
    public float getMarginTop()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,103,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        float ret = retVar.toFloat();
        return(ret);
    }

    /**
    * @param arg1float
    * @param arg1float
    */
    public void setMarginTop(float arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,103,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getOrientation()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,104,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1intRealType - MsoTextOrientation
    * @param arg1intRealType - MsoTextOrientation
    */
    public void setOrientation(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,104,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return Range
    */
    public Range getTextRange()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1001,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return Range
    */
    public Range getContainingRange()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1002,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Range ret = new Range(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return TextFrame
    */
    public TextFrame getNext()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,5001,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        TextFrame ret = new TextFrame(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param arg1TextFrame
    * @param arg1TextFrame
    */
    public void setNext(TextFrame arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,5001,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return TextFrame
    */
    public TextFrame getPrevious()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,5002,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        TextFrame ret = new TextFrame(retVar.toDispatch());
        return(ret);
    }

    /**
    * @param arg1TextFrame
    * @param arg1TextFrame
    */
    public void setPrevious(TextFrame arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,5002,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getOverflowing()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,5003,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @return int
    */
    public int getHasText()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,5008,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    */
    public void BreakForwardLink()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,5004,DispatchConstants.DISPATCH_METHOD);
    }

    /**
    * @param TargetTextFrameTextFrame
    * @param TargetTextFrameTextFrame
    * @return boolean
    */
    public boolean ValidLinkTarget(TextFrame TargetTextFrame)
    {
        Variant[] args = {new Variant(TargetTextFrame)};
        Variant retVar = invoke_method(args,5006,DispatchConstants.DISPATCH_METHOD);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

}
