package com.microsoft.word.gen;
import com.microsoft.word.*;
import com.microsoft.word.com_enum.*;
import com.lordjoe.lib.xml.*;
import java.util.HashMap;
import java.io.*;
import java.util.Map;
import java.util.Iterator;
import com.jacob.com.*;
import com.lordjoe.utilities.COMUtilities;

/**
* java surrogate for com object WebOptions
* DO NOT EDIT THIS CODE 
* EDIT the subclass WebOptions
* @author S Lewis
*/
public class _WebOptions extends WDispatch
{
    public static final String clsid = "{000209E4-0000-0000-C000-000000000046}";
    /**
    * default constructor
    */
    public _WebOptions()
    {
        super(clsid);
    }
    /**
    * default constructor
    */
    public _WebOptions(Dispatch in)
    {
        super(in);
    }
    /**
    * default constructor
    */
    public _WebOptions(WDispatch in)
    {
        super(in);
        if(!getClsId().equals(in.getClsId())) {
            if(!COMUtilities.allowCOMCast(getClass(),in.getClass()))
                throw new IllegalArgumentException("input cannot be assigned");
        }
    }
    /**
    * class id
    */
    public String getClsId()
    {
        return(clsid);
    }
    /**
    * @return Application
    */
    public Application getApplication()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1000,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Application ret = new Application(retVar.toDispatch());
        return(ret);
    }

    /**
    * @return int
    */
    public int getCreator()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1001,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @return Dispatch
    */
    public Dispatch ambig_getParent()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1002,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        Dispatch ret = retVar.toDispatch();
        return(ret);
    }

    /**
    * @return boolean
    */
    public boolean getOptimizeForBrowser()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,1,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setOptimizeForBrowser(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,1,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return WdBrowserLevelEnum
    */
    public WdBrowserLevelEnum getBrowserLevel()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,2,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        WdBrowserLevelEnum ret = WdBrowserLevelEnum.getOptionByValue(retVar.toInt());
        return(ret);
    }

    /**
    * @param arg1WdBrowserLevelEnum
    * @param arg1WdBrowserLevelEnum
    */
    public void setBrowserLevel(WdBrowserLevelEnum arg1)
    {
        Variant[] args = {new Variant(arg1.getValue())};
        invoke_method_void(args,2,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getRelyOnCSS()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,3,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setRelyOnCSS(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,3,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getOrganizeInFolder()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,4,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setOrganizeInFolder(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,4,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getUseLongFileNames()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,5,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setUseLongFileNames(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,5,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getRelyOnVML()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,6,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setRelyOnVML(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,6,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return boolean
    */
    public boolean getAllowPNG()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,7,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(false);
        boolean ret = retVar.toBoolean();
        return(ret);
    }

    /**
    * @param arg1boolean
    * @param arg1boolean
    */
    public void setAllowPNG(boolean arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,7,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getScreenSize()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,8,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1intRealType - MsoScreenSize
    * @param arg1intRealType - MsoScreenSize
    */
    public void setScreenSize(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,8,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getPixelsPerInch()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,9,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1int
    * @param arg1int
    */
    public void setPixelsPerInch(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,9,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return int
    */
    public int getEncoding()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,10,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(0);
        int ret = retVar.toInt();
        return(ret);
    }

    /**
    * @param arg1intRealType - MsoEncoding
    * @param arg1intRealType - MsoEncoding
    */
    public void setEncoding(int arg1)
    {
        Variant[] args = {new Variant(arg1)};
        invoke_method_void(args,10,DispatchConstants.DISPATCH_PROPERTYPUT);
    }

    /**
    * @return String
    */
    public String getFolderSuffix()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        Variant retVar = invoke_method(args,11,DispatchConstants.DISPATCH_PROPERTYGET);
        if(retVar == null)
            return(null);
        String ret = retVar.getString();
        return(ret);
    }

    /**
    */
    public void UseDefaultFolderSuffix()
    {
        Variant[] args = Variant.EMPTY_ARRAY;
        invoke_method_void(args,101,DispatchConstants.DISPATCH_METHOD);
    }

}
