package jp.jcomgenerator;
import jp.ne.so_net.ga2.no_ji.jcom.*;
import java.io.*;
import java.util.*;
import java.text.DateFormat;

/**
* This writes out the information in as typelib as 
* XML allowing any code to write the generator
* @author Steve Lewis
*
*/
public class XMLGenerator {
    public static final boolean DISPATCH_ONLY = false;
    
	protected ITypeInfo entryInfo = null;	// ProgIDŎw肳ꂽ^
	protected ITypeLib currentLib = null;		// ݂̃Cu
	protected ITypeInfo currentInfo = null;		// ݂̌^
	private PrintWriter m_out; // output writer
    private String m_ProgID; // make of the file 
    private String m_FileName; // make of the file 
    private ReleaseManager m_rm; // make of the file 
    private int m_indent;
    
    static {
        System.loadLibrary("jcom");
    }
    
    public XMLGenerator(ReleaseManager rm,String ProgID)
    {
        m_rm = rm;
        if(ProgID.startsWith("File:"))
            m_FileName = ProgID.substring(5);
        else
            m_ProgID = ProgID;
        
    }
    
    protected void addIndent() 
    {
        m_indent++;
    }
    
    protected void dropIndent() 
    {
        m_indent--;
    }
    
    protected void indent()
    {
        for(int i = 0; i < m_indent; i++) 
            m_out.print("    ");
    }
    
    protected void print(String s) {
        m_out.print(s);
    }
    
    protected void println(String s) {
        m_out.println(s);
    }
    protected void println() {
        m_out.println();
    }
    
    
    
    
    public void doGeneration() throws IOException,JComException
    {
        ITypeInfo typeInfo = null;
        String FileName = null;
        ITypeLib typeLib = null;
        if(m_ProgID != null) {
            FileName = m_ProgID.replace('.','_') + ".xml";
		    IDispatch disp = new IDispatch(m_rm, m_ProgID);
		    typeInfo = disp.getTypeInfo();
		    entryInfo = typeInfo;
		    typeLib = typeInfo.getTypeLib();
		}
		else {
		    String AFileName = m_FileName.replace('\\','/');
		    int index = AFileName.lastIndexOf('/');
		    int extIndex = AFileName.lastIndexOf('.');
		    
		    FileName =  AFileName.substring(index + 1,extIndex) + ".xml";
		    typeLib = ITypeLib.loadTypeLib(m_rm, AFileName);
		}
        m_out = new PrintWriter(new FileWriter(FileName));
        if(m_ProgID != null)
	    	System.out.println(" Handling " + m_ProgID);
		else 
	    	System.out.println(" Handling " + m_FileName);
		
		addTLibAttr(typeLib.getTLibAttr());
        ITypeLib.TLibAttr attr = null;
        int count = libset.size();
		for(int i=0; i < count; i++) {
			attr = (ITypeLib.TLibAttr)libset.get(i);
            System.out.println("TypeLib: " +attr);
            int MajorVersion = attr.getVerMajor();
            int MinorVersion = attr.getVerMinor();
            GUID libid = attr.getLIBID();
			ITypeLib lib = ITypeLib.loadRegTypeLib(m_rm,libid ,MajorVersion , MinorVersion);
			writeFileHeader(libid,MajorVersion , MinorVersion);
			addIndent();
			generateAll(lib);
			dropIndent();
			writeFileFooter();
		}
		m_out.close();
	}
	
	protected void writeFileHeader(GUID libid,int MajorVersion,int MinorVersion)
	{
	    println("<?xml version=\"1.0\"?>");
	    if(m_ProgID != null)
	        print("<Typelib progid=\"" + m_ProgID + "\" guid=\"");
	    else
	        print("<Typelib file=\"" + m_FileName + "\" guid=\"");
	    
	    print(libid.toString());
	    println("\" majorversion=\"" + MajorVersion + "\" minorversion=\"" + MinorVersion + "\" >");
	}
	
	
	
	protected void writeFileFooter()
	{
	    println("</Typelib>");
	}
	    
	// Actually write  all information
	protected void generateAll(ITypeLib lib) throws JComException
	{
		currentLib = lib;
//		currentPackageName = packagename;
		// ׂẴR|[lg\B
		int infocount = lib.getTypeInfoCount();
		for(int i=0 ; i< infocount; i++) {
		    try { 
		 //       System.out.println("Handling item " + i + " out of " + infocount);
			    ITypeInfo info = lib.getTypeInfo(i);
			    generate(info);
			}
			catch(jp.ne.so_net.ga2.no_ji.jcom.JComException ex) {
			    System.out.println("ERROR CREATING TypeLib: " + i + " out of " + infocount);
			    ex.printStackTrace();
			}
 		
 		}
 		currentLib = lib;
	}
	
	

	/**
	* Actually write the XML
	*/
	public void generate(ITypeInfo info) throws JComException
	{
		currentInfo = info;
		ITypeInfo.TypeAttr attr = info.getTypeAttr();
		int kind = attr.getTypeKind();
		if(kind == ITypeInfo.TKIND_COCLASS)
		    kind = ITypeInfo.TKIND_COCLASS; //break here
		// ׂĂ̓T|[gĂȂB(;_;)
		switch(kind) {
			case ITypeInfo.TKIND_ENUM:
			    if(!DISPATCH_ONLY)
			        generateEnum(info);
			    return;
			case ITypeInfo.TKIND_DISPATCH:		
			    generateDispatch(info);
			    return;
			case ITypeInfo.TKIND_COCLASS:	
			    if(!DISPATCH_ONLY)
			            generateCoClass(info);
			    return;
			case ITypeInfo.TKIND_RECORD:		
			    if(!DISPATCH_ONLY)
			        	System.out.println("TKIND_RECORD Type Kind="+attr.getTypeKind());
				break;
			case ITypeInfo.TKIND_MODULE:		
				System.out.println("TKIND_MODULE Type Kind="+attr.getTypeKind());
				break;
			case ITypeInfo.TKIND_INTERFACE:	// 3
			    if(!DISPATCH_ONLY)
			        	generateInterface(info);
				break;
			case ITypeInfo.TKIND_ALIAS:		
				System.out.println("TKIND_ALIAS Type Kind="+attr.getTypeKind());
				break;
			case ITypeInfo.TKIND_UNION:		
				System.out.println("TKIND_UNION Type Kind="+attr.getTypeKind());
				break;
			default: 
				System.out.println("Unknown Type "+attr.getTypeKind());
		}
	}

	/**
		T|[gĂȂ^CṽC^[tF[X𐶐܂B
		TYPEATTR.typekind  TKIND_???? ̃mɑ΂Đ
		fobOpɏo͂܂B
	*/
	public boolean generateNoSupport(ITypeInfo info) {
		try {
			String[] docs = info.getDocumentation(-1);
			ITypeInfo.TypeAttr attr = info.getTypeAttr();
			m_out.print("<UnsuppoortedType TypeKind=\""); //  + attr.getTypeKind() + "\" ");
			switch(attr.getTypeKind()) {
				case ITypeInfo.TKIND_ENUM:			m_out.print("TKIND_ENUM");		break;
				case ITypeInfo.TKIND_DISPATCH:		m_out.print("TKIND_DISPATCH");	break;
				case ITypeInfo.TKIND_RECORD:		m_out.print("TKIND_RECORD");		break;
				case ITypeInfo.TKIND_MODULE:		m_out.print("TKIND_MODULE");		break;
				case ITypeInfo.TKIND_INTERFACE:	m_out.print("TKIND_INTERFACE");	break;
				case ITypeInfo.TKIND_COCLASS:		m_out.print("TKIND_COCLASS");		break;
				case ITypeInfo.TKIND_ALIAS:		m_out.print("TKIND_ALIAS");		break;
				case ITypeInfo.TKIND_UNION:		m_out.print("TKIND_UNION");		break;
			}
			m_out.println("\" />");
			return true;
		}
		catch(Exception e) { 
		    e.printStackTrace(); 
		 }
		return false;
	}

	/**
		񋓌^̃NX𐶐܂B
		TYPEATTR.typekind  TKIND_ENUM ̃mɑ΂Đ
		varkind  VAR_CONST ̂̂ΉĂ܂񂪁A
		Excel̏ꍇAꂵȂ悤łB
		@param	outdir		o̓pX(\Ȃ)
	*/
	public void generateEnum(ITypeInfo info) throws JComException
	{
		String[] docs = info.getDocumentation(-1);
			
		indent();
		println("<enum name=\"" + docs[0] + "\" >");
		addIndent();
		printTypeVars(info);
		dropIndent();
		indent();
		println("</enum>");
	}
	/**
		񋓌^̃NX𐶐܂B
		TYPEATTR.typekind  TKIND_ENUM ̃mɑ΂Đ
		varkind  VAR_CONST ̂̂ΉĂ܂񂪁A
		Excel̏ꍇAꂵȂ悤łB
		@param	outdir		o̓pX(\Ȃ)
	*/
	public void generateInterface(ITypeInfo info) throws JComException
	{
		String[] docs = info.getDocumentation(-1);
			
		indent();
		println("<interface name=\"" + docs[0] + "\" >");
		addIndent();
		ITypeInfo.TypeAttr attr = info.getTypeAttr();
		for(int f=0; f < attr.getFuncs(); f++) {
			ITypeInfo.FuncDesc   funcdesc   = info.getFuncDesc(f);
			writeFuncDesc(info,funcdesc);
		}
		dropIndent();
		indent();
		println("</interface>");
	}
	
	/**
		񋓌^̃NX𐶐܂B
		TYPEATTR.typekind  TKIND_ENUM ̃mɑ΂Đ
		varkind  VAR_CONST ̂̂ΉĂ܂񂪁A
		Excel̏ꍇAꂵȂ悤łB
		@param	outdir		o̓pX(\Ȃ)
	*/
	public void printTypeVars(ITypeInfo info) throws JComException
	{
		ITypeInfo.TypeAttr attr = info.getTypeAttr();
		if(attr.getFuncs()!=0) {
			return;
		}
		for(int f=0; f < attr.getVars(); f++) {
			ITypeInfo.VarDesc   vardesc   = info.getVarDesc(f);
			ITypeInfo.ElemDesc  elemVar   = vardesc.getVar();
			String[]            names     = vardesc.getNames();
			Object              value     = vardesc.getValue();
			indent();
			print("<var name=\"" + names[0] + "\" ");
			switch(vardesc.getVarKind()) {
				case ITypeInfo.VAR_CONST:		// 2
					print("kind=\"VAR_CONST\" type=\"" + getJavaType(elemVar.toString())+ "\" value=\"" + value + "\" ");
					break;
				case ITypeInfo.VAR_PERINSTANCE:	// 0
				    print("kind=\"VAR_PERINSTANCE\" ");
				case ITypeInfo.VAR_STATIC:		// 1
				    print("kind=\"VAR_STATIC\" ");
				case ITypeInfo.VAR_DISPATCH:	// 3
				    print("kind=\"VAR_STATIC\" type=\"" + vardesc.toString() + "\" ");
				break;
			}
			println(" />");
		}
	}

	//	TYPEATTR.typekind  TKIND_DISPATCH ̃mɑ΂Đ
	public void generateDispatch(ITypeInfo info) throws JComException
	{
		String[] docs = info.getDocumentation(-1);
		indent();
		print("<Dispatch name=\"");
		print(docs[0]);
		print("\" ");
		ITypeInfo.TypeAttr attr = info.getTypeAttr();
		String IIDRawString = attr.getIID().toString();
		String IIDString = GUID.parse(IIDRawString).toString();
		if(!IIDRawString.equals(IIDString))
		    System.out.println("Unequal iids " + IIDRawString + " || " + IIDString);
		
		System.out.println("Handling Dispatch " + docs[0] + " iid-" + IIDString);
		print("iid=\"" + IIDString + "\" ");
		if(entryInfo != null) {
		    print("entryinfo=\"" + info.equals(entryInfo) + "\" ");
		    if(info.equals(entryInfo)) {
		        ITypeInfo.TypeAttr entryattr = info.getTypeAttr();
		        String EntryIID = entryattr.getIID().toString();
	/*			String formalProgID = Com.getProgIDFromCLSID(entryattr.getIID());
				print("progid=\"" + formalProgID + "\" ");
				GUID CLSID = Com.getCLSIDFromProgID(formalProgID);
				print("giud=\"" + CLSID.toString() + "\" ");
				*/
		    }
		}
	//    m_out.println("\tDispatch "+docs[0]+((docs[1]!=null)?docs[1]:""));
	//	m_out.println("\t"+docs[3]+" "+docs[2]);
		String formalProgID = null;
	/*	if(info.equals(entryInfo)) {	// ProgIDACLSID\
			GUID CLSID = Com.getCLSIDFromProgID(m_ProgID);
			formalProgID = Com.getProgIDFromCLSID(CLSID);
		//	m_out.println("\tProgID="+formalProgID);
		//	m_out.println("\tCLSID="+CLSID);
		}
		*/
		println(" >");
			
		addIndent();
		int count = attr.getFuncs();
		Set holder = new HashSet();
		for(int f=0; f < count; f++) {
			ITypeInfo.FuncDesc   funcdesc   = info.getFuncDesc(f);
			String FName = getFunctionName(funcdesc);
			perhapsAddNameToSet(holder,FName);
		}
		String[] FunctionNames = new String[holder.size()];
		holder.toArray(FunctionNames);
		
		
		for(int f=0; f < count; f++) {
			ITypeInfo.FuncDesc   funcdesc   = info.getFuncDesc(f);
			writeFuncDesc(info,funcdesc);
		}
		count = attr.getVars();
		for(int f=0; f < count; f++) {
			ITypeInfo.VarDesc   vardesc   = info.getVarDesc(f);
			// These vars are really property gets
			if(vardesc.getVarKind() == ITypeInfo.VAR_DISPATCH)
			    writeVarDesc(info,vardesc);
		}
		dropIndent();
		indent();
		println("</Dispatch>");
	}
	
	protected void perhapsAddNameToSet(Collection holder,String Name)
	{
	    if(Name.equals("QueryInterface"))
	        return;
	    if(Name.equals("AddRef"))
	        return;
	    if(Name.equals("Release"))
	        return;
	    if(Name.equals("GetTypeInfoCount"))
	        return;
	    if(Name.equals("GetTypeInfo"))
	        return;
	    if(Name.equals("Invoke"))
	        return;
	    if(Name.equals("GetIDsOfNames"))
	        return;
	    holder.add(Name);
	}

    protected String getFunctionName(ITypeInfo.FuncDesc funcdesc) throws JComException
    {
		String[]             names      = funcdesc.getNames();
		return(names[0]);
	}
	
    protected void writeFuncDesc(ITypeInfo info,ITypeInfo.FuncDesc funcdesc) throws JComException
    {
		ITypeInfo.ElemDesc   elemFunc   = funcdesc.getFunc();
		String[]             names      = funcdesc.getNames();
		// IDispatchȊO̊֐𐶐BQueryInterface()Ȃǂ͂Ȃ
		if(isIDispatchFunction(names[0])) 
		    return;
	
		String[] funcdocs = info.getDocumentation(funcdesc.getMemID());
	    if(funcdocs[0].equals("SynonymInfo"))
	        indent(); // debugging distinction
	    else   
	        indent();
	    print("<funcdesc ");
	    if(funcdocs != null) {
	       if(funcdocs.length > 0) {
	            print("name=\"" + funcdocs[0] + "\" ");
	        }
	        if(funcdocs.length > 2) {
	            try {
	                int test = Integer.parseInt(funcdocs[2]);
	                String id = Integer.toHexString(test);
	             //   print("\" id=\"" + id + "\" ");
	                print(" dispid=\"" + funcdesc.getMemID() + "\" ");
	             //   print("value=\"" + test + "\" ");
	            }
	            catch(NumberFormatException ex) {
	                ex.printStackTrace();
	            }

	        }
	    }
	    println(" >");
	    addIndent();
	/*	if(funcdocs != null) {
		    for(int i = 0; i < funcdocs.length; i++) 
		        printDoc(funcdocs[i]);
		}
		*/
		printKind(funcdesc);
		indent();
		println("<return com_type=\"" + filterTypeDesc(elemFunc.getTypeDesc()) + "\" type=\"" + getJavaType(elemFunc.getTypeDesc()) + "\" />");
		printParams(funcdesc,names);
		checkUserDefined(info, elemFunc.getTypeDesc());
	    dropIndent();
		indent();
		println("</funcdesc>");
	}
	
	protected String filterTypeDesc(String in)
	{
	    if(in.indexOf("VT_USERDEFINED(") == -1) 
	        return(in);
	        
	    int index = in.indexOf("):");
	    if(index > 0) {
	        if(in.startsWith("VT_USERDEFINED"))
	            return("VT_USERDEFINED:" + in.substring(index + 2));
	        else
	            return("VT_USERDEFINED:" + in.substring(index + 2) + "*");
	    }
	    else {
	        return(in);
	    }
	}
	
    protected void printParams(ITypeInfo.FuncDesc funcdesc,String[] names)
    {
		ITypeInfo.ElemDesc[] elemParams = funcdesc.getParams();
		if(elemParams == null)
		    return;
		for(int p=0; p < elemParams.length; p++) {
		    indent();
		    String ComType = filterTypeDesc(elemParams[p].getTypeDesc());
		    String JavaType = getJavaType(elemParams[p].getTypeDesc());
		    print("<param com_type=\"" + ComType +
		        "\" type=\"" + JavaType + "\" flags=\"" +
		        elemParams[p].getIDL() + "\" ");
		    
		    if(names.length > p+1) 
		        print("name=\"" + names[p+1] + "\" ");
		    else
		        print("name=\"unknown\" ");
		        
		    println("/>");
		}
	}

	
	protected void printDoc(String s)
	{
	    if(s == null || s.length() == 0)
	        return;
	    indent();
	    println("<doc value=\"" + s.trim() + "\" />");
	}
	
	protected void printKind(ITypeInfo.FuncDesc funcdesc)
	{
	    indent();
	    print("<kind value=\"");
		switch(funcdesc.getInvokeKind()) {
			case ITypeInfo.INVOKE_FUNC:
				print("IDispatch.METHOD");
				break;
			case ITypeInfo.INVOKE_PROPERTYGET:
				print("IDispatch.PROPERTYGET");
				break;
			case ITypeInfo.INVOKE_PROPERTYPUT:
				print("IDispatch.PROPERTYPUT");
				break;
			case ITypeInfo.INVOKE_PROPERTYPUTREF:
			    print("INVOKE_PROPERTYPUTREF");
        }
	    println("\" />");
	}

	//	TYPEATTR.typekind  TKIND_COCLASS ̃mɑ΂Đ
	public void generateCoClass(ITypeInfo info)  throws JComException
	{
		String[] docs = info.getDocumentation(-1);
		indent();
		print("<CoClass name=\"");
		print(docs[0]);
		print("\" ");
		ITypeInfo.TypeAttr attr = info.getTypeAttr();
		String IIDRawString = attr.getIID().toString();
		
		System.out.println("Handling Dispatch " + docs[0]);
		print(" iid=\"" + IIDRawString + "\" ");
		println(" >");
		addIndent();
		printCoClassTypes(info,docs);
		dropIndent();
		indent();
		println("</CoClass>");
	}
	
	
	//	TYPEATTR.typekind  TKIND_COCLASS ̃mɑ΂Đ
	protected void printCoClassTypes(ITypeInfo info,String[] docs)  throws JComException
	{
		ITypeInfo.TypeAttr attr = info.getTypeAttr();
		for(int i=0; i<attr.getImplTypes(); i++) {
			ITypeInfo imp = info.getImplType(i);
			indent();
			println("<typedoc doc=\"" + imp.getDocumentation(-1)[0] + "\" />");
		}
		ITypeInfo impl = info.getImplType(0);
		indent();
		println("<typedoc doc=\"" + impl.getDocumentation(-1)[0] + "\" />");
	}
	/**
		IDispatchC^[tF[XŒ`Ă֐ǂ𒲂ׂB
		PɊ֐ŔfĂ邾B
	*/
	protected boolean isIDispatchFunction(String funcname) {
		String[] fnames = {
			"QueryInterface",
			"AddRef",
			"Release",
			"GetTypeInfoCount",
			"GetTypeInfo",
			"GetIDsOfNames",
			"Invoke" };
		for(int i=0; i<fnames.length; i++) {
			if(funcname.equals(fnames[i])) return true;
		}
		return false;
	}
	/**
		VARIANŤ^Javǎ^ɕϊ
	*/
	protected String getJavaType(String type) {
		if(type.equals("VT_INT")) return "int";				// Ȃ
		if(type.equals("VT_UI1")) return "byte";
		if(type.equals("VT_I2")) return "short";
		if(type.equals("VT_I4")) return "int";
		if(type.equals("VT_R4")) return "float";
		if(type.equals("VT_R8")) return "double";
		if(type.equals("VT_BSTR")) return "String";
		if(type.equals("VT_VOID")) return "void";			// Ȃ
		if(type.equals("VT_VARIANT")) return "Object";		// Ȃ
		if(type.equals("VT_BOOL")) return "boolean";
		if(type.equals("VT_HRESULT")) return "HRESULT";
		if(type.equals("VT_DISPATCH")) return "IDispatch";
		if(type.equals("VT_UNKNOWN")) return "IUnknown";
		if(type.equals("VT_DATE")) return "java.util.Date";
		if(type.equals("VT_PTR+VT_I4")) return "int[]";
		if(type.equals("VT_PTR+VT_R8")) return "double[]";
		if(type.equals("VT_PTR+VT_BOOL")) return "boolean[]";
		if(type.equals("VT_PTR+VT_BSTR")) return "String[]";
		if(type.equals("VT_PTR+VT_VARIANT")) return "Object[]";
		if(type.equals("VT_PTR+VT_SAFEARRAY+VT_BSTR")) return "String[]";

		if(type.startsWith("VT_PTR+VT_USERDEFINED")) {
			String clsname = type.substring(type.indexOf(':')+1);
			// CuH
			try {
				int hRefType = ITypeInfo.getRefTypeFromTypeDesc(type);
				ITypeLib reflib = currentInfo.getRefTypeInfo(hRefType).getTypeLib();
				if(reflib.getTLibAttr().equals(currentLib.getTLibAttr())) {
					return clsname;
				}
				// EEEAtpXŕ\
//				String packagename = getPackageName(packagePath, reflib);
//				return packagename+"."+clsname;
			} 
			catch(Exception e) 
			{ e.printStackTrace(); }
			return "@@@" +clsname; // com.lordjoe.utilities.UnknownCOMType"; //"@@@"+clsname;
		}

		// VT_PTR̂ȂVT_USERDEFINEDEnumƌȂAEnumintƂ݂ȂBƗ\H
		if(type.startsWith("VT_USERDEFINED")) 
		    return "int";
		return "@@@"+type; //"com.lordjoe.utilities.UnknownCOMType"; //
	}
	/**
		̃CũR|[lg܂ނH
	*/
	protected boolean containStranger(ITypeInfo.FuncDesc funcdesc) {
		ITypeInfo.ElemDesc   elemFunc   = funcdesc.getFunc();
		if(isStranger(elemFunc.getTypeDesc())) return true;
		ITypeInfo.ElemDesc[] elemParams = funcdesc.getParams();
		if(elemParams == null) return false;
		for(int p=0; p<elemParams.length; p++) {
			if(isStranger(elemParams[p].getTypeDesc())) return true;
		}
		return false;
	}
	/**
		̃CũR|[lgH
	*/
	protected boolean isStranger(String type) {
		if(! type.startsWith("VT_PTR+VT_USERDEFINED")) return false;
		String clsname = type.substring(type.indexOf(':')+1);
		// CuH
		try {
			int hRefType = ITypeInfo.getRefTypeFromTypeDesc(type);
			ITypeLib reflib = currentInfo.getRefTypeInfo(hRefType).getTypeLib();
			if(reflib.getTLibAttr().equals(currentLib.getTLibAttr())) return false;
		} catch(Exception e) { e.printStackTrace(); }
		// EEE
		return true;
	}
	/**
		ݒ肷ӏ𐶐
	*/
	String generateArgument(ITypeInfo.ElemDesc elem, String name) {
		String jtype = getJavaType(elem.getTypeDesc());
		if(jtype.equals("byte")) return "new Byte("+name+")";
		if(jtype.equals("short")) return "new Short("+name+")";
		if(jtype.equals("int")) return "new Integer("+name+")";
		if(jtype.equals("float")) return "new Float("+name+")";
		if(jtype.equals("double")) return "new Double("+name+")";
		if(jtype.equals("boolean")) return "new Boolean("+name+")";
		if(jtype.equals("String")) return name;
		if(jtype.equals("Object")) return name;			// Ȃ
		if(jtype.equals("IUnknown")) return name;	// 悢H
		if(jtype.equals("IDispatch")) return name;	// 悢H
		if(elem.getTypeDesc().startsWith("VT_PTR+VT_USERDEFINED")) return name;
		if(jtype.equals("int[]")) return name;
		if(jtype.equals("double[]")) return name;
		if(jtype.equals("boolean[]")) return name;
		if(jtype.equals("String[]")) return name;
		return "@@@"+name; //"com.lordjoe.utilities.UnknownCOMType"; 
	}
	/**
		return𐶐
	*/
	String generateReturnStatement(ITypeInfo.ElemDesc elem, String var) {
		String jtype = getJavaType(elem.getTypeDesc());
		if(jtype.equals("void")) return "return;";			// Ȃ
		if(jtype.equals("byte")) return "return ((Byte)"+var+").byteValue();";
		if(jtype.equals("short")) return "return ((Short)"+var+").shortValue();";
		if(jtype.equals("int")) return "return ((Integer)"+var+").intValue();";
		if(jtype.equals("float")) return "return ((Float)"+var+").floatValue();";
		if(jtype.equals("double")) return "return ((Double)"+var+").doubleValue();";
		if(jtype.equals("boolean")) return "return ((Boolean)"+var+").booleanValue();";
		if(jtype.equals("Object")) return "return "+var+";";			// Ȃ
		if(jtype.equals("String")) return "return (String)"+var+";";
		if(jtype.equals("java.util.Date")) return "return (java.util.Date)"+var+";";
		if(elem.getTypeDesc().startsWith("VT_PTR+VT_USERDEFINED"))
				return "return new "+getJavaType(elem.getTypeDesc())+"((IDispatch)"+var+");";
		if(elem.getTypeDesc().equals("VT_DISPATCH"))
				return "return (IDispatch)"+var+";";
		if(elem.getTypeDesc().equals("VT_UNKNOWN"))
				return "return (IUnknown)"+var+";";

		return "return "+jtype+"@@@"+var; // "return com.lordjoe.utilities.UnknownCOMType"; //"@@@"+var;
	}

	//	[U`^̏ꍇA̐giITypeLibj􂤁B
	public void checkUserDefined(ITypeInfo info, String type)  throws JComException
	{
		if(! type.startsWith("VT_PTR+VT_USERDEFINED")) return;
		// "VT_PTR+VT_USERDEFINED(50383648):Application"hreftypeo
		int hreftype = ITypeInfo.getRefTypeFromTypeDesc(type);
		ITypeInfo refinfo = info.getRefTypeInfo(hreftype);
		ITypeLib lib = refinfo.getTypeLib();
		addTLibAttr(lib.getTLibAttr());
	}
	// TLibAttrW߂
	Vector libset = new Vector();
	public boolean addTLibAttr(ITypeLib.TLibAttr attr)  throws JComException
	{
		// łɓITypeLib邩ǂH
		for(int i=0; i<libset.size(); i++) {
			if(libset.get(i).equals(attr)) return false;
		}
		libset.add(attr);
		return true;
	}

	// ^CvCuw肵ITypeInfo̓eo͂
	void generate(ITypeLib lib,String infoname)  throws JComException
	{
		currentLib = lib;
		int infocount = lib.getTypeInfoCount();
		// w肵IuWFNg\B
		for(int i=0; i<infocount; i++) {
			ITypeInfo info = lib.getTypeInfo(i);
			if(info.getDocumentation(-1)[0].equals(infoname)) {
				generate(info);
				System.out.println("o͂܂B");
				break;	// I
			}
		}
	}
    protected void writeVarDesc(ITypeInfo info,ITypeInfo.VarDesc vdesc) throws JComException
    {
	    int id =  vdesc.getMemID();
	    int kind =  vdesc.getVarKind();
	    ITypeInfo.ElemDesc desc = vdesc.getVar();
	    String[] names =  vdesc.getNames();
	    Object value = vdesc.getValue();
	    indent();
	    print("<vardesc ");
	    if(names != null) {
	       if(names.length > 0) {
	            print("name=\"" + names[0] + "\" ");
	        }
	    }
	    print("id=\"" + id + "\" ");
	    print("kind=\"" + kind + "\" ");
	    if(value != null)
	        print("value=\"" + value + "\" ");
	    if(desc != null) {
            print("com_type=\"" + filterTypeDesc(desc.getTypeDesc()) +
		        "\" type=\"" + getJavaType(desc.getTypeDesc()) + "\" ");
	    }
	    println(" />");
	}


	/**
	* show program usage
	*/
	public static void usage() {
		    System.out.println("Usage:"); 
		    System.out.println("java jp.jcomgenerator.XMLGenerator <ComNames>"); 
		    System.out.println("ie: java jp.jcomgenerator.XMLGenerator Excel.Application"); 
	}

    
	public static void main(String[] args) throws Exception {
		if(args.length==0) {
		    usage();
		    return; 
		}
		ReleaseManager rm = new ReleaseManager();
		try {
		    for(int i = 0; i < args.length; i++) {
    		    XMLGenerator generator = new XMLGenerator(rm,args[i]);
    		    generator.doGeneration();
		    }
		}
		catch(Exception e) { 
		    e.printStackTrace(); 
		}
		finally { rm.release(); }
	}
}

/*
	generate(ITypeInfo info)
		generateEnum(ITypeInfo info)
		generateDispatch(ITypeInfo info)
		generateCoClass(ITypeInfo info)

*/

