#include "atlbase.h"
#include "atlconv.h"
#include <stdio.h>
#include "ComDesc.h"


//------------------------------------------------------------------------------
//	TYPEDESC\̂\B VT_XXX̑gݍ킹ɂB
void print_TYPEDESC(TYPEDESC* td, ITypeInfo* pITypeInfo)
{
	print_VARTYPE(td->vt);
	// @@@@ union͂܂
	if(td->vt==VT_PTR || td->vt==VT_SAFEARRAY) {
		printf("|");
		print_TYPEDESC(&td->lptdesc[0], pITypeInfo);
	}
	else if(td->vt==VT_USERDEFINED) {
		ITypeInfo* pUserTypeInfo = NULL;
		HRESULT hr = pITypeInfo->GetRefTypeInfo( td->hreftype, &pUserTypeInfo ); 
		print2_Documentaion(pUserTypeInfo,MEMBERID_NIL);
		pUserTypeInfo->Release();
	}
}
void print2_TYPEDESC(TYPEDESC* td, ITypeInfo* pITypeInfo)
{
	if(td->vt==VT_PTR || td->vt==VT_SAFEARRAY) {
		print2_TYPEDESC(&td->lptdesc[0], pITypeInfo);
		printf("*");
	}
	else if(td->vt==VT_USERDEFINED) {
		ITypeInfo* pUserTypeInfo = NULL;
		HRESULT hr = pITypeInfo->GetRefTypeInfo( td->hreftype, &pUserTypeInfo ); 
		print2_Documentaion(pUserTypeInfo,MEMBERID_NIL);
		pUserTypeInfo->Release();
	}
	else print2_VARTYPE(td->vt);
}
#if 0
typedef struct  tagTYPEDESC {
    /* [switch_is][switch_type] */
    union {
        /* [case()] */ struct tagTYPEDESC __RPC_FAR *lptdesc;
        /* [case()] */ struct tagARRAYDESC __RPC_FAR *lpadesc;
        /* [case()] */ HREFTYPE hreftype;
        /* [default] */  /* Empty union arm */ 
    }	;
    VARTYPE vt;
}	TYPEDESC;
Describes the type of a variable, the return type of a function, 
or the type of a function parameter. It is defined as follows: 

typedef struct FARSTRUCT tagTYPEDESC {
	union {
		// VT_PTR|VT_SAFEAEEAY, the pointed-at type.
		struct FARSTRUCT tagTYPEDESC FAR* lptdesc;

		// VT_CARRAY.
		struct FARSTRUCT tagARRAYDESC FAR* lpadesc;

		// VT_USERDEFINED is used to get type information for a 
		// user-defined type.
		HREFTYPE hreftype;

	}UNION_NAME(u);
	VARTYPE vt;
} TYPEDESC;
 
If the variable is VT_SAFEARRAY or VT_PTR, 
the union portion of the TYPEDESC contains a pointer to a TYPEDESC 
that specifies the element type
#endif

//------------------------------------------------------------------------------
// IDLDESC\̂̓e\B [in, out]ȂǂɂB
void print_IDLDESC(IDLDESC* idl)
{
	printf("0x%04X(",idl->wIDLFlags);
	if(idl->wIDLFlags == IDLFLAG_NONE) {	printf("IDLFLAG_NONE)");	return; }
	if(idl->wIDLFlags & IDLFLAG_FIN)		printf("IDLFLAG_FIN ");
	if(idl->wIDLFlags & IDLFLAG_FOUT)		printf("IDLFLAG_FOUT ");
	if(idl->wIDLFlags & IDLFLAG_FLCID)		printf("IDLFLAG_FLCID ");
	if(idl->wIDLFlags & IDLFLAG_FRETVAL)	printf("IDLFLAG_FRETVAL ");
	printf(")");
}
#if 0
typedef struct  tagIDLDESC
    {
    ULONG dwReserved;
    USHORT wIDLFlags;
    }	IDLDESC;
#endif

//------------------------------------------------------------------------------
//	 ELEMDESC\̂̓e\BVT_XXX[in,out]ɂB
void print_ELEMDESC(ELEMDESC* ed, ITypeInfo* pITypeInfo)
{
	print_TYPEDESC(&ed->tdesc, pITypeInfo);
	// @@@@ union͂܂  Ƃ肠AIDLDESCƂĉ
	printf(" ");
	print_IDLDESC(&ed->idldesc);
}
void print2_ELEMDESC(ELEMDESC* ed, ITypeInfo* pITypeInfo)
{
	// @@@@ union͂܂  Ƃ肠AIDLDESCƂĉ
	printf("[");
	if(ed->idldesc.wIDLFlags & IDLFLAG_FIN)		printf("in");
	if(ed->idldesc.wIDLFlags & IDLFLAG_FOUT)	printf("out");
	if(ed->idldesc.wIDLFlags & IDLFLAG_FLCID)	printf("LCID");
	if(ed->idldesc.wIDLFlags & IDLFLAG_FRETVAL)	printf("retval");
	printf("]");
	print2_TYPEDESC(&ed->tdesc, pITypeInfo);
}
#if 0
typedef struct tagELEMDESC {
    TYPEDESC tdesc;             /* the type of the element */
    union {
        IDLDESC idldesc;        /* info for remoting the element */
        PARAMDESC paramdesc;    /* info about the parameter */
    };
} ELEMDESC, * LPELEMDESC;
#endif

//------------------------------------------------------------------------------
//	TYPEATTR\̂̓e\B
void print_TYPEATTR(TYPEATTR* pAttr, ITypeInfo* pITypeInfo)
{
	printf("TYPEATTR {\n");
	printf("  GUID guid = {");		print_GUID(&pAttr->guid); 	printf("}\n");
	printf("  LCID lcid = 0x%04X\n", pAttr->lcid);
	printf("  MEMBERID memidConstructor = %d\n", pAttr->memidConstructor);
	printf("  MEMBERID memidDestructor  = %d\n", pAttr->memidDestructor);
	printf("  OLECHAR* lpstrSchema      = %p // Reserved for future use.\n", pAttr->lpstrSchema);
	printf("  ULONG    cbSizeInstance   = %d\n", pAttr->cbSizeInstance);
	switch(pAttr->typekind) {
	case 0:		printf("  TYPEKIND typekind         = 0 // TKIND_ENUM\n");			break;
	case 1:		printf("  TYPEKIND typekind         = 1 // TKIND_RECORD\n");		break;
	case 2:		printf("  TYPEKIND typekind         = 2 // TKIND_MODULE\n");		break;
	case 3:		printf("  TYPEKIND typekind         = 3 // TKIND_INTERFACE\n");		break;
	case 4:		printf("  TYPEKIND typekind         = 4 // TKIND_DISPATCH\n");		break;
	case 5:		printf("  TYPEKIND typekind         = 5 // TKIND_COCLASS\n");		break;
	case 6:		printf("  TYPEKIND typekind         = 6 // TKIND_ALIAS\n");			break;
	case 7:		printf("  TYPEKIND typekind         = 7 // TKIND_UNION\n");			break;
	case 8:		printf("  TYPEKIND typekind         = 8 // TKIND_MAX\n");			break;
	default:	printf("  TYPEKIND typekind         = %d ???\n", pAttr->typekind);	break;
	}
	printf("  USHORT   cFuncs           = %d\n", pAttr->cFuncs);
	printf("  USHORT   cVars            = %d\n", pAttr->cVars);
	printf("  USHORT   cImplTypes       = %d\n", pAttr->cImplTypes);
	printf("  USHORT   cbSizeVft        = %d\n", pAttr->cbSizeVft);
	printf("  USHORT   cbAlignment      = %d\n", pAttr->cbAlignment);
	printf("  USHORT   wTypeFlags       = 0x%X\n", pAttr->wTypeFlags);
	printf("  USHORT   wMajorVerNum     = %d\n", pAttr->wMajorVerNum);
	printf("  USHORT   wMinorVerNum     = %d\n", pAttr->wMinorVerNum);
	printf("  TYPEDESC tdescAlias       = ");	print_TYPEDESC(&pAttr->tdescAlias, pITypeInfo); printf("\n");
	printf("  IDLDESC idldescType       = ");	print_IDLDESC(&pAttr->idldescType);	printf("\n");
	printf("}\n");
}
#if 0
typedef struct FARSTRUCT tagTYPEATTR {
	GUID guid;					// The GUID of the type information. 
	LCID lcid;					// Locale of member names and doc
								// strings.
	unsigned long dwReserved;
	MEMBERID memidConstructor;	// ID of constructor, or MEMBERID_NIL if 
								// none.
	MEMBERID memidDestructor;	// ID of destructor, or MEMBERID_NIL if 
								// none. 	OLECHAR FAR* lpstrSchema;
								// Reserved for future use.
	unsigned long cbSizeInstance;// The size of an instance of 
								// this type.	TYPEKIND typekind;
								// The kind of type this information
								// describes.	unsigned short cFuncs;
								// Number of functions.
	unsigned short cVars;		// Number of variables/data members.
	unsigned short cImplTypes;	// Number of implemented interfaces.
	unsigned short cbSizeVft;	// The size of this type's VTBL.
	unsigned short cbAlignment;	// Byte alignment for an instance 
								// of this type.	unsigned short wTypeFlags;
	unsigned short wMajorVerNum;	// Major version number.
	unsigned short wMinorVerNum;	// Minor version number.
	TYPEDESC tdescAlias;			// If TypeKind == TKIND_ALIAS, 
								// specifies the type for which 	
								// this type is an alias.
	IDLDESC idldescType;		// IDL attributes of the 		
								// described type.
} TYPEATTR, FAR* LPTYPEATTR;
#endif
//------------------------------------------------------------------------------
//	FUNCDESC\̂̓e\BP̃\bhAvpeBɂB
void	print_FUNCDESC(FUNCDESC* pFuncDesc, ITypeInfo* pITypeInfo)
{
	printf("FUNCDESC {\n");
	printf("  MEMBERID memid = 0x%08X\n", pFuncDesc->memid);
	printf("  SCODE* lprgscode = {");
	for(int i=0; i<pFuncDesc->cScodes; i++) {
		if(i!=0) printf(",");
		printf("0x%08X", pFuncDesc->lprgscode[i]);
	} printf("}\n");
	printf("  ELEMDESC* lprgelemdescParam = {");			//	̓e
	for(int k=0; k<pFuncDesc->cParams; k++) {
		if(k!=0) printf(",");
		print_ELEMDESC(&pFuncDesc->lprgelemdescParam[k], pITypeInfo);
	} printf("}\n");
	switch(pFuncDesc->funckind) {
		case 0:		printf("  FUNCKIND funckind  = 0 // FUNC_VIRTUAL\n");			break;
		case 1:		printf("  FUNCKIND funckind  = 1 // FUNC_PUREVIRTUAL\n");		break;
		case 2:		printf("  FUNCKIND funckind  = 2 // FUNC_NONVIRTUAL\n");		break;
		case 3:		printf("  FUNCKIND funckind  = 3 // FUNC_STATIC\n");			break;
		case 4:		printf("  FUNCKIND funckind  = 4 // FUNC_DISPATCH\n");			break;
		default:	printf("  FUNCKIND funckind  = %d ???\n", pFuncDesc->funckind);	break;
	}
	switch(pFuncDesc->invkind) {
		case 1:		printf("  INVOKEKIND invkind = 1 // INVOKE_FUNC\n");			break;
		case 2:		printf("  INVOKEKIND invkind = 2 // INVOKE_PROPERTYGET\n");		break;
		case 4:		printf("  INVOKEKIND invkind = 4 // INVOKE_PROPERTYPUT\n");		break;
		case 8:		printf("  INVOKEKIND invkind = 8 // INVOKE_PROPERTYPUTREF\n");	break;
		default:	printf("  INVOKEKIND invkind = %d ???\n", pFuncDesc->invkind);	break;
	}
	switch(pFuncDesc->callconv) {
		case CC_FASTCALL:	printf("  CALLCONV callconv = %d // CC_FASTCALL\n",	pFuncDesc->callconv);	break;
		case CC_CDECL:		printf("  CALLCONV callconv = %d // CC_CDECL\n",	pFuncDesc->callconv);	break;
		case CC_MSCPASCAL:	printf("  CALLCONV callconv = %d // CC_MSCPASCAL\n",pFuncDesc->callconv);	break;
		case CC_MACPASCAL:	printf("  CALLCONV callconv = %d // CC_MACPASCAL\n",pFuncDesc->callconv);	break;
		case CC_STDCALL:	printf("  CALLCONV callconv = %d // CC_STDCALL\n",	pFuncDesc->callconv);	break;
		case CC_FPFASTCALL:	printf("  CALLCONV callconv = %d // CC_FPFASTCALL\n",pFuncDesc->callconv);	break;
		case CC_SYSCALL:	printf("  CALLCONV callconv = %d // CC_SYSCALL\n",	pFuncDesc->callconv);	break;
		case CC_MPWCDECL:	printf("  CALLCONV callconv = %d // CC_MPWCDECL\n",	pFuncDesc->callconv);	break;
		case CC_MPWPASCAL:	printf("  CALLCONV callconv = %d // CC_MPWPASCAL\n",pFuncDesc->callconv);	break;
		case CC_MAX:		printf("  CALLCONV callconv = %d // CC_MAX\n",		pFuncDesc->callconv);	break;
		default:			printf("  CALLCONV callconv = %d ???\n",			pFuncDesc->callconv);	break;
	}
	printf("  short cParams    = %d\n", pFuncDesc->cParams);
	printf("  short cParamsOpt = %d\n", pFuncDesc->cParamsOpt);
	printf("  short oVft       = %d\n", pFuncDesc->oVft);
	printf("  short cScodes    = %d\n", pFuncDesc->cScodes);
	//	߂l̓e
	printf("  ELEMDESC elemdescFunc = ");	print_ELEMDESC(&pFuncDesc->elemdescFunc, pITypeInfo);	printf("\n");
	printf("  WORD wFuncFlags  = %xh\n", pFuncDesc->wFuncFlags);
	printf("}\n");
}
void	print2_FUNCDESC(FUNCDESC* pFuncDesc, ITypeInfo* pITypeInfo)
{
	//	̓e
	printf("(");
	for(int k=0; k<pFuncDesc->cParams; k++) {
		if(k!=0) printf(",");
		print2_ELEMDESC(&pFuncDesc->lprgelemdescParam[k], pITypeInfo);
	} printf(") ");

	switch(pFuncDesc->invkind) {
		case 1:		printf("INVOKE_FUNC");		break;
		case 2:		printf("PROPERTYGET");		break;
		case 4:		printf("PROPERTYPUT");		break;
		case 8:		printf("PROPERTYPUTREF");	break;
		default:	printf("???");	break;
	}
	//	߂l̓e
	printf(" ");
	print2_ELEMDESC(&pFuncDesc->elemdescFunc, pITypeInfo);
	printf("\n");
}

//------------------------------------------------------------------------------
// õhLg\
void print_Documentaion(ITypeInfo* pITypeInfo, MEMBERID memid)
{
	BSTR bstrName;
	BSTR bstrDocString;
	unsigned long dwHelpContext = 0;
	BSTR bstrHelpFile;
	HRESULT hr = pITypeInfo->GetDocumentation( memid,
						&bstrName, &bstrDocString, &dwHelpContext, &bstrHelpFile ); 
	printf("Documentaion {\n");
	if(SUCCEEDED(hr)) {
		printf("  bstrName      = '");	print_bstring(bstrName);		SysFreeString(bstrName);		printf("'\n");
		printf("  bstrDocString = '");	print_bstring(bstrDocString);	SysFreeString(bstrDocString);	printf("'\n");
		printf("  dwHelpContext = %d\n", dwHelpContext);
		printf("  bstrHelpFile  = '");	print_bstring(bstrHelpFile);	SysFreeString(bstrHelpFile);	printf("'\n");
		/*
			Excel.Application̏ꍇA唼̃o 8002802B TYPE_E_ELEMENTNOTFOUND ԂB
			܂AhLgȂƂƁB
			AG[͂Ɍy`ȂB
		*/
	}
	printf("}\n");
}
// ITypeInfõhLg\  MEMBERID_NIL
void print2_Documentaion(ITypeInfo* pITypeInfo, MEMBERID memid)
{
	BSTR bstrName;
	HRESULT hr = pITypeInfo->GetDocumentation( memid, &bstrName, NULL, NULL, NULL ); 
	if(SUCCEEDED(hr)) {
		print_bstring(bstrName);	SysFreeString(bstrName);
	}
}

//------------------------------------------------------------------------------
// ITypeInfoMops\
void print_Mops(ITypeInfo* pITypeInfo, MEMBERID memid)
{
	BSTR bstrMops;
	HRESULT hr = pITypeInfo->GetMops( memid, &bstrMops );
	if(SUCCEEDED(hr)) {
		if(bstrMops==NULL) {
			printf("Mops = (null)\n");
			SysFreeString(bstrMops);
		}
		else {
			printf("Mops = '"); print_bstring(bstrMops); SysFreeString(bstrMops); printf("'\n");
		}
	}
}


//------------------------------------------------------------------------------
//	ckk̃Gg\
//	TYPE_E_ELEMENTNOTFOUND	0x8002802BL 
//	TYPE_E_BADMODULEKIND	0x800288BDL	W[̎ނ
void print_DllEntry(ITypeInfo* pITypeInfo, MEMBERID memid, INVOKEKIND invKind)
{
	BSTR bstrDllName;
	BSTR bstrName;
	unsigned short wOrdinal;
	HRESULT hr = pITypeInfo->GetDllEntry( memid,invKind, 
					&bstrDllName, &bstrName, &wOrdinal ); 
	printf("DllEntry {\n");
	if(SUCCEEDED(hr)) {
		printf("  bstrDllName = ");	print_bstring(bstrDllName); SysFreeString(bstrDllName); printf("\n");
		printf("  bstrName    = ");	print_bstring(bstrName); SysFreeString(bstrName); printf("\n");
		printf("  wOrdinal    = %d\n", wOrdinal);
	}else printf("hr=0x%08X\n", hr);
	printf("}\n");
}

//------------------------------------------------------------------------------
//	VARDESC\̂̓e\B
void print_VARDESC(VARDESC* pVarDesc, ITypeInfo* pITypeInfo)
{
	printf("VARDESC {\n");
	printf("  MEMBERID       memid       = %d\n", pVarDesc->memid);
	printf("  OLECHAR FAR*   lpstrSchema = %p\n", pVarDesc->lpstrSchema);	// Reserved for future use.
	if(pVarDesc->varkind == VAR_PERINSTANCE) {
		printf("  unsigned long oInst = %d\n", pVarDesc->oInst);
	}
	else if(pVarDesc->varkind == VAR_CONST) {
		printf("  VARIANT FAR*   lpvarValue  = ");
		print_VARIANT(pVarDesc->lpvarValue);
		printf("\n");
	}
	printf("  ELEMDESC       elemdescVar = ");	print_ELEMDESC(&pVarDesc->elemdescVar, pITypeInfo);	printf("\n");
	printf("  unsigned short wVarFlags   = 0x%08X\n", pVarDesc->wVarFlags);
	switch(pVarDesc->varkind) {
		case VAR_PERINSTANCE:	printf("  VARKIND        varkind     = %d //VAR_PERINSTANCE\n",pVarDesc->varkind);	break;
		case VAR_STATIC:		printf("  VARKIND        varkind     = %d //VAR_STATIC\n",pVarDesc->varkind);	break;
		case VAR_CONST:			printf("  VARKIND        varkind     = %d //VAR_CONST\n",pVarDesc->varkind);	break;
		case VAR_DISPATCH:		printf("  VARKIND        varkind     = %d //VAR_DISPATCH\n",pVarDesc->varkind);	break;
		default:				printf("  VARKIND        varkind     = %d //???\n",pVarDesc->varkind);	break;
	}
	printf("}\n");
}
void print2_VARDESC(VARDESC* pVarDesc, ITypeInfo* pITypeInfo)
{
//	printf("  ELEMDESC       elemdescVar = ");	print_ELEMDESC(&pVarDesc->elemdescVar, pITypeInfo);	printf("\n");
//	printf("  unsigned short wVarFlags   = 0x%08X\n", pVarDesc->wVarFlags);
	switch(pVarDesc->varkind) {
		case VAR_PERINSTANCE:	printf("VAR_PERINSTANCE ");
			printf("  unsigned long oInst = %d\n", pVarDesc->oInst);
			break;
		case VAR_STATIC:		printf("VAR_STATIC ");		break;
		case VAR_CONST:			printf("VAR_CONST ");
			print_VARIANT(pVarDesc->lpvarValue);
			break;
		case VAR_DISPATCH:		printf("VAR_DISPATCH ");	break;
		default:				printf("???");				break;
	}
}

#if 0
Describes a variable, constant, or data member. It is defined as follows: 

typedef struct FARSTRUCT tagVARDESC {
	MEMBERID memid;
	OLECHAR FAR* lpstrSchema;	// Reserved for future use.
	union {
								// VAR_PERINSTANCE, the offset of this 
								// variable within the instance.
	unsigned long oInst;

								// VAR_CONST, the value of the constant.
	VARIANT FAR* lpvarValue;

	} UNION_NAME(u);
	ELEMDESC elemdescVar;
	unsigned short wVarFlags;
	VARKIND varkind;
} VARDESC

#endif


//------------------------------------------------------------------------------
//	ڍׂɕ\
void	print_ITypeInfo(ITypeInfo* pITypeInfo)
{
	// TYPEATTR 擾
	TYPEATTR*  pAttr = NULL;
	HRESULT hr = pITypeInfo->GetTypeAttr(&pAttr);
	if(FAILED(hr)) {
		printf("hr=%Xh\n",hr);
		return;
	}
	print_TYPEATTR(pAttr, pITypeInfo);
	print_Documentaion(pITypeInfo, MEMBERID_NIL);
	print_Mops(pITypeInfo, MEMBERID_NIL);
//////////////////////////begin
/*
	// ĂTypeInfo̐
	for(i=0; i<pAttr->cImplTypes ; i++) {
		printf("-----------------------------------------------ITypeInfo.ImplType %d\n",i);
		HREFTYPE hRefType = NULL;
		hr = pITypeInfo->GetRefTypeOfImplType((unsigned int) i, &hRefType);

		ITypeInfo* pUserTypeInfo = NULL;
		HRESULT hr = pITypeInfo->GetRefTypeInfo( hRefType, &pUserTypeInfo ); 
		printf("hRefType = "); print2_Documentaion(pUserTypeInfo,MEMBERID_NIL);	printf("\n");

		pUserTypeInfo->Release();
	}
*/
	for(int i=-1; i<pAttr->cImplTypes ; i++) {
		HREFTYPE hRefType = NULL;
		hr = pITypeInfo->GetRefTypeOfImplType((unsigned int) i, &hRefType);
if(hr==0) {
		ITypeInfo* pUserTypeInfo = NULL;
		HRESULT hr = pITypeInfo->GetRefTypeInfo( hRefType, &pUserTypeInfo ); 
		printf("ImplType %2d hRefType = ", i); print2_Documentaion(pUserTypeInfo,MEMBERID_NIL);	printf("\n");

		pUserTypeInfo->Release();
}
	}
///////////////////////// end

	// ֐̐
	for (i = 0; i < pAttr->cFuncs; i++) {
		printf("-----------------------------------------------ITypeInfo.FUNCDESC %d\n",i);
		// ֐̐擾Bڍׂɕ\
		FUNCDESC *pfuncdesc = NULL;
		hr = pITypeInfo->GetFuncDesc((unsigned int) i, &pfuncdesc);
		print_FUNCDESC(pfuncdesc, pITypeInfo);
		// O\BǂAŏ̖O֐̂悤B
		unsigned int cNames;
		const unsigned int MAX_NAMES = 100;
		BSTR rgNames[MAX_NAMES];
		hr = pITypeInfo->GetNames(pfuncdesc->memid, rgNames, MAX_NAMES, &cNames);
		for (int j = 0; j < cNames; j++) {
			print_bstring(rgNames[j]);
			printf(" ");
			SysFreeString(rgNames[j]);
		}
		printf("\n");
		// ֐̐ȗĕ\
		print2_FUNCDESC(pfuncdesc, pITypeInfo);
		print_DllEntry(pITypeInfo, pfuncdesc->memid, pfuncdesc->invkind);
		// hLe[VΕ\B
		print_Documentaion(pITypeInfo, pfuncdesc->memid);
		print_Mops(pITypeInfo, pfuncdesc->memid);
		pITypeInfo->ReleaseFuncDesc(pfuncdesc);
	}
	// ϐ̐
	for(i=0; i<pAttr->cVars; i++) {
		printf("-----------------------------------------------ITypeInfo.VARDESC %d\n",i);
		VARDESC* pVarDesc = NULL;
		hr = pITypeInfo->GetVarDesc((unsigned int) i, &pVarDesc);
		print_VARDESC(pVarDesc, pITypeInfo);
		// hLe[VΕ\B
		print_Documentaion(pITypeInfo, pVarDesc->memid);
		print_Mops(pITypeInfo, pVarDesc->memid);
		pITypeInfo->ReleaseVarDesc(pVarDesc);
	}

	pITypeInfo->ReleaseTypeAttr(pAttr);
}
//------------------------------------------------------------------------------
void	print2_ITypeInfo(ITypeInfo* pITypeInfo)
{
	// TYPEATTR 擾
	TYPEATTR*  pAttr = NULL;
	HRESULT hr = pITypeInfo->GetTypeAttr(&pAttr);
	if(FAILED(hr)) {
		printf("hr=%Xh\n",hr);
		return;
	}
	int funcs = pAttr->cFuncs;

	// ֐̐
	for (int i = 0; i < funcs; i++) {
		FUNCDESC *pFuncDesc = NULL;
		hr = pITypeInfo->GetFuncDesc((unsigned int) i, &pFuncDesc);

		switch(pFuncDesc->invkind) {
			case 1:		printf("INVOKE_FUNC");		break;
			case 2:		printf("PROPERTYGET");		break;
			case 4:		printf("PROPERTYPUT");		break;
			case 8:		printf("PROPERTYPUTREF");	break;
			default:	printf("???");	break;
		}
		printf(" ");
		
		unsigned int cNames;
		const unsigned int MAX_NAMES = 100;
		BSTR rgNames[MAX_NAMES];
		hr = pITypeInfo->GetNames(pFuncDesc->memid, rgNames, MAX_NAMES, &cNames);
		print_bstring(rgNames[0]);				SysFreeString(rgNames[0]);

		//	̓e
		printf("(");
		for(int k=0; k<pFuncDesc->cParams; k++) {
			if(k!=0) printf(",");
			print2_ELEMDESC(&pFuncDesc->lprgelemdescParam[k], pITypeInfo); printf(" ");
			print_bstring(rgNames[k+1]);		SysFreeString(rgNames[k+1]);
		}
		 printf(") ");

		//	߂l̓e
		print2_ELEMDESC(&pFuncDesc->elemdescFunc, pITypeInfo);
		printf("\n");
		pITypeInfo->ReleaseFuncDesc(pFuncDesc);
	}
	// ϐ̐
	for(i=0; i<pAttr->cVars; i++) {
		VARDESC* pVarDesc = NULL;
		hr = pITypeInfo->GetVarDesc((unsigned int) i, &pVarDesc);
		// hLe[VΕ\B
		print2_Documentaion(pITypeInfo, pVarDesc->memid);
		printf(" ");
		print2_VARDESC(pVarDesc, pITypeInfo);	printf("\n");
		pITypeInfo->ReleaseVarDesc(pVarDesc);
	}
	pITypeInfo->ReleaseTypeAttr(pAttr);
}


#if 0
    interface ITypeInfo : public IUnknown
    {
    public:
        virtual /* [local] */ HRESULT STDMETHODCALLTYPE GetTypeAttr( 
            /* [out] */ TYPEATTR __RPC_FAR *__RPC_FAR *ppTypeAttr) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE GetTypeComp( 
            /* [out] */ ITypeComp __RPC_FAR *__RPC_FAR *ppTComp) = 0;
        
        virtual /* [local] */ HRESULT STDMETHODCALLTYPE GetFuncDesc( 
            /* [in] */ UINT index,
            /* [out] */ FUNCDESC __RPC_FAR *__RPC_FAR *ppFuncDesc) = 0;
        
        virtual /* [local] */ HRESULT STDMETHODCALLTYPE GetVarDesc( 
            /* [in] */ UINT index,
            /* [out] */ VARDESC __RPC_FAR *__RPC_FAR *ppVarDesc) = 0;
        
        virtual /* [local] */ HRESULT STDMETHODCALLTYPE GetNames( 
            /* [in] */ MEMBERID memid,
            /* [length_is][size_is][out] */ BSTR __RPC_FAR *rgBstrNames,
            /* [in] */ UINT cMaxNames,
            /* [out] */ UINT __RPC_FAR *pcNames) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE GetRefTypeOfImplType( 
            /* [in] */ UINT index,
            /* [out] */ HREFTYPE __RPC_FAR *pRefType) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE GetImplTypeFlags( 
            /* [in] */ UINT index,
            /* [out] */ INT __RPC_FAR *pImplTypeFlags) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE GetIDsOfNames( 
            /* [size_is][in] */ LPOLESTR __RPC_FAR *rgszNames,
            /* [in] */ UINT cNames,
            /* [size_is][out] */ MEMBERID __RPC_FAR *pMemId) = 0;
        
        virtual /* [local] */ HRESULT STDMETHODCALLTYPE Invoke( 
            /* [in] */ PVOID pvInstance,
            /* [in] */ MEMBERID memid,
            /* [in] */ WORD wFlags,
            /* [out][in] */ DISPPARAMS __RPC_FAR *pDispParams,
            /* [out] */ VARIANT __RPC_FAR *pVarResult,
            /* [out] */ EXCEPINFO __RPC_FAR *pExcepInfo,
            /* [out] */ UINT __RPC_FAR *puArgErr) = 0;
        
        virtual /* [local] */ HRESULT STDMETHODCALLTYPE GetDocumentation( 
            /* [in] */ MEMBERID memid,
            /* [out] */ BSTR __RPC_FAR *pBstrName,
            /* [out] */ BSTR __RPC_FAR *pBstrDocString,
            /* [out] */ DWORD __RPC_FAR *pdwHelpContext,
            /* [out] */ BSTR __RPC_FAR *pBstrHelpFile) = 0;
        
        virtual /* [local] */ HRESULT STDMETHODCALLTYPE GetDllEntry( 
            /* [in] */ MEMBERID memid,
            /* [in] */ INVOKEKIND invKind,
            /* [out] */ BSTR __RPC_FAR *pBstrDllName,
            /* [out] */ BSTR __RPC_FAR *pBstrName,
            /* [out] */ WORD __RPC_FAR *pwOrdinal) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE GetRefTypeInfo( 
            /* [in] */ HREFTYPE hRefType,
            /* [out] */ ITypeInfo __RPC_FAR *__RPC_FAR *ppTInfo) = 0;
        
        virtual /* [local] */ HRESULT STDMETHODCALLTYPE AddressOfMember( 
            /* [in] */ MEMBERID memid,
            /* [in] */ INVOKEKIND invKind,
            /* [out] */ PVOID __RPC_FAR *ppv) = 0;
        
        virtual /* [local] */ HRESULT STDMETHODCALLTYPE CreateInstance( 
            /* [in] */ IUnknown __RPC_FAR *pUnkOuter,
            /* [in] */ REFIID riid,
            /* [iid_is][out] */ PVOID __RPC_FAR *ppvObj) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE GetMops( 
            /* [in] */ MEMBERID memid,
            /* [out] */ BSTR __RPC_FAR *pBstrMops) = 0;
        
        virtual /* [local] */ HRESULT STDMETHODCALLTYPE GetContainingTypeLib( 
            /* [out] */ ITypeLib __RPC_FAR *__RPC_FAR *ppTLib,
            /* [out] */ UINT __RPC_FAR *pIndex) = 0;
        
        virtual /* [local] */ void STDMETHODCALLTYPE ReleaseTypeAttr( 
            /* [in] */ TYPEATTR __RPC_FAR *pTypeAttr) = 0;
        
        virtual /* [local] */ void STDMETHODCALLTYPE ReleaseFuncDesc( 
            /* [in] */ FUNCDESC __RPC_FAR *pFuncDesc) = 0;
        
        virtual /* [local] */ void STDMETHODCALLTYPE ReleaseVarDesc( 
            /* [in] */ VARDESC __RPC_FAR *pVarDesc) = 0;
        
    };
#endif
