#include "atlbase.h"
#include "atlconv.h"
#include <stdio.h>
#include "ComDesc.h"

//------------------------------------------------------------------------------
//	TLIBATTR\̂̓e\B
void	print_TLIBATTR(TLIBATTR* pTLibAttr)
{
	printf("TLIBATTR {\n");
	printf("  GUID    guid         = {");		print_GUID(&pTLibAttr->guid); 	printf("}\n");
	printf("  LCID    lcid         = 0x%04X\n", pTLibAttr->lcid);
	switch(pTLibAttr->syskind) {
		case SYS_WIN16:	printf("  SYSKIND syskind      = %d // SYS_WIN16\n",pTLibAttr->syskind);	break;
		case SYS_WIN32:	printf("  SYSKIND syskind      = %d // SYS_WIN32\n",pTLibAttr->syskind);	break;
		case SYS_MAC:	printf("  SYSKIND syskind      = %d // SYS_MAC\n",pTLibAttr->syskind);	break;
		default:		printf("  SYSKIND syskind      = %d // ???\n",pTLibAttr->syskind);	break;
	}
	printf("  USHORT  wMajorVerNum = %d\n", pTLibAttr->wMajorVerNum);
	printf("  USHORT  wMinorVerNum = %d\n", pTLibAttr->wMinorVerNum);
	printf("  USHORT  wLibFlags    = 0x%X\n", pTLibAttr->wLibFlags);
	printf("}\n");
}
#if 0
typedef struct FARSTRUCT tagTLIBATTR {
    GUID guid;                      // Unique ID of the library.
    LCID lcid;                      // Language/locale of the library.
    SYSKIND syskind;                // Target hardware platform.
    unsigned short wMajorVerNum;    // Major version number.
    unsigned short wMinorVerNum;    // Minor version number.
    unsigned short wLibFlags;       // Library flags.
} TLIBATTR, FAR * LPTLIBATTR;
#endif
//------------------------------------------------------------------------------
//	index=-1̂Ƃ́ATypeLibg̃hLgԂ
void print_Documentation(ITypeLib* pITypeLib, int index)
{
	BSTR bstrName;
	BSTR bstrDocString;
	DWORD dwHelpContext;
	BSTR bstrHelpFile;
	HRESULT hr = pITypeLib->GetDocumentation(index,
						&bstrName, &bstrDocString, &dwHelpContext, &bstrHelpFile);
	printf("Documentaion {\n");
	if(SUCCEEDED(hr)) {
		printf("  bstrName      = '");	print_bstring(bstrName);	SysFreeString(bstrName);	printf("'\n");
		printf("  bstrDocString = '");	print_bstring(bstrDocString);	SysFreeString(bstrDocString);	printf("'\n");
		printf("  dwHelpContext = %d\n", dwHelpContext);
		printf("  bstrHelpFile  = '");	print_bstring(bstrHelpFile);	SysFreeString(bstrHelpFile);	printf("'\n");
	}
	else { printf("hr=%X\n",hr); }
	printf("}\n");
}

//------------------------------------------------------------------------------
void	print_ITypeLib(ITypeLib* pITypeLib)
{
	// TYPEATTR 擾
	TLIBATTR*  pTLibAttr = NULL;
	HRESULT hr = pITypeLib->GetLibAttr(&pTLibAttr);
	if(FAILED(hr)) {
		printf("hr=%Xh\n",hr);
		return;
	}
	print_TLIBATTR(pTLibAttr);
	print_Documentation(pITypeLib, -1);

	int typeinfocount = pITypeLib->GetTypeInfoCount();
	// ֐̐
	for (int i = 0; i < typeinfocount; i++) {
		printf("-----------------------------------------------ITypeLib.TypeInfo %d\n",i);
		ITypeInfo* pITypeInfo = NULL;
		HRESULT hr = pITypeLib->GetTypeInfo(i, &pITypeInfo);
		print_ITypeInfo(pITypeInfo);
		print_Documentation(pITypeLib, i);
		pITypeInfo->Release();
	}

	pITypeLib->ReleaseTLibAttr(pTLibAttr);
}
//------------------------------------------------------------------------------
void	print2_ITypeLib(ITypeLib* pITypeLib)
{
	int typeinfocount = pITypeLib->GetTypeInfoCount();
	// ֐̐
	for (int i = 0; i < typeinfocount; i++) {
		printf("-----------------------------------------------");
		ITypeInfo* pITypeInfo = NULL;
		HRESULT hr = pITypeLib->GetTypeInfo(i, &pITypeInfo);
		print2_Documentaion(pITypeInfo, MEMBERID_NIL);	printf("\n");
		print2_ITypeInfo(pITypeInfo);
		pITypeInfo->Release();
	}
}


#if 0
struct __declspec(uuid("00020402-0000-0000-c000-000000000046")) ITypeLib;
    interface ITypeLib : public IUnknown
    {
    public:
        virtual /* [local] */ UINT STDMETHODCALLTYPE GetTypeInfoCount( void) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE GetTypeInfo( 
            /* [in] */ UINT index,
            /* [out] */ ITypeInfo __RPC_FAR *__RPC_FAR *ppTInfo) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE GetTypeInfoType( 
            /* [in] */ UINT index,
            /* [out] */ TYPEKIND __RPC_FAR *pTKind) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE GetTypeInfoOfGuid( 
            /* [in] */ REFGUID guid,
            /* [out] */ ITypeInfo __RPC_FAR *__RPC_FAR *ppTinfo) = 0;
        
        virtual /* [local] */ HRESULT STDMETHODCALLTYPE GetLibAttr( 
            /* [out] */ TLIBATTR __RPC_FAR *__RPC_FAR *ppTLibAttr) = 0;
        
        virtual HRESULT STDMETHODCALLTYPE GetTypeComp( 
            /* [out] */ ITypeComp __RPC_FAR *__RPC_FAR *ppTComp) = 0;
        
        virtual /* [local] */ HRESULT STDMETHODCALLTYPE GetDocumentation( 
            /* [in] */ INT index,
            /* [out] */ BSTR __RPC_FAR *pBstrName,
            /* [out] */ BSTR __RPC_FAR *pBstrDocString,
            /* [out] */ DWORD __RPC_FAR *pdwHelpContext,
            /* [out] */ BSTR __RPC_FAR *pBstrHelpFile) = 0;
        
        virtual /* [local] */ HRESULT STDMETHODCALLTYPE IsName( 
            /* [out][in] */ LPOLESTR szNameBuf,
            /* [in] */ ULONG lHashVal,
            /* [out] */ BOOL __RPC_FAR *pfName) = 0;
        
        virtual /* [local] */ HRESULT STDMETHODCALLTYPE FindName( 
            /* [out][in] */ LPOLESTR szNameBuf,
            /* [in] */ ULONG lHashVal,
            /* [length_is][size_is][out] */ ITypeInfo __RPC_FAR *__RPC_FAR *ppTInfo,
            /* [length_is][size_is][out] */ MEMBERID __RPC_FAR *rgMemId,
            /* [out][in] */ USHORT __RPC_FAR *pcFound) = 0;
        
        virtual /* [local] */ void STDMETHODCALLTYPE ReleaseTLibAttr( 
            /* [in] */ TLIBATTR __RPC_FAR *pTLibAttr) = 0;
        
    };
    
#endif
/*
	// ITypeLibC^[tF[X擾
//	ITypeLib* ptlib = 0;
//	unsigned int index = 0;
//	HRESULT hr = pTypeInfo ->GetContainingTypeLib(&ptlib, &index);
//	printf("TypeLib index=%d\n", index);
//	if (SUCCEEDED(hr)) {
//	}

*/